SystemOrganization addCategory: #'Seaside-Core-Canvas'!
SystemOrganization addCategory: #'Seaside-Core-Canvas-Tags'!
SystemOrganization addCategory: #'Seaside-Core-Component'!
SystemOrganization addCategory: #'Seaside-Core-Components-Decorations'!
SystemOrganization addCategory: #'Seaside-Core-Components-Dialogs'!
SystemOrganization addCategory: #'Seaside-Core-Components-Frames'!
SystemOrganization addCategory: #'Seaside-Core-Components-Widgets'!
SystemOrganization addCategory: #'Seaside-Core-Configuration'!
SystemOrganization addCategory: #'Seaside-Core-Continuations'!
SystemOrganization addCategory: #'Seaside-Core-Document'!
SystemOrganization addCategory: #'Seaside-Core-Document-Elements'!
SystemOrganization addCategory: #'Seaside-Core-HTTP'!
SystemOrganization addCategory: #'Seaside-Core-Libraries'!
SystemOrganization addCategory: #'Seaside-Core-Platform'!
SystemOrganization addCategory: #'Seaside-Core-Callbacks'!
SystemOrganization addCategory: #'Seaside-Core-RenderLoop'!
SystemOrganization addCategory: #'Seaside-Core-RequestHandler'!
SystemOrganization addCategory: #'Seaside-Core-Session'!
SystemOrganization addCategory: #'Seaside-Core-Exceptions'!
SystemOrganization addCategory: #'Seaside-Core-Utilities'!

Notification subclass: #WADeprecatedApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WADeprecatedApi commentStamp: 'pmm 4/17/2007 00:16' prior: 0!
WADeprecatedApi is a notification that gets signaled if someone used a deprecated Seaside method.

see #deprecatedApi!

Notification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WADynamicVariable commentStamp: 'pmm 4/17/2007 00:14' prior: 0!
A WADynamicVariable is a variable that is visible only in the stackframes outgoing from this one.

Example:

WADynamicVariable
	use: 'Seaside'
	during: [ self compilcatedCalculation ]
	
Whenever
WADynamicVariable value
gets evaluated somewhere inside [ self compilcatedCalculation ] or a method invoked directly or indirectly by it, its value will be 'Seaside'. If no #use:during: handler is around the current stack frame, then the value will be the return value of #defaultValue.

Do not use WADynamicVariable directly, instead create a subclass for each variable you want to use.!

WADynamicVariable subclass: #WACurrentSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WACurrentSession commentStamp: 'pmm 4/17/2007 00:15' prior: 0!
A WACurrentSession is the dynamic variable for the current Seaside session. See superclass comment for what a dynamic variable is.!

!WADynamicVariable class methodsFor: 'defaults' stamp: 'avi 3/29/2004 14:12'!
defaultValue
	^ nil! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'lr 4/18/2007 00:25'!
use: anObject during: aBlock
	^ aBlock on: self do: [ :notification | notification resume: anObject ]! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'avi 4/27/2004 14:25'!
value
	^ self raiseSignal! !

!WADynamicVariable methodsFor: 'defaults' stamp: 'dkh 07/06/2007 23:13'!
defaultAction
	^self class defaultValue! !

Notification subclass: #WAPageExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

Notification subclass: #WAValidationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAValidationNotification commentStamp: 'cds 7/25/2005 10:17' prior: 0!
I am signaled to indicate that a validation has occurred.  See: Object>>validationError:, WAComponent>>validateWith: and WAValidationDecoration.!

!Integer methodsFor: '*Seaside-Core' stamp: 'pmm 11/20/2007 15:38'!
printStringAsCents
	^ '$', (self // 100) toString, '.', (self \\ 100) asTwoCharacterString! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'pmm 4/23/2007 20:02'!
fixCallbackTemps
	"for polymorphism with BlockContext >> #fixCallbackTemps"! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'lr 8/4/2006 09:18'!
renderOn: html
	self value: html! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
valueWithPossibleArgument: anArg

     "Evaluate the block represented by the receiver.
     If the block requires one argument, use anArg, if it requires more than one,
     fill up the rest with nils."

	self numArgs = 0
		ifTrue: [^self value].
	self numArgs = 1
		ifTrue: [^self value: anArg].
	self numArgs  > 1 ifTrue: [
		^self valueWithArguments: (Array with: anArg), (Array new: self numArgs  - 1)]! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words := WriteStream on: String new.
	read := ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord := WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x := read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord := currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord := capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
asMIMEDocument
	^self asMIMEDocumentType: 'text/plain'! !

!String methodsFor: '*Seaside-Core' stamp: 'pmm 11/21/2007 20:56'!
asMIMEDocumentType: mimeType
	^SeasidePlatformSupport mimeDocumentClass
		contentType: mimeType toString
		content: self! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 3/26/2007 20:22'!
encodeOn: aDocument
	aDocument htmlEncoder nextPutAll: self! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 6/13/2006 16:06'!
renderOn: aRenderer
	aRenderer text: self! !

!String methodsFor: '*Seaside-Core' stamp: 'pmm 11/21/2007 20:19'!
toMimeType
	^ WAMimeType fromString: self! !

!Collection methodsFor: '*Seaside-Core' stamp: 'lr 5/9/2007 08:47'!
inspectorFields
	| i |
	i := 0.
	^ self asArray collect: [ :each | i := i + 1. i -> each ]! !

!Collection methodsFor: '*Seaside-Core' stamp: 'lr 3/8/2006 08:43'!
renderOn: html
	self do: [ :each | each renderOn: html ]! !

IdentityDictionary subclass: #WASnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WASnapshot methodsFor: 'registry' stamp: 'lr 4/20/2007 20:39'!
register: anObject
	anObject ifNotNil: [ self at: anObject put: anObject snapshotCopy ]! !

!WASnapshot methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
restore
	"Restore all the backtracked states."

	self keysAndValuesDo: [ :key :value | key restoreFromSnapshot: value ]! !

!WASnapshot methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
snapshot
	"Snapshot all the states that have been registered for backtracking overriding existing snapshots."

	self associationsDo: [ :assoc | assoc value: assoc key snapshotCopy ]! !

!BlockContext methodsFor: '*Seaside-Core' stamp: 'ab 2/11/2003 20:09'!
handleRequest: aRequest
	^ self value: aRequest! !

!BlockContext methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
renderOn: aRenderer
	self numArgs = 0
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'mb 6/2/2006 10:46'!
asMIMEDocument
	^self asMIMEDocumentType: 'application/octet-stream'! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'pmm 11/21/2007 20:56'!
asMIMEDocumentType: mimeType
	^SeasidePlatformSupport mimeDocumentClass contentType: mimeType toString content: self! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'mb 9/22/2006 12:17'!
renderOn: aRenderer
	aRenderer text: self! !

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: 'Generator GeneratorMutex'
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAExternalID commentStamp: 'pmm 4/22/2007 12:55' prior: 0!
I am a session or conticuation key.!

!WAExternalID class methodsFor: 'defaults' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'lr 10/28/2007 14:42'!
fromString: aString
	| id |
	id := self new: aString size.
	aString withIndexDo: [ :each :index |
		id at: index put: each asInteger].
	^ id! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'pmm 11/9/2007 20:15'!
initializeClass
	"WAExternalID initializeClass"

	GeneratorMutex := SeasidePlatformSupport semaphoreClass forMutualExclusion.
	SeasidePlatformSupport addToStartUpList: self.
	self startUp! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'instance creation' stamp: 'pmm 11/2/2005 23:19'!
new: aNumber
	^ (self basicNew: aNumber) initialize! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'lr 10/28/2007 14:42'!
startUp
	Generator := SeasidePlatformSupport randomClass new! !

!WAExternalID methodsFor: 'private' stamp: 'pmm 7/5/2007 19:22'!
initialize
	GeneratorMutex critical: [
		1 to: self size do: [ :index |
			self at: index put: ((($a to: $z), ($A to: $Z)) atRandom: Generator) asInteger ] ]! !

!WAExternalID methodsFor: 'private' stamp: 'ab 5/29/2003 00:00'!
printOn: stream
	self do: [:i | stream nextPut: (Character value: i)]! !

Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Continuations'!

Continuation subclass: #AnswerContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Continuations'!

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!Continuation methodsFor: 'private' stamp: 'pmm 12/4/2007 20:30'!
initializeFromContext: aContext
	| valueStream context |
	valueStream := WriteStream on: (Array new: 20).
	context := aContext.
	[ context notNil ] whileTrue: [
		context serialiseOn: valueStream.
		context := context sender ].
	values := valueStream contents! !

!Continuation methodsFor: 'accessing' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
restoreValues
	| valueStream context |
	valueStream := values readStream.
	[valueStream atEnd] whileFalse:
		[context := valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]]! !

!Continuation methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
terminate: aContext
	| context |
	context := aContext.
	[context notNil] whileTrue: [context := context swapSender: nil]! !

!Continuation methodsFor: 'evaluating' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'evaluating' stamp: 'lr 10/28/2007 14:42'!
value: anObject
	"Invoke the continuation and answer anObject as return value."

	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^ anObject! !

!Continuation methodsFor: 'evaluating' stamp: 'lr 10/28/2007 14:42'!
valueWithArguments: anArray
	anArray size = 1
		ifFalse: [ ^ self error: 'continuations can only be resumed with one argument' ].
	self value: anArray first! !

Continuation subclass: #EscapeContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Continuations'!

Continuation subclass: #ResponseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Continuations'!

!Object methodsFor: '*Seaside-Core' stamp: 'pmm 11/20/2007 15:39'!
deprecatedApi
	self deprecatedApi: thisContext sender toString! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 6/5/2007 21:35'!
deprecatedApi: aString
	WADeprecatedApi raiseSignal: aString! !

!Object methodsFor: '*Seaside-Core' stamp: 'pmm 11/20/2007 15:39'!
encodeOn: aDocument
	aDocument print: self toString! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 5/9/2007 08:47'!
inspectorFields
	| members |
	members := Array new writeStream.
	self class allInstVarNames withIndexDo: [ :each :index |
		members nextPut: each -> (self instVarAt: index) ].
	self class isVariable ifTrue: [
		1 to: self size do: [ :index |
			members nextPut: index -> (self at: index) ] ].
	^ members contents! !

!Object methodsFor: '*Seaside-Core' stamp: 'avi 3/14/2005 15:19'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!Object methodsFor: '*Seaside-Core' stamp: 'pmm 4/7/2007 17:14'!
renderOn: aRenderer
	"Override this method to customize how objects (not components) are rendered when passed as an argument to #render:. The default is the return value of #displayString.
	Just remember that you can not use #callback:, #on:of:, or #call:"

	aRenderer text: self! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 3/19/2007 23:13'!
restoreFromSnapshot: anObject
	self copyFrom: anObject! !

!Object methodsFor: '*Seaside-Core' stamp: 'avi 9/1/2004 21:20'!
snapshotCopy
	^ self shallowCopy! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
validationError: message
	^WAValidationNotification raiseSignal: message! !

Object subclass: #SeasidePlatformSupport
	instanceVariableNames: ''
	classVariableNames: 'Implementation'
	poolDictionaries: ''
	category: 'Seaside-Core-Platform'!

!SeasidePlatformSupport class methodsFor: 'startup' stamp: 'pmm 11/6/2007 21:06'!
addToStartUpList: anObject
	Implementation addToStartUpList: anObject! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:04'!
asMethodReturningByteArray: aByteArrayOrString named: aSymbol
	"Generates the source of a method named aSymbol that returns aByteArrayOrString as a ByteArray"
	^Implementation asMethodReturningByteArray: aByteArrayOrString named: aSymbol! !

!SeasidePlatformSupport class methodsFor: 'encoding' stamp: 'pmm 11/6/2007 21:05'!
base64Decode: aString
	^ Implementation base64Decode: aString! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:02'!
compile: aString into: aClass classified: aSymbol
	Implementation compile: aString into: aClass classified: aSymbol! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:04'!
contentsOfFile: aString binary: aBoolean
	^Implementation contentsOfFile: aString binary: aBoolean! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:04'!
convertToSmalltalkNewlines: aString
	^Implementation convertToSmalltalkNewlines: aString! !

!SeasidePlatformSupport class methodsFor: 'dispatchers' stamp: 'pmm 11/6/2007 21:06'!
defaultDispatcherName
	^Implementation defaultDispatcherName! !

!SeasidePlatformSupport class methodsFor: 'email' stamp: 'pmm 11/6/2007 21:07'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	Implementation deliverMailFrom: fromAddress to: recipientList text: messageText! !

!SeasidePlatformSupport class methodsFor: 'transactions' stamp: 'pmm 11/6/2007 21:07'!
doTransaction: aBlock
	"for Gemstone/S compatibility
	http://gemstonesoup.wordpress.com/2007/05/10/porting-application-specific-seaside-threads-to-gemstone/
	use when modifying an object from an outside thread"
	^Implementation doTransaction: aBlock! !

!SeasidePlatformSupport class methodsFor: 'vm' stamp: 'pmm 11/6/2007 21:08'!
ensureAuthorInitials: aBlock
	"Makes sure the author initials for the image are set"
	Implementation ensureAuthorInitials: aBlock! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:03'!
ensureExistenceOfFolder: aString
	"creates a folder named aString in the image directory"
	Implementation ensureExistenceOfFolder: aString! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:03'!
filesIn: aPathString
	"Return a collection of absolute paths for all the files (no directories) in the directory given by aPathString
	must not include file names that start with ."
	^Implementation filesIn: aPathString! !

!SeasidePlatformSupport class methodsFor: 'testing' stamp: 'pmm 11/6/2007 21:18'!
isProxy: anObject
	^Implementation isProxy: anObject! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:03'!
localNameOf: aFilename
	^Implementation localNameOf: aFilename! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 11/6/2007 21:15'!
mimeDocumentClass
	^Implementation mimeDocumentClass! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 11/6/2007 21:15'!
mimeDocumentOfType: type from: aFilename
	^Implementation mimeDocumentOfType: type from: aFilename! !

!SeasidePlatformSupport class methodsFor: 'exceptions' stamp: 'pmm 11/6/2007 21:18'!
openDebuggerOn: anError
	Implementation openDebuggerOn: anError! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 11/6/2007 21:15'!
randomClass
	"used by Gemstone/S traditional Randoms which cannot be persisted"
	^Implementation randomClass! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 11/6/2007 21:15'!
readWriteStream
	^Implementation readWriteStream! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 11/6/2007 21:17'!
reducedConflictDictionary
	"used by Gemstone/S reduced conflict classes that can be used to avoid transaction conflicts"
	^Implementation reducedConflictDictionary! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:05'!
removeSelector: aSymbol from: aClass
	Implementation removeSelector: aSymbol from: aClass! !

!SeasidePlatformSupport class methodsFor: 'requests' stamp: 'pmm 11/6/2007 21:18'!
request: aString
	^Implementation request: aString! !

!SeasidePlatformSupport class methodsFor: 'requests' stamp: 'pmm 11/6/2007 21:19'!
request: aRequestString initialAnswer: anIntialAnserString
	^Implementation request: aRequestString initialAnswer: anIntialAnserString! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 11/6/2007 21:17'!
semaphoreClass
	"used by Gemstone/S traditional Semaphores which cannot be persisted"
	^Implementation semaphoreClass! !

!SeasidePlatformSupport class methodsFor: 'accessing' stamp: 'pmm 11/6/2007 21:21'!
versionString
	^Implementation versionString! !

!SeasidePlatformSupport class methodsFor: 'vm' stamp: 'pmm 11/6/2007 21:18'!
vmStatisticsReportString
	^Implementation vmStatisticsReportString! !

!SeasidePlatformSupport class methodsFor: 'exceptions' stamp: 'pmm 11/6/2007 21:18'!
walkbackStringsFor: anError
	^Implementation walkbackStringsFor: anError! !

!SeasidePlatformSupport class methodsFor: 'factory' stamp: 'pmm 11/6/2007 21:17'!
weakDictionaryOfSize: aNumber
	^Implementation weakDictionaryOfSize: aNumber! !

!SeasidePlatformSupport class methodsFor: 'file-library' stamp: 'pmm 11/6/2007 21:05'!
write: aStringOrByteArray toFile: aFileNameString inFolder: aFolderString
	"writes aStringOrByteArray to a file named aFilenameString in the folder aFolderString"
	Implementation write: aStringOrByteArray toFile: aFileNameString inFolder: aFolderString! !

Object subclass: #WABrush
	instanceVariableNames: 'canvas parent closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WABrush commentStamp: 'lr 3/27/2007 11:18' prior: 0!
I represent a brush to be used on a *WACanvas*.

Instance Variables
	canvas:		The canvas instance I am used with.
	parent:		The parent brush I am used within.
	closed:		Wether I have been closed/flushed yet.!

!WABrush class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 22:31'!
new
	^ self basicNew initialize! !

!WABrush methodsFor: 'public' stamp: 'lr 4/9/2007 16:32'!
close
	"Close and flush the receiver onto the canvas and its associated document."

	closed ifFalse: [ self with: nil ]! !

!WABrush methodsFor: 'initialization' stamp: 'lr 3/27/2007 11:09'!
initialize
	closed := false! !

!WABrush methodsFor: 'private' stamp: 'lr 3/27/2007 17:38'!
labelForSelector: aSymbol of: anObject
	^ anObject labelForSelector: aSymbol! !

!WABrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:27'!
parent
	^ parent! !

!WABrush methodsFor: 'initialization' stamp: 'avi 6/13/2004 00:27'!
setParent: aBrush canvas: aCanvas
	parent := aBrush.
	canvas := aCanvas! !

!WABrush methodsFor: 'public' stamp: 'lr 3/27/2007 11:10'!
with: aBlock
	canvas nest: aBlock.
	closed := true! !

WABrush subclass: #WACompound
	instanceVariableNames: 'callbackBlock value id properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WACompound commentStamp: 'pmm 9/22/2007 22:22' prior: 0!
I am the superclass for stuff that is not html element but you still want to access via the canvas API.!

!WACompound methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
callback: aBlock
	callbackBlock := aBlock! !

!WACompound methodsFor: 'public' stamp: 'lr 3/27/2007 18:00'!
close
	closed ifTrue: [ ^ self ].
	closed := true.
	self with: nil! !

!WACompound methodsFor: 'testing' stamp: 'lr 3/27/2007 17:25'!
hasCallback
	^ callbackBlock notNil! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:55'!
id
	^ id! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:55'!
id: aString
	id := aString! !

!WACompound methodsFor: 'initialization' stamp: 'lr 3/27/2007 17:51'!
initialize
	super initialize.
	"do not remove properties, it is used by SeasideAsync"
	properties := Dictionary new! !

!WACompound methodsFor: 'callbacks' stamp: 'lr 3/27/2007 17:24'!
on: selector of: anObject
	self value: (anObject perform: selector).
	self callback: [ :date | anObject perform: selector asMutator with: date ]! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:25'!
value
	^ value! !

!WACompound methodsFor: 'accessing' stamp: 'mb 1/30/2006 18:40'!
value: aValue
	value := aValue! !

WACompound subclass: #WADateInput
	instanceVariableNames: 'options month day year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WADateInput commentStamp: 'pmm 4/30/2007 23:41' prior: 0!
I am a composition of three input fields that allow the user to select year, month and day. #options: can be used to toggle them individually.
The argument for my callback blocks is an instance of Date.

See WADateTimeTest >> #renderDateTimeOn:!

!WADateInput methodsFor: 'private rendering' stamp: 'mb 7/6/2007 18:51'!
addCallback
	self hasCallback
		ifFalse:
			[canvas flush.
			^ self].
	canvas hiddenInput
		callback: [callbackBlock value: self setValueWithNewDate];
		 with: nil! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addDayCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #day of: self! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addMonthCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #month of: self! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:19'!
addYearCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #year of: self! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
day
	^day! !

!WADateInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:31'!
day: anIntegerOrString
	day := [ anIntegerOrString asInteger ] on: Error do: [ :e | 1 ]! !

!WADateInput methodsFor: 'private' stamp: 'mb 11/3/2006 09:57'!
defaultOptions
	^#(month day year)! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
month
	^month! !

!WADateInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:31'!
month: anIntegerOrString
	month := [ anIntegerOrString asInteger ] on: Error do: [ :error | 1 ]! !

!WADateInput methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
options
	^options ifNil: [ self defaultOptions ]! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:58'!
options: anArray
	"Valid values in the array : #year #month #day
	Can be used to control what is shown and in what order
	Default #(month day year)"
	options := anArray! !

!WADateInput methodsFor: 'private rendering' stamp: 'mb 7/10/2007 09:42'!
renderDay
	| brush |
	brush := canvas textInput
				id: (self id isNil
						ifFalse: [self id , '-day']);
				 value: day;
				 yourself.
	self addDayCallbackToBrush: brush.
	brush attributeAt: 'size' put: 2;
		 attributeAt: 'maxlength' put: 2! !

!WADateInput methodsFor: 'private rendering' stamp: 'lr 10/28/2007 14:42'!
renderMonth
	| brush |
	brush := canvas select
		id: self id;
		list: (1 to: 12);
		selected: month;
		yourself.
	self addMonthCallbackToBrush: brush.
	brush
		labels: [:ea | Date nameOfMonth: ea]! !

!WADateInput methodsFor: 'private rendering' stamp: 'lr 10/28/2007 14:42'!
renderYear
	| brush |
	brush := (canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-year']);
		value: year;
		yourself.
	self addYearCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 4;
		attributeAt: 'maxlength' put: 4! !

!WADateInput methodsFor: 'private callbacks' stamp: 'pmm 9/11/2007 06:44'!
setValueWithNewDate
	^value := Date
		newDay: ((day min: (Month daysInMonth: month forYear: year)) max: 1)
		monthNumber: month
		year: year! !

!WADateInput methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
with: aBlock
	value isNil ifTrue: [value := Date today].
	day := value dayOfMonth.
	month := value monthIndex.
	year := value year.
	self options
		do: [:each | self perform: ('render' , each asLowercase capitalized) asSymbol ]
		separatedBy: [ canvas space ].
	self addCallback! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
year
	^year! !

!WADateInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:30'!
year: anIntegerOrString
	year := [ anIntegerOrString asInteger ] on: Error do: [ :e | 1900 ]! !

WACompound subclass: #WATimeInput
	instanceVariableNames: 'withSeconds hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATimeInput commentStamp: 'pmm 4/30/2007 23:41' prior: 0!
I am a composition of three input fields that allows the user to select hour, minute and optionally second.
#withSeconds and #withoutSeconds can be used to toggle seconds.

The argument for my callback blocks is an instance of Time.

See WADateTimeTest >> #renderDateTimeOn:!

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 7/6/2007 18:52'!
addCallback
	self hasCallback
		ifFalse:
			[canvas flush.
			^ self].
	canvas hiddenInput
		callback: [callbackBlock value: self setValueWithNewTime];
		 with: nil! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addHoursCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #hours of: self! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addMinutesCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #minutes of: self! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addSecondsCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #seconds of: self! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
hours
	^hours! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:29'!
hours: anIntegerOrString
	hours := [ anIntegerOrString asInteger ] on: Error do: [ :e | 0 ]! !

!WATimeInput methodsFor: 'initialize-release' stamp: 'pmm 9/12/2006 19:18'!
initialize
	super initialize.
	self withoutSeconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
minutes
	^minutes! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:29'!
minutes: anIntegerOrString
	minutes := [ anIntegerOrString asInteger ] on: Error do: [ :error | 0]! !

!WATimeInput methodsFor: 'private rendering' stamp: 'lr 3/27/2007 17:28'!
renderHours
	| brush |
	brush := canvas textInput
		id: self id;
		value: hours asTwoCharacterString;
		yourself.
	self addHoursCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 7/10/2007 09:42'!
renderMinutes
	| brush |
	brush := canvas textInput
				id: (self id isNil
						ifFalse: [self id , '-mins']);
				 value: minutes asTwoCharacterString;
				 yourself.
	self addMinutesCallbackToBrush: brush.
	brush attributeAt: 'size' put: 2;
		 attributeAt: 'maxlength' put: 2! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 7/10/2007 09:42'!
renderSeconds
	| brush |
	brush := canvas textInput
				id: (self id isNil
						ifFalse: [self id , '-secs']);
				 value: seconds asTwoCharacterString;
				 yourself.
	self addSecondsCallbackToBrush: brush.
	brush attributeAt: 'size' put: 2;
		 attributeAt: 'maxlength' put: 2! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
seconds
	^seconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
seconds: anIntegerOrString
	seconds := [anIntegerOrString asNumber] on: Error do: [:e | 0]! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
setValueWithNewTime
	^value := Time
				hour: hours
				minute: (minutes min: 59)
				second: (seconds min: 59)! !

!WATimeInput methodsFor: 'public api' stamp: 'lr 10/28/2007 14:42'!
with: aBlock
	value isNil ifTrue: [value := Time now].
	hours := value hour.
	minutes := value minutes.
	seconds := value seconds.
	self renderHours.
	canvas space; text: ':'; space.
	self renderMinutes.
	withSeconds ifTrue:
		[canvas space; text: ':'; space.
		self renderSeconds]
	ifFalse:
		[seconds := 0].
	self addCallback! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:55'!
withSeconds
	withSeconds := true! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:56'!
withoutSeconds
	withSeconds := false! !

WABrush subclass: #WATagBrush
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WATagBrush commentStamp: 'pmm 4/15/2007 22:14' prior: 0!
This is the superclass for all XML element classes. Its main addtions are
- element name (#tag)
- attributes (instance of WAHtmlAttributes)
- common events (onXXX), this is a hack and would better be solved with traits!

WATagBrush subclass: #WAAnchorTag
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAAnchorTag commentStamp: 'lr 7/4/2007 20:42' prior: 0!
I'm the class responsible for adding anchors (links) to your webpage. There are multiple ways of using me.

1. In the following case, the method #doSomethingOnClick will be sent to self when the user click on the anchor 'Click here to do something':

	html anchor
		callback: [ self doSomethingOnClick ];
		with: 'Click here to do something'.
		
The following code is a shortcut to create an anchor. The executed action is #doSomethingOnClick and the text is 'Do Something On Click':

	html anchor
		on: #doSomethingOnClick of: self

2. In the following case, a link to an external resource will be generated:

	html anchor
		url: 'http://www.seaside.st';
		with: 'Visit the Seaside'!

!WAAnchorTag methodsFor: 'callbacks' stamp: 'lr 8/17/2007 15:07'!
callback: aBlock
	self url addParameter: (canvas callbacks registerActionCallback: aBlock)! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:42'!
canHaveShortcut
	^ true! !

!WAAnchorTag methodsFor: 'documents' stamp: 'lr 8/17/2007 15:08'!
document: aDocument
	self document: aDocument mimeType: nil! !

!WAAnchorTag methodsFor: 'documents' stamp: 'lr 8/17/2007 15:08'!
document: aDocument mimeType: mimeType
	self document: aDocument mimeType: mimeType fileName: nil! !

!WAAnchorTag methodsFor: 'documents' stamp: 'lr 8/17/2007 15:09'!
document: aDocument mimeType: mimeType fileName: fileName
	self url: (canvas context urlForDocument: aDocument mimeType: mimeType fileName: fileName)! !

!WAAnchorTag methodsFor: 'url' stamp: 'lr 8/17/2007 15:16'!
extraParameters: aCollection
	self url addParameter: aCollection! !

!WAAnchorTag methodsFor: 'url' stamp: 'pmm 10/7/2007 14:32'!
extraPath: aString
	self url addToPath: aString! !

!WAAnchorTag methodsFor: 'url' stamp: 'lr 8/17/2007 15:16'!
fragment: aString
	self url fragment: aString! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:43'!
ignoreURL
	"does nothing when clicked"
	^ self onClick: 'return false'! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:24'!
mailto: aString
	self deprecatedApi.
	self url: 'mailto:' , aString; with: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 8/17/2007 15:04'!
name: aString
	self attributes at: 'name' put: aString! !

!WAAnchorTag methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
navigation
	"Makes the receiving anchor a purely navigational link, this is it won't redirect after processing the callbacks but directly process with the render phase. Don't use this feature if you change your model in the callback'."

	self url addParameter: '_n'! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:19'!
newTarget
	self deprecatedApi.
	self target: '_new'! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'lr 8/17/2007 15:07'!
on: aSymbol of: anObject
	self callback: [ anObject perform: aSymbol ].
	self with: (self labelForSelector: aSymbol of: anObject)! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:19'!
rel: aString
	self deprecatedApi.
	self relationship: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
relationship: aString
	self attributes at: 'rel' put: aString! !

!WAAnchorTag methodsFor: 'url' stamp: 'lr 8/17/2007 15:25'!
resourceUrl: aString
	self url: (canvas context absoluteUrlForResource: aString)! !

!WAAnchorTag methodsFor: 'conveniance' stamp: 'lr 10/28/2007 14:42'!
submitFormNamed: aString
	"Submits a form with the id aString."

	self onClick: 'document.forms[' , aString printString , '].submit()'! !

!WAAnchorTag methodsFor: 'private' stamp: 'lr 8/17/2007 15:15'!
tag
	^ 'a'! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:19'!
target: aString
	self deprecatedApi.
	self attributeAt: 'target' put: aString! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:19'!
text: aString
	self deprecatedApi.
	self with: aString! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'lr 8/17/2007 15:17'!
url
	^ url ifNil: [ url := canvas context actionUrl copy ]! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'lr 8/17/2007 15:06'!
url: aString
	url := aString! !

!WAAnchorTag methodsFor: 'public' stamp: 'lr 8/17/2007 15:11'!
with: aBlock
	url isNil
		ifFalse: [ self attributes at: 'href' put: url ]
		ifTrue: [
			((self attributes includesKey: 'href') or: [ self attributes includesKey: 'name' ])
				ifFalse: [ self attributes at: 'href' put: 'javascript:void(0)' ] ].
	super with: aBlock! !

WAAnchorTag subclass: #WAImageMapTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAImageMapTag commentStamp: 'lr 8/17/2007 18:56' prior: 0!
A WAImageMapTag is supposed to be used like this:

	html map
		callback: [ :point | self click: point ];
		with: [ html image url: 'foo.gif' ]
			
An example can be found in WAScreenshot.

Technincal:
http://www.w3.org/TR/html4/struct/objects.html#include-maps

The location clicked is passed to the server as follows. The user agent derives a new URI from the URI specified by the href attribute of the A element, by appending `?' followed by the x and y coordinates, separated by a comma. The link is then followed using the new URI. For instance, in the given example, if the user clicks at the location x=10, y=27 then the derived URI is "http://www.acme.com/cgi-bin/competition?10,27".
!

!WAImageMapTag methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
callback: aBlock
	"The parameter for the image-map callback must be the last one, as the web-browser will use the same name and replace it with the coordinates."

	aBlock fixCallbackTemps.
	self url
		addParameter: (canvas callbacks registerCallback: [ :value |
			aBlock value: (self parseImageMap: value) ])
		value: ''! !

!WAImageMapTag methodsFor: 'private' stamp: 'pmm 12/9/2007 12:30'!
parseImageMap: aString
	| stream x y |
	('?*,*' match: aString) ifFalse: [ ^ nil ].
	stream := aString readStream.
	stream upTo: $?.
	x := stream upTo: $,.
	y := stream upToEnd.
	^ x asInteger @ y asInteger! !

WAAnchorTag subclass: #WAPopupAnchorTag
	instanceVariableNames: 'name features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAPopupAnchorTag commentStamp: 'lr 7/4/2007 20:46' prior: 0!
I am used to create a link that opens in a new window. A name can be specified using #name: and many features can be configured. Note, that not all features are supported on all web browser platforms. If Javascript is disabled the link will behave like any other anchor.

Most of the time a popup-anchor is created like this:

	html popupAnchor
		callback: [ WARenderLoop new call: WACounter new ];
		with: 'Open the counter within a new window'

This code creates a new render-loop and displays a new instance of WACounter within the new browser window.		
!

!WAPopupAnchorTag methodsFor: 'deprecated' stamp: 'lr 7/4/2007 20:34'!
beDependent
	self deprecatedApi.
	self dependent: true! !

!WAPopupAnchorTag methodsFor: 'deprecated' stamp: 'lr 7/4/2007 20:34'!
beResizable
	self deprecatedApi.
	self resizable: true! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:32'!
dependent: aBoolean
	"Specifies whether the new window is closed as well when the parent window gets closed."

	features at: #dependent put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
extent: aPoint
	"Specifies the width and height of the new window."

	self width: aPoint x; height: aPoint y! !

!WAPopupAnchorTag methodsFor: 'private' stamp: 'pmm 11/20/2007 15:47'!
featureString
	^ String streamContents: [ :stream |
		features associations
			do: [ :assoc |
				stream nextPutAll: assoc key; nextPut: $=.
				stream nextPutAll: (assoc value == true
					ifTrue: [ 'yes' ]
					ifFalse: [
						assoc value == false
							ifTrue: [ 'no' ]
							ifFalse: [ assoc value toString ] ]) ]
			separatedBy: [ stream nextPut: $, ] ]! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
height: anInteger
	"Specifies the height of the new window."

	features at: #height put: anInteger! !

!WAPopupAnchorTag methodsFor: 'initialization' stamp: 'lr 7/4/2007 20:16'!
initialize
	super initialize.
	name := '_blank'.
	features := Dictionary new! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
left: anInteger
	"Specifies the x coordinate of the top left corner of the new window. "

	features at: #left put: anInteger! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
location: aBoolean
	"Specifies whether to display the address line in the new window."

	features at: #location put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
menubar: aBoolean
	"Specifies whether to display the browser menu bar."

	features at: #menubar put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'lr 7/4/2007 20:22'!
name
	^ name! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'lr 7/4/2007 19:56'!
name: aString
	"String specifying the name of the new window. If a window with this name already exists, then the new content will be displayed in that existing window, rather than creating a new one."

	name := aString! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
position: aPoint
	"Specifies the x and y coordinates of the top left corner of the new window."

	self left: aPoint x; top: aPoint y! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
resizable: aBoolean
	"Specifies whether the new window is resizable."

	features at: #resizable put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
scrollbars: aBoolean
	"Specifies whether the new window should have scrollbars."

	features at: #scrollbars put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'deprecated' stamp: 'lr 7/4/2007 20:34'!
showScrollbars
	self deprecatedApi.
	self scrollbars: true! !

!WAPopupAnchorTag methodsFor: 'deprecated' stamp: 'lr 7/4/2007 20:35'!
showToolbar
	self deprecatedApi.
	self toolbar: true! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
status: aBoolean
	"Specifies whether to display the browser status bar."

	features at: #status put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
toolbar: aBoolean
	"Specifies whether to display the toolbar in the new window."

	features at: #toolbar put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
top: anInteger
	"Specifies the y coordinate of the top left corner of the new window. "

	features at: #top put: anInteger! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
width: anInteger
	"Specifies the width of the new window."

	features at: #width put: anInteger! !

!WAPopupAnchorTag methodsFor: 'public' stamp: 'lr 7/4/2007 20:33'!
with: aBlock
	self onClick: 'window.open(this.href,' , self name printString , ',' , self featureString printString , ');return false'.
	super with: aBlock! !

WATagBrush subclass: #WABreakTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WABreakTag commentStamp: 'pmm 9/22/2007 22:22' prior: 0!
The BR element forcibly breaks (ends) the current line of text. Authors are advised to use style sheets to control text flow around floating images and other objects.

Prohibiting a line break 

Sometimes authors may want to prevent a line break from occurring between two words. The &nbsp; entity (&#160; or &#xA0;) acts as a space where user agents should not cause a line break.!

!WABreakTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:10'!
isClosed
	^ true! !

!WABreakTag methodsFor: 'accessing' stamp: 'lr 3/26/2007 21:10'!
tag
	^ 'br'! !

WATagBrush subclass: #WACollectionTag
	instanceVariableNames: 'list selected callbackBlock labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WACollectionTag commentStamp: 'pmm 4/23/2007 20:59' prior: 0!
This element allows the use to select one (in single selection mode) or multiple (in single selection mode) elements. Multiple selection can be triggered with #beMultiple, single selection can be triggered with #beSingle .Default is single selection.

The general idea is that you pass the colletion of options to #list: and use #labels: to customize their rendering. The selected option(s) can be set with: #selected:.


This whole class is kind of an akward hack, but noone needs MI anyway. You can always get a way with composition and delegation!

!WACollectionTag methodsFor: 'adding' stamp: 'lr 6/6/2007 13:22'!
add: anObject
	self list add: anObject! !

!WACollectionTag methodsFor: 'adding' stamp: 'lr 6/6/2007 13:22'!
addAll: aCollection
	self list addAll: aCollection! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
before
	super before.
	self hasList ifTrue: [
		self list do: [ :each |
			self
				renderListItem: each
				labelled: (self labelForOption: each) ] ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 6/7/2007 07:48'!
callback: aBlock
	callbackBlock := aBlock fixCallbackTemps! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 6/7/2007 07:46'!
hasCallback
	^ callbackBlock notNil! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 6/6/2007 13:30'!
hasList
	^ list notNil and: [ list notEmpty ]! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isSelected: anObject
	"Test if anObject is currently selected."

 	^ selected = anObject! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 6/6/2007 13:53'!
labelForOption: anObject
	^ labelBlock isNil
		ifTrue: [ anObject ]
		ifFalse: [ labelBlock value: anObject ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
labels: aBlock
	"Allows to customize the rendering of list items by passing a one argument block that converts each option to a string. If you need to do custom html rendering for the options use #with: or override #renderOn: in your objects."

	labelBlock := aBlock fixCallbackTemps! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 6/6/2007 13:22'!
list
	^ list ifNil: [ list := OrderedCollection new ]! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
list: aCollection
	"Append aCollection of items to display. The rendering can be customized using #labels:."

	aCollection ifNotNil: [ self addAll: aCollection ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 6/7/2007 07:48'!
on: aSelector of: anObject
	self selected: (anObject perform: aSelector).
	self callback: [ :value | anObject perform: aSelector asMutator with: value ]! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:50'!
performCallback: anObject
	self hasCallback ifTrue: [ callbackBlock value: anObject ]! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:56'!
renderListItem: anObject labelled: aString
	self subclassResponsibility! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
selected: anObject
	"Set anObject to be selected."

	selected := anObject! !

WACollectionTag subclass: #WAListTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAListTag commentStamp: 'pmm 6/30/2007 00:46' prior: 0!
Abstract base class for ordered and unordered list tags.

Ordered and unordered lists are rendered in an identical manner except that visual user agents number ordered list items. User agents may present those numbers in a variety of ways. Unordered list items are not numbered.

Both types of lists are made up of sequences of list items defined by the LI element (whose end tag may be omitted).

Lists may also be nested.!

!WAListTag methodsFor: 'private' stamp: 'lr 6/7/2007 08:01'!
renderListItem: anObject labelled: aString
	canvas listItem
		class: 'option-selected' if: (self isSelected: anObject);
		with: [
			self hasCallback
				ifFalse: [ canvas render: aString ]
				ifTrue: [
					canvas anchor
						callback: [ self performCallback: anObject ];
						with: aString ] ]! !

WAListTag subclass: #WAOrderedListTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAOrderedListTag commentStamp: 'pmm 6/30/2007 00:47' prior: 0!
See superclass comment.!

!WAOrderedListTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 17:12'!
tag
	^ 'ol'! !

WAListTag subclass: #WAUnorderedListTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAUnorderedListTag commentStamp: 'pmm 6/30/2007 00:47' prior: 0!
See superclass comment.!

!WAUnorderedListTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 17:12'!
tag
	^ 'ul'! !

WACollectionTag subclass: #WASelectTag
	instanceVariableNames: 'enabledBlock isOptional optionalLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WASelectTag commentStamp: 'pmm 4/24/2007 11:12' prior: 0!
This element allows the use to select one (in single selection mode) or multiple (in single selection mode) elements. Default is single selection. Multiple selection can be triggered with #beMultiple.

Single selection is in general a drop-down list, so make sure the list of options is not too big.
Multiple selection has in general crappy browser support and a list of checkboxes is in general the better option.

If in single selection mode and you want enable "no selection" see #beOptional.

If you absolutely need to you can render the options yourself with 'html option' inside #with:

Make sure to check the superclass for more methods.

See WAInputTest >> #renderSingleSelectionOn: and WAInputTest >> #renderMultiSelectionOn: for examples.!

WASelectTag subclass: #WAMultiSelectTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
closeTag
	super closeTag.
	self hasCallback ifFalse: [ ^ self ].
	canvas insert: [
		canvas hiddenInput callback: [
			self hasCallback
				ifTrue: [ callbackBlock value: selected ] ] ]! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 16:18'!
dispatchCallback
	^ canvas callbacks registerMultiDispatchCallback! !

!WAMultiSelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 16:14'!
isSelected: anObject
	^ selected notNil and: [ selected includes: anObject ]! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
openTag
	self hasCallback ifTrue: [
		canvas insert: [
			canvas hiddenInput
				callback: [ selected := OrderedCollection new ] ] ].
	self attributes at: 'multiple' put: true.
	super openTag! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 18:37'!
performCallback: anObject
	selected add: anObject! !

!WASelectTag methodsFor: 'deprecated' stamp: 'lr 6/7/2007 07:54'!
beMultiple
	self deprecatedApi: 'Use #multiSelect (constructure-method) instead of #beMultiple'.
	self primitiveChangeClassTo: WAMultiSelectTag new! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
beOptional
	"This adds a nil item to #list: which has the semantic of no selection. #optionalLabel: is the label for nil. This only really makes sense in single selection mode."

	isOptional := true! !

!WASelectTag methodsFor: 'deprecated' stamp: 'lr 6/7/2007 07:54'!
beSingle
	self deprecatedApi: 'Use #select (constructure-method) instead of #beSingle'.
	self primitiveChangeClassTo: WASelectTag new! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
beSubmitOnChange
	"Submit the form in the user selects a value."

	self onChange: 'submit()'! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 17:44'!
before
	self isOptional ifTrue: [ self renderOptional ].
	super before! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 16:17'!
dispatchCallback
	^ canvas callbacks registerDispatchCallback! !

!WASelectTag methodsFor: 'callbacks' stamp: 'lr 6/6/2007 13:38'!
enabled: aBlock
	"Enable only those elements for selection for whom aBlock return true."

	enabledBlock := aBlock fixCallbackTemps! !

!WASelectTag methodsFor: 'initialization' stamp: 'lr 6/6/2007 17:43'!
initialize
	super initialize.
	isOptional := false! !

!WASelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 16:21'!
isEnabled: anObject
	"Test if anObject is enabled."

 	^ enabledBlock isNil or: [ enabledBlock value: anObject ]! !

!WASelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 17:42'!
isOptional
	^ isOptional! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
name: aString
	"This attribute assigns the control name."

	self attributes at: 'name' put: aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 16:23'!
openTag
	self attributes at: 'name' ifAbsentPut: [ self dispatchCallback ].
	super openTag! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
optionalLabel: aString
	"The label for the nil element. See #beOptional."

	optionalLabel := aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:57'!
renderListItem: anObject labelled: aString
	| option |
	option := canvas option.
	self hasCallback
		ifTrue: [ option callback: [ self performCallback: anObject ] ].
	option
		selected: (self isSelected: anObject);
		disabled: (self isEnabled: anObject) not;
		with: aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:58'!
renderOptional
	self renderListItem: nil labelled: optionalLabel! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
size: aNumber
	"If a SELECT element is presented as a scrolled list box, this attribute specifies the number of rows in the list that should be visible at the same time. Visual user agents are not required to present a SELECT element as a list box; they may use any other mechanism, such as a drop-down menu."

	self attributes at: 'size' put: aNumber! !

!WASelectTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 16:44'!
tag
	^ 'select'! !

WATagBrush subclass: #WADivTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WADivTag methodsFor: 'public api' stamp: 'avi 6/3/2005 15:40'!
clear
	self class: 'clear'.
	self with: [canvas space]! !

!WADivTag methodsFor: 'accessing' stamp: 'avi 6/3/2005 15:39'!
tag
	^ 'div'! !

WATagBrush subclass: #WAFieldSetTag
	instanceVariableNames: 'legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAFieldSetTag commentStamp: 'pmm 5/10/2007 10:12' prior: 0!
The FIELDSET element allows authors to group thematically related controls and labels. Grouping controls makes it easier for users to understand their purpose while simultaneously facilitating tabbing navigation for visual user agents and speech navigation for speech-oriented user agents. The proper use of this element makes documents more accessible.

The LEGEND element allows authors to assign a caption to a FIELDSET. The legend improves accessibility when the FIELDSET is rendered non-visually.!

!WAFieldSetTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
before
	legend ifNotNil: [canvas legend: legend]! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
legend: aString
	legend := aString! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:44'!
tag
	^ 'fieldset'! !

WATagBrush subclass: #WAFormInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

WAFormInputTag subclass: #WAAbstractTextAreaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAAbstractTextAreaTag commentStamp: 'pmm 4/23/2007 21:10' prior: 0!
An abstract class to describe the HTML elements that allow the user to enter text.!

!WAAbstractTextAreaTag methodsFor: 'callbacks' stamp: 'lr 2/25/2007 23:11'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock).
	self value: self value! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'lr 6/24/2007 10:03'!
exampleText: aString
	(self value isEmptyOrNil or: [ self value = aString ]) ifFalse: [ ^ self ].
	self onFocus: 'if(value==' , aString printString , '){value='''';style.color=null}'.
	self style: 'color: #aaa'; value: aString! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'lr 10/28/2007 14:42'!
setCursorPosition: anInteger
	self setSelectionFrom: anInteger to: anInteger! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'pmm 5/23/2007 23:46'!
setSelectionFrom: aStartInteger to: aStopInteger
	"Insert the javascript for setting the selection"
	| aStream |
	self ensureId.
	aStream := (String new: 30) writeStream.
	aStream
		nextPutAll: 'setSelection(''';
		nextPutAll: self id;
		nextPutAll: ''''.
	aStartInteger isNumber
		ifTrue: [aStream nextPut: $,; print: aStartInteger]
		ifFalse: [aStream nextPutAll: ',1'].
	aStopInteger isNumber
		ifTrue: [aStream nextPut: $,; print: aStopInteger ].
	aStream nextPut: $).
	self session addLoadScript: aStream contents! !

WAAbstractTextAreaTag subclass: #WATextAreaTag
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATextAreaTag commentStamp: 'pmm 4/24/2007 11:13' prior: 0!
I am a multi line text input widget. See WAInputTest >> #renderTextAreaWithExampleOn: for examples.!

!WATextAreaTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
columns: anInteger
	"This attribute specifies the visible width in average character widths. User agents may wrap visible text lines to keep long lines visible without the need for scrolling."
	self attributeAt: 'cols' put: anInteger! !

!WATextAreaTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:12'!
isClosed
	^ false! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
rows: anInteger
	"This attribute specifies the number of visible text lines. If more are entered, the widget scrolls."
	self attributeAt: 'rows' put: anInteger! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 4/13/2005 01:51'!
tag
	^ 'textarea'! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'lr 9/4/2007 15:53'!
value
	^ value! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 8/30/2005 16:26'!
value: aString
	value := aString! !

!WATextAreaTag methodsFor: 'public' stamp: 'lr 9/4/2007 15:57'!
with: aBlock
	super with: (value ifNil: [ aBlock ])! !

WAAbstractTextAreaTag subclass: #WATextInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATextInputTag commentStamp: 'pmm 4/24/2007 11:13' prior: 0!
I am a single line text input widget. See WAInputTest >> #renderTextInputWithExampleOn: for examples.!

WATextInputTag subclass: #WAPasswordInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAPasswordInputTag commentStamp: 'pmm 4/23/2007 21:12' prior: 0!
I am a password input widget that does not display the entered text.!

!WAPasswordInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:33'!
type
	^ 'password'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'pmm 4/23/2007 21:15'!
maxLength: aNumber
	"This attribute specifies the maximum number of characters the user may enter. This number may exceed the specified #size:, in which case the user agent should offer a scrolling mechanism. The default value for this attribute is an unlimited number."
	self attributeAt: 'maxlength' put: aNumber! !

!WATextInputTag methodsFor: 'attributes' stamp: 'pmm 4/23/2007 21:16'!
size: aNumber
	"This attribute tells the user agent the initial width of the widget. The width is given in number of characters."
	self attributeAt: 'size' put: aNumber! !

!WATextInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:50'!
type
	^ 'text'! !

WAFormInputTag subclass: #WACheckboxTag
	instanceVariableNames: 'value callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WACheckboxTag methodsFor: 'private' stamp: 'pmm 4/17/2007 16:32'!
after
	canvas hiddenInput callback: [
		callback value: value.
		value := false ]! !

!WACheckboxTag methodsFor: 'callbacks' stamp: 'avi 9/19/2006 14:31'!
callback: aBlock
	value := false.
	callback := aBlock fixCallbackTemps.
	super callback: [value := true]! !

!WACheckboxTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:20'!
canHaveShortcut
	^true! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
onTrue: trueBlock onFalse: falseBlock
	trueBlock fixCallbackTemps. falseBlock fixCallbackTemps.
	self callback: [ :v | v ifTrue: [ trueBlock value ] ifFalse: [ falseBlock value ] ]! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'pmm 11/20/2007 15:40'!
submitFormNamed: formName
	self onClick: 'submitForm(''', formName toString, '''); return false;'! !

!WACheckboxTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:44'!
type
	^ 'checkbox'! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
value: aBoolean
	self attributeAt: 'checked' put: aBoolean! !

WAFormInputTag subclass: #WAFileUploadTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAFileUploadTag commentStamp: 'pmm 4/15/2007 22:22' prior: 0!
I represent a file input element (<input type="file"). My callbacks will be evaluated with an instance of WAFile as an argument.!

!WAFileUploadTag methodsFor: 'attributes' stamp: 'pmm 5/2/2007 21:50'!
accept: aString
	"This attribute specifies a comma-separated list of content types that a server processing this form will handle correctly. User agents may use this information to filter out non-conforming files when prompting a user to select files to be sent to the server"
	self attributes at: 'accept' put: aString! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
callback: aBlock
	aBlock fixCallbackTemps.
	super callback: [ :file | aBlock value: (file = '' ifFalse: [ file ]) ]! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
on: selector of: anObject
	self callback: [ :value | anObject perform: selector asMutator with: value ]! !

!WAFileUploadTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:45'!
type
	^ 'file'! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:35'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock)! !

!WAFormInputTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:12'!
isClosed
	^ true! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
name: aString
	self attributes at: 'name' put: aString! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:35'!
on: selector of: anObject
	self value: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ]! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'pmm 4/23/2007 21:24'!
readonly: aBoolean
	"When set to true, this boolean attribute prohibits changes to the widget."
	self attributes at: 'readonly' put: aBoolean! !

!WAFormInputTag methodsFor: 'javascript' stamp: 'pmm 5/10/2007 10:04'!
setFocus
	"Makes this element have the initial focus once the page is loaded aka autofocus."
	self ensureId.
	self session addLoadScript: 'setFocus(' , self id printString , ')'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
submitOnClick
	self onClick: 'submit()'! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:08'!
tag
	^ 'input'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:37'!
text: aString
	self value: aString! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:43'!
type
	^ nil! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
type: aString
	self attributes at: 'type' put: aString! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
value
	^ self attributes at: 'value'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
value: anObject
	anObject ifNotNil: [ self attributes at: 'value' put: anObject ]! !

!WAFormInputTag methodsFor: 'public' stamp: 'lr 11/16/2006 15:31'!
with: aBlock
	self type isNil ifFalse: [
		self attributes at: 'type' ifAbsentPut: [ self type ].
		self class: self type ].
	super with: aBlock! !

WAFormInputTag subclass: #WAHiddenInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAHiddenInputTag commentStamp: 'pmm 9/22/2007 22:23' prior: 0!
Authors may create controls that are not rendered but whose values are submitted with a form. Authors generally use this control type to store information between client/server exchanges that would otherwise be lost due to the stateless nature of HTTP (see [RFC2616]). The INPUT element is used to create a hidden control.!

!WAHiddenInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:45'!
type
	^ 'hidden'! !

WAFormInputTag subclass: #WARadioButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WARadioButtonTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
beChecked
	self attributeAt: 'checked' put: true! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
beUnchecked
	self attributeAt: 'checked' put: false! !

!WARadioButtonTag methodsFor: 'callbacks' stamp: 'pmm 1/8/2007 12:14'!
callback: aBlock
	self value: (canvas callbacks registerCallback: aBlock)! !

!WARadioButtonTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:20'!
canHaveShortcut
	^true! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
group: aRadioGroup
	self name: aRadioGroup key! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
selected: aBoolean
	self attributeAt: 'checked' put: aBoolean! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:46'!
type
	^ 'radio'! !

WAFormInputTag subclass: #WASubmitButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

WASubmitButtonTag subclass: #WAButtonTag
	instanceVariableNames: 'type value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAButtonTag commentStamp: 'pmm 7/28/2007 08:54' prior: 0!
Buttons created with the BUTTON element function just like buttons created with the INPUT element, but they offer richer rendering possibilities: the BUTTON element may have content. For example, a BUTTON element that contains an image functions like and may resemble an INPUT element whose type is set to "image", but the BUTTON element type allows content.!

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:40'!
bePush
	"Creates a push button. Push buttons have no default behavior. Each push button may have client-side scripts associated with the element's event attributes. When an event occurs (e.g., the user presses the button, releases it, etc.), the associated script is triggered."
	type := 'button'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:34'!
beReset
	"Creates a reset button. When activated it resets all controls to their initial values."
	type := 'reset'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:33'!
beSubmit
	"Creates a submit button. When activated, a submit button submits a form. A form may contain more than one submit button. This is the default."
	type := 'submit'! !

!WAButtonTag methodsFor: 'initialize-release' stamp: 'pmm 7/28/2007 08:34'!
initialize
	super initialize.
	self beSubmit! !

!WAButtonTag methodsFor: 'testing' stamp: 'lr 6/13/2007 21:13'!
isClosed
	^ false! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 6/13/2007 21:13'!
tag
	^ 'button'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 8/8/2007 14:48'!
type
	^ type! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 9/18/2007 08:18'!
value
	^ value! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 9/18/2007 08:19'!
value: aString
	value := aString! !

!WAButtonTag methodsFor: 'public' stamp: 'lr 9/18/2007 08:19'!
with: aBlock
	super with: (value ifNil: [ aBlock ])! !

WASubmitButtonTag subclass: #WACancelButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WACancelButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:33'!
callback: aBlock
	self name: (canvas callbacks registerCancelActionCallback: aBlock)! !

WASubmitButtonTag subclass: #WAImageButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAImageButtonTag commentStamp: 'pmm 7/28/2007 08:56' prior: 0!
Creates a graphical submit button. The value of the src attribute specifies the URI of the image that will decorate the button. For accessibility reasons, authors should provide alternate text for the image via the alt attribute. 

When a pointing device is used to click on the image, the form is submitted and the click coordinates passed to the server. The x value is measured in pixels from the left of the image, and the y value in pixels from the top of the image. The submitted data includes name.x=x-value and name.y=y-value where "name" is the value of the name attribute, and x-value and y-value are the x and y coordinate values, respectively.!

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
callback: aBlock
	self name: (canvas callbacks registerImageCallback: aBlock)! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
form: aForm
	self extent: aForm extent.
	self url: (canvas context urlForDocument: aForm)! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
height: aNumber
	self attributes at: 'height' put: aNumber! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 4/10/2007 09:55'!
resourceUrl: aString
	self url: (canvas context absoluteUrlForResource: aString)! !

!WAImageButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'image'! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
url: aString
	self attributes at: 'src' put: aString! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: aNumber
	self attributes at: 'width' put: aNumber! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:32'!
callback: aBlock
	self name: (canvas callbacks registerActionCallback: aBlock)! !

!WASubmitButtonTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:19'!
canHaveShortcut
	^true! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:32'!
on: aSymbol of: anObject
	self value: (self labelForSelector: aSymbol of: anObject).
	self callback: [ anObject perform: aSymbol ]! !

!WASubmitButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'submit'! !

WATagBrush subclass: #WAFormTag
	instanceVariableNames: 'defaultAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAFormTag commentStamp: 'pmm 9/15/2007 08:23' prior: 0!
The FORM element acts as a container for input elements and buttons.

Evaluation order:
The input fields callbacks will be evaluated in the order they
appear in the XHTML. Buttons will always be evaluated last, no matter
where they are positioned.!

!WAFormTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
acceptCharset: aString
	"This attribute specifies the list of character encodings for input data that is accepted by the server processing this form. The value is a space- and/or comma-delimited list of charset values. The client must interpret this list as an exclusive-or list, i.e., the server is able to accept any single character encoding per entity received.

The default value for this attribute is the reserved string 'UNKNOWN'. User agents may interpret this value as the character encoding that was used to transmit the document containing this FORM element."

	self attributeAt: 'accept-charset' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'pmm 6/30/2007 00:33'!
action: aString
	"This attribute specifies a form processing agent. User agent behavior for a value other than an HTTP URI is undefined."
	self attributeAt: 'action' put: aString! !

!WAFormTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
after
	canvas div: [
		canvas context actionUrl parameters keysAndValuesDo: [ :k :v |
			canvas hiddenInput
				name: k;
				value: v ] ]! !

!WAFormTag methodsFor: 'private' stamp: 'pmm 11/25/2007 10:50'!
before
	"Define the default action form buttons. Some implementation notes on this feature: (1) a tab-index of -1 is not valid XHTML, but most todays browser accept it and ignore the element in the tab-order. (2) Internet Explorer requires an additional text field (without other functionality) to make the default action work. Other browser should not include this text-field, as it prevents remembering form input."

	defaultAction ifNil: [ ^ nil ].
	canvas div: [
		canvas submitButton
			tabIndex: -1;
			value: 'Default';
			callback: defaultAction;
			style: 'position: absolute; top: -100em'.
		self isInternetExplorer ifTrue: [
			canvas textInput
				tabIndex: -1;
				callback: [ :v | ];
				style: 'position: absolute; top: -100em' ] ]! !

!WAFormTag methodsFor: 'callbacks' stamp: 'pmm 9/15/2007 08:22'!
defaultAction: aBlock
	"The default action gets evaluated whenever the user presses submits
	the form by pressing enter without having the focus on a specific
	submit-button."
	defaultAction := aBlock! !

!WAFormTag methodsFor: 'initialize-release' stamp: 'pmm 6/30/2007 00:41'!
initialize
	super initialize.
	self acceptCharset: WACurrentSession value charSet! !

!WAFormTag methodsFor: 'private' stamp: 'pmm 11/25/2007 10:49'!
isInternetExplorer
	"tries to find out whether the current request is made by IE
	This is extremely unrelyable"
	| userAgent |
	userAgent := self session currentRequest userAgent.
	^(userAgent notNil
		and: [ (userAgent includesSubString: 'MSIE') ]
		"some Opera versions try to disguise them as IE")
		and: [ (userAgent includesSubString: 'Opera') not ]! !

!WAFormTag methodsFor: 'attributes' stamp: 'pmm 6/30/2007 00:34'!
method: aString
	"This attribute specifies which HTTP method will be used to submit the form data set. Possible (case-insensitive) values are 'get' (the default) and 'post'."
	self attributeAt: 'method' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'pmm 6/30/2007 00:37'!
multipart
	"Sets the content type used to submit the form to the server (when the value of method is 'post') to multipart/form-data instead the default application/x-www-form-urlencoded. This should be used in combination with a WAFileUploadTag."
	self attributeAt: 'enctype' put: 'multipart/form-data'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
multipart: aBoolean
	"Sets the content type used to submit the form to the server.
	true: sets the content type to multipart/form-data
	false: leavess the content type to default application/x-www-form-urlencoded"
	aBoolean ifTrue: [ self multipart ]! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/9/2005 16:02'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 3/21/2006 16:51'!
noAutocomplete
	self attributeAt: 'autocomplete' put: 'off'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:57'!
post
	self method: 'post'! !

!WAFormTag methodsFor: 'initialize-release' stamp: 'pmm 6/21/2007 20:57'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	self post; action: aCanvas context actionUrl withoutParameters! !

!WAFormTag methodsFor: 'private' stamp: 'avi 6/17/2004 11:29'!
tag
	^ 'form'! !

WATagBrush subclass: #WAGenericTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

WAGenericTag subclass: #WAEditTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAEditTag commentStamp: 'pmm 3/28/2007 10:40' prior: 0!
INS and DEL are used to markup sections of the document that have been inserted or deleted with respect to a different version of a document (e.g., in draft legislation where lawmakers need to view the changes).

These two elements are unusual for HTML in that they may serve as either block-level or inline elements (but not both). They may contain one or more words within a paragraph or contain one or more block-level elements such as paragraphs, lists and tables.

This example could be from a bill to change the legislation for how many deputies a County Sheriff can employ from 3 to 5.

<P>
  A Sheriff can employ <DEL>3</DEL><INS>5</INS> deputies.
</P>

The INS and DEL elements must not contain block-level content when these elements behave as inline elements.!

!WAEditTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 10:37'!
cite: aUrl
	"The value of this attribute is a URI that designates a source document or message. This attribute is intended to point to information explaining why a document was changed."
	self attributeAt: 'cite' put: aUrl! !

!WAEditTag methodsFor: 'attributes' stamp: 'pmm 3/28/2007 10:38'!
datetime: anObject
	"The value of this attribute specifies the date and time when the change was made.
	ISO date format"
	self attributeAt: 'datetime' put: anObject! !

!WAGenericTag class methodsFor: 'instance-creation' stamp: 'pmm 1/26/2007 23:05'!
tag: aString
	^ self new initializeWithTag: aString! !

!WAGenericTag methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:40'!
initializeWithTag: aString
	tag := aString! !

!WAGenericTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:40'!
tag
	^ tag! !

WATagBrush subclass: #WAHeadingTag
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAHeadingTag commentStamp: 'pmm 6/30/2007 00:44' prior: 0!
A heading element briefly describes the topic of the section it introduces. Heading information may be used by user agents, for example, to construct a table of contents for a document automatically.

There are six levels of headings in HTML with H1 as the most important and H6 as the least. Visual browsers usually render more important headings in larger fonts than less important ones.!

!WAHeadingTag methodsFor: 'initialization' stamp: 'lr 6/6/2007 14:02'!
initialize
	super initialize.
	self level1! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 18:26'!
level
	^ level! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level1
	level := 1! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level2
	level := 2! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level3
	level := 3! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level4
	level := 4! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level5
	level := 5! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level6
	level := 6! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'lr 6/6/2007 14:01'!
level: anInteger
	level := (anInteger max: 1) min: 6! !

!WAHeadingTag methodsFor: 'private' stamp: 'pmm 11/20/2007 15:45'!
tag
	^ 'h' , self level toString! !

WATagBrush subclass: #WAHorizontalRuleTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAHorizontalRuleTag commentStamp: 'pmm 9/22/2007 22:24' prior: 0!
The HR element causes a horizontal rule to be rendered by visual user agents.

The amount of vertical space inserted between a rule and the content that surrounds it depends on the user agent.!

!WAHorizontalRuleTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:10'!
isClosed
	^ true! !

!WAHorizontalRuleTag methodsFor: 'accessing' stamp: 'lr 3/26/2007 21:08'!
tag
	^ 'hr'! !

WATagBrush subclass: #WAIframeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAIframeTag commentStamp: 'pmm 9/22/2007 22:25' prior: 0!
The IFRAME element allows authors to insert a frame within a block of text. Inserting an inline frame within a section of text is much like inserting an object via the OBJECT element: they both allow you to insert an HTML document in the middle of another, they may both be aligned with surrounding text, etc. 

The information to be inserted inline is designated by the src attribute of this element. The contents of the IFRAME element, on the other hand, should only be displayed by user agents that do not support frames or are configured not to display frames.

Inline frames may not be resized.!

!WAIframeTag methodsFor: 'conveniance' stamp: 'pmm 5/23/2007 19:05'!
contents: anObject
	self url: (canvas urlForAction: [ self performRendering: anObject ])! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:34'!
document: anObject
	self document: anObject mimeType: nil! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:31'!
document: anObject mimeType: aMimeString
	self document: anObject mimeType: aMimeString fileName: nil! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 10/28/2007 14:42'!
document: anObject mimeType: aMimeString fileName: aFileNameString
	self url: (canvas context
		urlForDocument: anObject
		mimeType: aMimeString
		fileName: aFileNameString)! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
height: anInteger
	"The height of the inline frame."
	self attributes at: 'height' put: anInteger! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
name: aString
	"This attribute assigns a name to the current frame. This name may be used as the target of subsequent links."
	self attributes at: 'name' put: aString! !

!WAIframeTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
performRendering: anObject
	| innerContext docRoot session document response renderer |
	innerContext := canvas context copy.
	docRoot := WAHtmlRoot context: innerContext.
	docRoot base target: '_top'.
	session := WACurrentSession value.
	document := session outputDocumentClass new.
	response := WAResponse new.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document stream: response stream.
	canvas context document: document.
	docRoot open: document.
	renderer := canvas species context: canvas context callbacks: canvas callbacks.
	renderer render: anObject;
		 flush.
	docRoot close: document.
	session returnResponse: response! !

!WAIframeTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:32'!
src: anUrl
	self deprecatedApi.
	self url: anUrl! !

!WAIframeTag methodsFor: 'accessing' stamp: 'lr 3/8/2006 23:25'!
tag
	^ 'iframe'! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:06'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
width: anInteger
	"The width of the inline frame."
	self attributes at: 'width' put: anInteger! !

WATagBrush subclass: #WAImageTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAImageTag commentStamp: 'pmm 9/22/2007 22:28' prior: 0!
The IMG element embeds an image in the current document at the location of the element's definition. The IMG element has no content; it is usually replaced inline by the image designated by the src attribute, the exception being for left or right-aligned images that are "floated" out of line.

The alt attribute specifies alternate text that is rendered when the image cannot be displayed (see below for information on how to specify alternate text ). User agents must render alternate text when they cannot support images, they cannot support a certain image type or when they are configured not to display images.

Seaside per default sets the alternate text to an empty string. This helps validation of the page.!

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
altText: aString
	"The alt attribute provides a short description of the image."
	self attributes at: 'alt' put: aString! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 6/20/2007 10:52'!
document: aDocument
	self document: aDocument mimeType: nil! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 6/20/2007 10:52'!
document: aDocument mimeType: mimeType
	self document: aDocument mimeType: mimeType fileName: nil! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 6/20/2007 10:52'!
document: aDocument mimeType: mimeType fileName: fileName
	self url: (canvas context urlForDocument: aDocument mimeType: mimeType fileName: fileName)! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 3/20/2007 14:26'!
form: aForm
	self document: aForm! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
height: anInteger
	self attributes at: 'height' put: anInteger! !

!WAImageTag methodsFor: 'initialize-release' stamp: 'lr 6/20/2007 10:53'!
initialize
	super initialize.
	self altText: ''! !

!WAImageTag methodsFor: 'testing' stamp: 'lr 3/27/2007 11:06'!
isClosed
	^ true! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 4/10/2007 09:56'!
resourceUrl: aString
	self url: (canvas context absoluteUrlForResource: aString)! !

!WAImageTag methodsFor: 'initialize-release' stamp: 'pmm 4/7/2007 01:27'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	(aBrush isKindOf: WAImageMapTag) ifTrue: [
		"in case the parent is an image map we need to set this attribute"
		self attributeAt: 'ismap' put: true ]! !

!WAImageTag methodsFor: 'deprecated' stamp: 'lr 10/28/2007 14:42'!
src: aString
	self deprecatedApi.
	self url: aString! !

!WAImageTag methodsFor: 'private' stamp: 'ac 3/16/2005 12:00'!
tag
	^ 'img'! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 6/20/2007 10:53'!
url: aString
	self attributes at: 'src' put: aString! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
width: anInteger
	self attributes at: 'width' put: anInteger! !

WATagBrush subclass: #WALabelTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WALabelTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
for: aString
	self attributeAt: 'for' put: aString! !

!WALabelTag methodsFor: 'accessing' stamp: 'ac 7/9/2005 04:36'!
tag
	^ 'label'! !

WATagBrush subclass: #WAObjectTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:27'!
archive: aUrl
	self attributeAt: 'archive' put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:25'!
classId: aUrl
	self attributeAt: 'classid' put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:26'!
codebase: aUrl
	self attributeAt: 'codebase' put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:28'!
codetype: aString
	self attributeAt: 'codetype' put: aString! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:28'!
declare: aBoolean
	self attributeAt: 'declare' put: aBoolean! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:57'!
height: anInteger
	self attributeAt: 'height' put: anInteger! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:29'!
standby: aString
	self attributeAt: 'standby' put: aString! !

!WAObjectTag methodsFor: 'accessing' stamp: 'pmm 2/11/2007 19:24'!
tag
	^ 'object'! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:28'!
type: aString
	self attributeAt: 'type' put: aString! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:26'!
url: aUrl
	self attributeAt: 'data' put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 19:57'!
width: anInteger
	self attributeAt: 'width' put: anInteger! !

WATagBrush subclass: #WAOptionGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAOptionGroupTag commentStamp: 'pmm 4/24/2007 10:53' prior: 0!
The OPTGROUP element allows authors to group choices logically. This is particularly helpful when the user must choose from a long list of options; groups of related choices are easier to grasp and remember than a single long list of options.

It has crappy browser support and noone as ever used it. See WAInputTest >> #renderOptionGroupOn: for examples.!

!WAOptionGroupTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
label: aString
	"This attribute specifies the label for the option group."

	self attributes at: 'label' put: aString! !

!WAOptionGroupTag methodsFor: 'accessing' stamp: 'pmm 4/24/2007 10:49'!
tag
	^ 'optgroup'! !

WATagBrush subclass: #WAOptionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAOptionTag methodsFor: 'callbacks' stamp: 'lr 6/6/2007 19:42'!
callback: aBlock
	self value: (canvas callbacks registerCallback: aBlock)! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
label: aString
	"This attribute allows authors to specify a shorter label for an option than the content of the OPTION element. When specified, user agents should use the value of this attribute rather than the content of the OPTION element as the option label."

	self attributes at: 'label' put: aString! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 6/6/2007 19:42'!
selected: aBoolean
	self attributes at: 'selected' put: aBoolean! !

!WAOptionTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 17:13'!
tag
	^ 'option'! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 6/6/2007 19:42'!
value: aString
	self attributes at: 'value' put: aString! !

WATagBrush subclass: #WAParameterTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAParameterTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 20:04'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAParameterTag methodsFor: 'accessing' stamp: 'pmm 2/11/2007 20:12'!
tag
	^ 'param'! !

!WAParameterTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 20:06'!
type: aString
	self attributeAt: 'type' put: aString! !

!WAParameterTag methodsFor: 'attributes' stamp: 'pmm 2/11/2007 20:05'!
value: aString
	self attributeAt: 'value' put: aString! !

WATagBrush subclass: #WARubyTextTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WARubyTextTag methodsFor: 'attributes' stamp: 'pmm 9/18/2006 19:01'!
span: anInteger
	self attributeAt: 'rbspan' put: anInteger! !

!WARubyTextTag methodsFor: 'accessing' stamp: 'pmm 9/18/2006 19:00'!
tag
	^ 'rt'! !

WATagBrush subclass: #WAScriptTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAScriptTag methodsFor: 'private' stamp: 'lr 3/27/2007 11:57'!
after
	self document nextPutAll: '/*]]>*/'! !

!WAScriptTag methodsFor: 'private' stamp: 'lr 3/27/2007 11:56'!
before
	self document nextPutAll: '/*<!![CDATA[*/'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 07:36'!
defer
	"When set, this boolean attribute provides a hint to the user agent that the script is not going to generate any document content (e.g., no 'document.write' in javascript) and thus, the user agent can continue parsing and rendering."
		self attributeAt: 'defer' put: true! !

!WAScriptTag methodsFor: 'attributes' stamp: 'lr 4/10/2007 09:55'!
resourceUrl: aString
	self url: (canvas context absoluteUrlForResource: aString)! !

!WAScriptTag methodsFor: 'accessing' stamp: 'dwj 6/10/2005 13:10'!
tag
	^ 'script'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:05'!
url: aString
	self attributes at: 'src' put: aString! !

!WAScriptTag methodsFor: 'public' stamp: 'pmm 11/20/2007 15:47'!
with: aString
	self attributes at: 'type' ifAbsentPut: [ 'text/javascript' ].
	super with: [ self document nextPutAll: aString toString ]! !

WATagBrush subclass: #WATableCellTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
align: aString
	self attributes at: 'align' put: aString! !

!WATableCellTag methodsFor: 'attributes' stamp: 'pmm 11/20/2007 15:48'!
character: aStringOrCharacter
	self attributes at: 'char' put: aStringOrCharacter toString! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
characterOffset: anInteger
	self attributes at: 'charoff' put: anInteger! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
colSpan: anInteger
	self attributes at: 'colspan' put: anInteger! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
rowSpan: anInteger
	self attributes at: 'rowspan' put: anInteger! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
scope: aString
	self attributes at: 'scope' put: aString! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
verticalAlign: aString
	self attributes at: 'valign' put: aString! !

WATableCellTag subclass: #WATableDataTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableDataTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:09'!
tag
	^ 'td'! !

WATableCellTag subclass: #WATableHeadingTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableHeadingTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:10'!
tag
	^ 'th'! !

WATagBrush subclass: #WATableColumnGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
align: aString
	self attributes at: 'align' put: aString! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'pmm 11/20/2007 15:48'!
character: aStringOrCharacter
	self attributes at: 'char' put: aStringOrCharacter toString! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
characterOffset: anInteger
	self attributes at: 'charoff' put: anInteger! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
span: anInteger
	self attributes at: 'span' put: anInteger! !

!WATableColumnGroupTag methodsFor: 'accessing' stamp: 'mb 12/8/2006 15:51'!
tag
	^ 'colgroup'! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
verticalAlign: aString
	self attributes at: 'valign' put: aString! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'pmm 11/20/2007 15:48'!
width: aNumber
	self attributeAt: 'width' put: aNumber toString! !

WATableColumnGroupTag subclass: #WATableColumnTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableColumnTag methodsFor: 'testing' stamp: 'lr 3/27/2007 11:06'!
isClosed
	^ true! !

!WATableColumnTag methodsFor: 'accessing' stamp: 'mb 12/8/2006 15:51'!
tag
	^ 'col'! !

WATagBrush subclass: #WATableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableTag methodsFor: 'deprecated' stamp: 'lr 10/28/2007 14:42'!
align: aString
	self deprecatedApi.
	self attributes at: 'align' put: aString! !

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:33'!
border: anInteger
	self deprecatedApi.
	self attributes at: 'border' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 12/30/2006 00:11'!
cellpadding: anInteger
	self attributes at: 'cellpadding' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 12/30/2006 00:11'!
cellspacing: anInteger
	self attributes at: 'cellspacing' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'pmm 4/8/2007 00:07'!
frame: aString
	"frame = void|above|below|hsides|lhs|rhs|vsides|box|border [CI]
    This attribute specifies which sides of the frame surrounding a table will be visible. Possible values:

        * void: No sides. This is the default value.
        * above: The top side only.
        * below: The bottom side only.
        * hsides: The top and bottom sides only.
        * vsides: The right and left sides only.
        * lhs: The left-hand side only.
        * rhs: The right-hand side only.
        * box: All four sides.
        * border: All four sides."

	self attributes at: 'frame' put: aString! !

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 18:07'!
layout
	self deprecatedApi.
	self border: 0.
	self cellspacing: 0.
	self cellpadding: 0! !

!WATableTag methodsFor: 'attributes' stamp: 'pmm 4/8/2007 00:06'!
rules: aString
	"rules = none|groups|rows|cols|all [CI]
    This attribute specifies which rules will appear between cells within a table. The rendering of rules is user agent dependent. Possible values:

        * none: No rules. This is the default value.
        * groups: Rules will appear between row groups (see THEAD, TFOOT, and TBODY) and column groups (see COLGROUP and COL) only.
        * rows: Rules will appear between rows only.
        * cols: Rules will appear between columns only.
        * all: Rules will appear between all rows and columns."
	self attributes at: 'rules' put: aString! !

!WATableTag methodsFor: 'attributes' stamp: 'mb 12/8/2006 15:03'!
summary: aString
	self attributes at: 'summary' put: aString! !

!WATableTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 15:22'!
tag
	^ 'table'! !

!WATagBrush class methodsFor: 'code generation' stamp: 'pmm 9/12/2006 19:28'!
tag
	"WASelectTag tag"
	"WAGenericTag tag"
	^(self selectors includes: #tag)
		ifTrue: [ self new tag ]
		ifFalse: [ nil ]! !

!WATagBrush methodsFor: 'attributes-keyboard' stamp: 'lr 10/28/2007 14:42'!
accessKey: aString
	"Set a keyboard shortcut to access an element. An access key is a single character from the document character set.

	Pressing an access key assigned to an element gives focus to the element. The action that occurs when an element receives focus depends on the element. For example, when a user activates a link defined by the A element, the user agent generally follows the link. When a user activates a radio button, the user agent changes the value of the radio button. When the user activates a text field, it allows input, etc.

The following elements support the accesskey attribute: A, AREA, BUTTON, INPUT, LABEL, and LEGEND, and TEXTAREA.

	The invocation of access keys depends on the underlying system. For instance, on machines running MS Windows, one generally has to press the 'alt' key in addition to the access key. On Apple systems, one generally has to press the 'cmd' key in addition to the access key."

	self attributes at: 'accesskey' put: aString! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addShortcut: aString
	self canHaveShortcut ifFalse: [
		self error: 'May not assign shortcut on items that are not clickable' ].

	self ensureId.
	self session addLoadScript: (String streamContents: [ :stream |
		stream
			nextPutAll: 'addShortcut(''';
			nextPutAll: aString;
			nextPutAll: ''', ''';
			nextPutAll: self id;
			nextPutAll: ''')' ])! !

!WATagBrush methodsFor: 'private' stamp: 'lr 4/9/2007 13:18'!
after
	"This template method is called directly after rendering the content of the receiver."! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:57'!
attributeAt: aKey
	^ self attributes at: aKey! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifAbsent: aBlock
	^ self attributes at: aKey ifAbsent: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifAbsentPut: aBlock
	^ self attributes at: aKey ifAbsentPut: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifPresent: aBlock
	^ self attributes at: aKey ifPresent: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:57'!
attributeAt: aKey put: aValue
	^ self attributes at: aKey put: aValue! !

!WATagBrush methodsFor: 'accessing' stamp: 'lr 3/23/2007 20:08'!
attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]! !

!WATagBrush methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
attributes: anHtmlAttributes
	attributes := anHtmlAttributes! !

!WATagBrush methodsFor: 'private' stamp: 'lr 4/9/2007 13:18'!
before
	"This template method is called directly before rendering the content of the receiver."! !

!WATagBrush methodsFor: 'convenience' stamp: 'mb 3/8/2006 18:18'!
canHaveShortcut
	^false! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
class: aString
	"This attribute assigns one or more class names to an element; the element may be said to belong to these classes. A class name may be shared by several element instances. Multiple classes might be added to one brush."

	self attributes addClass: aString! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
class: aString if: aBoolean
	"Adds the class aString aString to this element if aBoolean is true,

	Example

	html div
		class: 'important' if: self isImportant;
		with: self message"

	aBoolean
		ifTrue: [self class: aString]! !

!WATagBrush methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
closeTag
	"Close the receiving tag onto the document."

	self isClosed ifFalse: [ self document closeTag: self tag ]! !

!WATagBrush methodsFor: 'convenience' stamp: 'avi 3/9/2006 17:41'!
confirm: aString
	self onClick: 'return confirm("', aString, '")'! !

!WATagBrush methodsFor: 'attributes-language' stamp: 'lr 10/28/2007 14:42'!
direction: aString
	"Set the text direction ltr (left-to-right) or right-to-left (rtl).

	Not supported on:
	APPLET, BASE, BASEFONT, BR, FRAME, FRAMESET, IFRAME, PARAM, SCRIPT"

	self attributes at: 'dir' put: aString! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
disableEnter
	"pressing the 'enter' key in the form input element does not submit the form"
	self onEnter: ''! !

!WATagBrush methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
disabled
	self disabled: true! !

!WATagBrush methodsFor: 'attributes' stamp: 'lr 6/6/2007 16:20'!
disabled: aBoolean
	self attributes at: 'disabled' put: aBoolean! !

!WATagBrush methodsFor: 'private' stamp: 'avi 6/13/2004 00:39'!
document
	^ canvas document! !

!WATagBrush methodsFor: 'public' stamp: 'lr 4/9/2007 16:31'!
ensureId
	"Answer the id of the receiving attribute. In case the receiver doesn't have an id yet, generate a new one."

	^ self attributes at: 'id' ifAbsentPut: [ canvas nextId ]! !

!WATagBrush methodsFor: 'accessing' stamp: 'pmm 11/21/2007 14:24'!
id
	^ self attributes at: 'id'! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
id: aString
	"The id attribute assigns a identifier to an element. The id of an element must be unique within a document."

	self attributes at: 'id' put: aString! !

!WATagBrush methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isClosed
	"Answer true if this tag should be closed immediately, such as <br />."

	^ false! !

!WATagBrush methodsFor: 'attributes-language' stamp: 'lr 10/28/2007 14:42'!
language: aString
	"Set the language code."

	self attributes
		at: 'lang' put: aString;
		at: 'xml:lang' put: aString! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 4/9/2007 14:08'!
onBlur: aString
	"The onblurs event occurs when the element that is in focus, loses that focus."

	self attributes at: 'onblur' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 4/9/2007 14:09'!
onChange: aString
	"The onchange event occurs when a select input element has a selection made or when a text input element has a change in the text."

	self attributes at: 'onchange' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onClick: aString
	"The onclick event occurs when the pointing device button is clicked over an element."

	self attributes at: 'onclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onDoubleClick: aString
	"The ondblclick event occurs when the pointing device button is double clicked over an element."

	self attributes at: 'ondblclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'convenience' stamp: 'pmm 11/20/2007 15:48'!
onEnter: aString
	"If 'enter' is pressed"
	self onKeyPress: 'if((window.event ? window.event.keyCode : event.which) == 13){', aString toString, '; return false}; return true'! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 6/7/2006 13:48'!
onError: aString
	self attributes at: 'onerror' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onFocus: aString
	"The onfocus event occurs when an element receives focus either by the pointing device or by tabbing navigation."

	self attributes at: 'onfocus' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onKeyDown: aString
	"The onkeydown event occurs when a key is pressed down over an element."

	self attributes at: 'onkeydown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onKeyPress: aString
	"The onkeypress event occurs when a key is pressed and released over an element."

	self attributes at: 'onkeypress' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onKeyUp: aString
	"The onkeyup event occurs when a key is released over an element."

	self attributes at: 'onkeyup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'mb 6/21/2006 18:28'!
onLoad: aString
	"The onload event occurs when the user agent finishes loading a window."

	self attributes at: 'onload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseDown: aString
	"The onmousedown event occurs when the pointing device button is pressed over an element."

	self attributes at: 'onmousedown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseMove: aString
	"The onmousemove event occurs when the pointing device is moved while it is over an element."

	self attributes at: 'onmousemove' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseOut: aString
	"The onmouseout event occurs when the pointing device is moved away from an element."

	self attributes at: 'onmouseout' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseOver: aString
	"The onmouseover event occurs when the pointing device is moved onto an element."

	self attributes at: 'onmouseover' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseUp: aString
	"The onmouseup event occurs when the pointing device button is released over an element."

	self attributes at: 'onmouseup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:49'!
onReset: aString
	"The onreset event occurs when a form is reset."

	self attributes at: 'onreset' append: aString separator: ';'! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 6/7/2006 13:49'!
onResize: aString
	self attributes at: 'onresize' append: aString separator: ';'! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 6/7/2006 13:49'!
onScroll: aString
	self attributes at: 'onscroll' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:49'!
onSelect: aString
	"The onselect event occurs when a user selects some text in a text field."

	self attributes at: 'onselect' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:49'!
onSubmit: aString
	"The onsubmit event occurs when a form is submitted."

	self attributes at: 'onsubmit' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:49'!
onUnload: aString
	"The onunload event occurs when the user agent removes a document from a window."

	self attributes at: 'onunload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
openTag
	"Open the receiving and all associated attributes onto the document."

	self document openTag: self tag attributes: attributes closed: self isClosed! !

!WATagBrush methodsFor: 'accessing' stamp: 'lr 4/20/2007 16:21'!
session
	^ WACurrentSession value! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 4/9/2007 16:13'!
style: aString
	"This attribute offers optional CSS style information. The attribute is deprecated and should be avoided in favor of an external stylesheet. Multiple styles might be added to one brush."

	self attributes addStyle: aString! !

!WATagBrush methodsFor: 'attributes-keyboard' stamp: 'lr 10/28/2007 14:42'!
tabIndex: aString
	"This attribute specifies the position of the current element in the tabbing order for the current document. This value must be a number between 0 and 32767.

	The tabbing order defines the order in which elements will receive focus when navigated by the user via the keyboard. The tabbing order may include elements nested within other elements.

	The following elements support the tabindex attribute: A, AREA, BUTTON, INPUT, OBJECT, SELECT, and TEXTAREA."

	self attributes at: 'tabindex' put: aString! !

!WATagBrush methodsFor: 'private' stamp: 'avi 6/13/2004 00:30'!
tag
	self subclassResponsibility! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
title: aString
	"This attribute offers advisory information about the element for which it is set. Visual browsers frequently display the title as a 'tool tip'."

	self attributes at: 'title' put: aString! !

!WATagBrush methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
with: anObject
	"Render anObject into the receiver. Make sure that you call #with: last in the cascade, as this method will serialize the tag onto the output document."

	self openTag.
	super with: [
		self before.
		anObject renderOn: canvas.
		self after ].
	self closeTag! !

!WATagBrush methodsFor: 'convenience' stamp: 'pmm 5/10/2007 10:16'!
withLineBreaks: aString
	"Renders text preserving line breaks."
	self with: [canvas withLineBreaks: aString]! !

Object subclass: #WACachedDocument
	instanceVariableNames: 'fullFileName mimeDocument mimeType'
	classVariableNames: 'DocumentCache'
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WACachedDocument commentStamp: '<historical>' prior: 0!
This class is for serving smallish files like PNG images etc using WADocumentHandler. Using the Canvas API for HTML generation you simply do this:

	html image fileName: 'myimage.png'

or:

	html image fileName: 'myimage.blurp' mimeType: 'blurp'

This will create a request handler in your WAApplication registry that is accessible on a unique URL and does not expire.
The actual contents of the file will only be read upon first access, we could augment this class with smarter caching, like checking the modification time on disk.

The class has a Cache class var holding a Dictionary of created instances so you can clear and preload files into the image using:

	WACachedDocument
		clearCache;
		fileName: 'myimage.png';
		fileName: 'another.gif'; "etc"
		preloadCache!

!WACachedDocument class methodsFor: 'cache' stamp: 'pmm 5/30/2007 09:33'!
clearCache
	"Clear the cache of instances. This will cause
	the files to be lazily reread from disk."

	DocumentCache := Dictionary new! !

!WACachedDocument class methodsFor: 'instance-creation' stamp: 'pmm 5/30/2007 09:33'!
fileName: aFileName
	"Check the cache to see if we already have this file loaded.
	We only rely on the local filename!!"

	^DocumentCache at: aFileName ifAbsentPut: [self fullFileName: aFileName]! !

!WACachedDocument class methodsFor: 'instance-creation' stamp: 'gk 1/10/2006 13:22'!
fullFileName: fullFileName

	^self new fullFileName: fullFileName! !

!WACachedDocument class methodsFor: 'initialize-release' stamp: 'gk 1/12/2006 14:05'!
initialize
	self clearCache! !

!WACachedDocument class methodsFor: 'cache' stamp: 'pmm 5/30/2007 09:33'!
preloadCache
	"Load the files into the image for the currently
	created instances in the Cache."

	DocumentCache valuesDo: [ :each | each asMIMEDocument ]! !

!WACachedDocument methodsFor: 'comparing' stamp: 'gk 1/10/2006 13:13'!
= other
	"Currently we do not take file modification time on disk into account."

	^other species = self species and: [other fullFileName = fullFileName]! !

!WACachedDocument methodsFor: 'public' stamp: 'mb 6/2/2006 10:49'!
asMIMEDocument
	^self asMIMEDocumentType: mimeType! !

!WACachedDocument methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
asMIMEDocumentType: type
	"Lazy caching."
	^mimeDocument ifNil: [
		mimeType := type.
		mimeDocument := SeasidePlatformSupport
				mimeDocumentOfType: mimeType
				from: fullFileName]! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:19'!
fullFileName
	^fullFileName! !

!WACachedDocument methodsFor: 'initialize-release' stamp: 'lr 10/28/2007 14:42'!
fullFileName: aFileName
	fullFileName := aFileName! !

!WACachedDocument methodsFor: 'comparing' stamp: 'gk 1/10/2006 13:14'!
hash
	"Currently we do not take file modification time on disk into account.
	Note that mimeType and mimeDocument are set lazily later, so we can't use
	the mimeType in the hash."

	^fullFileName hash! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:18'!
mimeType
	^mimeType! !

!WACachedDocument methodsFor: 'accessing' stamp: 'pmm 8/9/2007 23:51'!
mimeType: anObject
	mimeType := anObject! !

Object subclass: #WACallback
	instanceVariableNames: 'context owner key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAActionCallback methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
block: aZeroArgBlock
	block := aZeroArgBlock fixCallbackTemps! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'avi 6/8/2004 01:51'!
evaluateWithArgument: anObject
	block value.
	self signalRenderNotification! !

!WAActionCallback methodsFor: 'testing' stamp: 'lr 8/8/2007 17:56'!
isEnabled
	^ self session currentRequest isXmlHttpRequest not! !

!WAActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 8! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'lr 10/28/2007 14:42'!
signalRenderNotification
	WARenderNotification raiseSignal! !

WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACancelActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 3! !

WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WADefaultActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 10! !

WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAImageCallback methodsFor: 'converting' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString, '.x'! !

!WACallback methodsFor: 'comparing' stamp: 'avi 6/7/2004 22:38'!
<= other
	^ self priority < other priority or: [self priority = other priority and: [self key asNumber <= other key asNumber]]! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 21:48'!
context
	^ context! !

!WACallback methodsFor: 'converting' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString! !

!WACallback methodsFor: 'evaluation' stamp: 'avi 6/7/2004 21:49'!
evaluateWithArgument: anObject
	self subclassResponsibility! !

!WACallback methodsFor: 'evaluation' stamp: 'lr 8/8/2007 17:55'!
evaluateWithField: anObject
	self isEnabled ifFalse: [ ^ self ].
	self evaluateWithArgument: (self valueForField: anObject)! !

!WACallback methodsFor: 'testing' stamp: 'lr 8/8/2007 17:56'!
isEnabled
	^ true! !

!WACallback methodsFor: 'accessing' stamp: 'lr 8/8/2007 17:54'!
key
	^ self convertKey: key! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 21:48'!
owner
	^ owner! !

!WACallback methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
priority
	self subclassResponsibility! !

!WACallback methodsFor: 'accessing' stamp: 'lr 8/8/2007 14:36'!
session
	^ context session! !

!WACallback methodsFor: 'initialization' stamp: 'avi 6/7/2004 22:39'!
setContext: aRenderingContext owner: anObject key: aString
	context := aRenderingContext.
	owner := anObject.
	key := aString! !

!WACallback methodsFor: 'converting' stamp: 'avi 6/7/2004 21:51'!
valueForField: anObject
	^ anObject
		ifNil: ['']
		ifNotNil:
			[(anObject isCollection and: [anObject isString not])
					ifTrue: [anObject isEmpty
								ifTrue: ['']
								ifFalse: [anObject first]]
					ifFalse: [anObject]]! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WADispatchCallback methodsFor: 'evaluation' stamp: 'lr 10/28/2007 14:42'!
evaluateWithArgument: anObject
	(context callbackAt: anObject)
		ifNotNilDo: [ :callback | callback evaluateWithArgument: nil ]! !

!WADispatchCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:42'!
priority
	^ 5! !

WADispatchCallback subclass: #WAMultiDispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAMultiDispatchCallback methodsFor: 'evaluation' stamp: 'lr 10/28/2007 14:42'!
evaluateWithField: anObject
	(anObject isCollection and: [ anObject isString not ])
		ifFalse: [ ^ super evaluateWithField: anObject ].
	anObject do: [ :each |
		self evaluateWithArgument: (self valueForField: each) ]! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 9/19/2006 14:29'!
block: aOneArgBlock
	block := aOneArgBlock fixCallbackTemps! !

!WAValueCallback methodsFor: 'evaluation' stamp: 'pmm 2/27/2007 06:30'!
evaluateWithArgument: anObject
	block valueWithPossibleArgument: anObject! !

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:41'!
priority
	^ 5! !

Object subclass: #WACallbackRegistry
	instanceVariableNames: 'context owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACallbackRegistry class methodsFor: 'instance-creation' stamp: 'avi 6/7/2004 22:04'!
context: aContext owner: anObject
	^ self basicNew initializeWithContext: aContext owner: anObject! !

!WACallbackRegistry methodsFor: 'initialization' stamp: 'avi 6/7/2004 22:04'!
initializeWithContext: aContext owner: anObject
	context := aContext.
	owner := anObject! !

!WACallbackRegistry methodsFor: 'accessing' stamp: 'lr 5/1/2007 08:20'!
owner
	^ owner! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerActionCallback: aBlock
	^ self storeCallback: (WAActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerCallback: aBlock
	^ self storeCallback: (WAValueCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:41'!
registerCancelActionCallback: aBlock
	^ self storeCallback: (WACancelActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:41'!
registerDefaultActionCallback: aBlock
	^ self storeCallback: (WADefaultActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 9/2/2004 14:42'!
registerImageCallback: aBlock
	^ self storeCallback: (WAImageCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'lr 10/10/2005 20:00'!
registerMultiDispatchCallback
	^ self storeCallback: WAMultiDispatchCallback new! !

!WACallbackRegistry methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
storeCallback: aCallback
	| key |
	key := context storeCallback: aCallback.
	aCallback setContext: context owner: owner key: key.
	^ key! !

Object subclass: #WACallbackStream
	instanceVariableNames: 'callbacks request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACallbackStream class methodsFor: 'instance-creation' stamp: 'avi 6/8/2004 01:58'!
callbacks: aDictionary request: aRequest
	^ self basicNew initializeWithCallbacks: aDictionary request: aRequest! !

!WACallbackStream methodsFor: 'testing' stamp: 'avi 6/8/2004 01:59'!
atEnd
	^ callbacks atEnd! !

!WACallbackStream methodsFor: 'initialization' stamp: 'lr 9/26/2005 14:10'!
initializeWithCallbacks: aDictionary request: aRequest
	| collection |
	collection := SortedCollection new.
	aRequest fields keys do:
		[:ea |
		aDictionary at: ea ifPresent: [:callback | collection add: callback]].
	callbacks := ReadStream on: collection asArray.
	request := aRequest! !

!WACallbackStream methodsFor: 'accessing' stamp: 'avi 6/8/2004 01:59'!
position
	^ callbacks position! !

!WACallbackStream methodsFor: 'processing' stamp: 'avi 6/12/2004 00:21'!
processCallbacksWithOwner: anObject
	| callback |
	[callbacks atEnd not and: [callbacks peek owner == anObject]] whileTrue:
		[callback := callbacks next.
		callback evaluateWithField: (request fields at: callback key)]! !

!WACallbackStream methodsFor: 'accessing' stamp: 'avi 6/12/2004 00:25'!
upToEnd
	^ callbacks upToEnd! !

Object subclass: #WACanvas
	instanceVariableNames: 'currentBrush parentBrush'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WACanvas commentStamp: 'pmm 4/15/2007 22:05' prior: 0!
This is the superclass of all canvas. It's a rendering interfact that generates brushes (see WABrush).

Subclass this class, if you want to generate an XML dialect.!

!WACanvas class methodsFor: 'instance creation' stamp: 'pmm 8/12/2007 11:59'!
builder
	^WAHtmlBuilder on: self! !

!WACanvas methodsFor: 'public' stamp: 'avi 6/17/2004 12:36'!
brush: aBrush
	self flush.
	currentBrush := aBrush.
	aBrush setParent: parentBrush canvas: self.
	^ aBrush! !

!WACanvas methodsFor: 'private' stamp: 'avi 6/17/2004 12:12'!
flush
	currentBrush ifNotNil:
		[currentBrush close.
		currentBrush := nil]! !

!WACanvas methodsFor: 'private' stamp: 'lr 6/6/2007 10:32'!
insert: aBlock
	| oldBrush |
	oldBrush := currentBrush.
	currentBrush := nil.
	aBlock value.
	self flush.
	currentBrush := oldBrush! !

!WACanvas methodsFor: 'private' stamp: 'lr 4/9/2007 17:54'!
nest: aBlock
	parentBrush := currentBrush.
	currentBrush := nil.
	aBlock renderOn: self.
	self flush.
	parentBrush := parentBrush parent! !

!WACanvas methodsFor: 'public' stamp: 'pmm 10/15/2006 11:33'!
render: anObject
	self flush.
	anObject renderOn: self! !

WACanvas subclass: #WAHtmlCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WAHtmlCanvas commentStamp: 'pmm 4/15/2007 22:10' prior: 0!
This canvas knows about HTML but nothing about callbacks.!

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:01'!
abbreviated
	"Defines an abbreviation, such as 'M.', 'Inc.', 'et al.', 'etc.'"

	^ self tag: 'abbr'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
abbreviated: aBlock
	self abbreviated with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
acronym
	"Defines an acronym, such as 'GmbH', 'NATO', and 'F.B.I.'"

	^ self tag: 'acronym'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'mb 3/24/2006 13:42'!
acronym: aBlock
	self acronym with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
address
	"Defines an address element."

	^ self tag: 'address'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 12/24/2005 17:44'!
address: aBlock
	self address with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
anchor
	"Defines an anchor."

	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 4/9/2007 17:23'!
anchor: aBlock
	self anchor with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
big
	"Defines big text."

	^ self tag: 'big'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'ac 2/21/2006 14:36'!
big: aBlock
	self big with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:02'!
blockquote
	"Defines a long quotation."

	^ self tag: 'blockquote'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'avi 6/3/2005 15:40'!
blockquote: aBlock
	self blockquote with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
break
	"Inserts a single line break."

	^ self brush: WABreakTag new! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
citation
	"Defines a citation."

	^ self tag: 'cite'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
citation: aBlock
	self citation with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
code
	"Defines computer code text."

	^ self tag: 'code'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'avi 6/3/2005 15:40'!
code: aBlock
	self code with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
definition
	"Defines a definition term."

	^ self tag: 'dfn'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'pmm 9/30/2006 20:06'!
definition: aBlock
	self definition with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionData
	"Defines a definition description."

	^ self tag: 'dd'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 5/31/2006 20:26'!
definitionData: aBlock
	self definitionData with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionList
	"Defines a definition list."

	^ self tag: 'dl'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 12/24/2005 17:42'!
definitionList: aBlock
	self definitionList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionTerm
	"Defines a definition term."

	^ self tag: 'dt'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm: aBlock
	self definitionTerm with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
deleted
	"Defines deleted text."

	^ self brush: (WAEditTag tag: 'del')! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 3/28/2007 10:42'!
deleted: aBlock
	self deleted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'lr 10/28/2007 14:42'!
div
	"Defines a section in a document."

	^ self brush: WADivTag new! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'avi 6/3/2005 15:40'!
div: aBlock
	self div with: aBlock! !

!WAHtmlCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:57'!
document
	self subclassResponsibility! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:53'!
emphasis
	"Defines emphasized text."

	^ self tag: 'em'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'mb 3/8/2006 17:14'!
emphasis: aBlock
	self emphasis with: aBlock! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'pmm 11/20/2007 15:45'!
encodeCharacter: aCharacter
	self html: '&#' , aCharacter asInteger toString , ';'! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
fieldSet
	"Defines a fieldset."

	^ self brush: WAFieldSetTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'mb 3/24/2006 13:45'!
fieldSet: aBlock
	self fieldSet with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
form
	"Defines a form."

	^ self tag: 'form'! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'avi 6/3/2005 15:40'!
form: aBlock
	self form with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
heading
	"Defines header 1 to header 6."

	^ self brush: WAHeadingTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'ac 3/16/2005 14:14'!
heading: aBlock
	self heading with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 7/10/2007 12:17'!
heading: anObject level: anInteger
	self deprecatedApi.
	self heading level: anInteger; with: anObject! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
horizontalRule
	"Defines a horizontal rule."

	^ self brush: WAHorizontalRuleTag new! !

!WAHtmlCanvas methodsFor: 'public' stamp: 'pmm 11/20/2007 15:45'!
html: aString
	"Emit aString unescaped onto the target document."

	self flush.
	self document nextPutAll: aString toString! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'pmm 1/3/2008 16:59'!
iframe
	^ self brush: WAIframeTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 10/28/2007 14:42'!
image
	"Defines an image."

	^ self brush: WAImageTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'mb 3/24/2006 13:51'!
image: aBlock
	self image with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 10/28/2007 14:42'!
imageForm: aForm
	self deprecatedApi.
	self image form: aForm! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:02'!
inserted
	"Defines inserted text."

	^ self brush: (WAEditTag tag: 'ins')! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 3/28/2007 10:41'!
inserted: aBlock
	self inserted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
keyboard
	"Defines keyboard text."

	^ self tag: 'kbd'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
keyboard: aBlock
	self keyboard with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'pmm 12/18/2007 20:41'!
keyboardInput
	"Keyboard, text to be entered by the user.
	This selector has been renamed"

	self deprecatedApi.
	^ self keyboard! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'pmm 12/18/2007 20:46'!
keyboardInput: aBlock
	self deprecatedApi.
	self keyboard: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
label
	"Defines a label for a form control."

	^ self brush: WALabelTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'avi 6/3/2005 15:40'!
label: aBlock
	self label with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
legend
	"Defines a title in a fieldset."

	^ self tag: 'legend'! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'mb 3/8/2006 18:00'!
legend: aBlock
	self legend with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
listItem
	"Defines a list item."

	^ self tag: 'li'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'avi 6/3/2005 15:40'!
listItem: aBlock
	self listItem with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 10/28/2007 14:42'!
map
	"Defines an anchor to be used around an image."

	^ self brush: WAImageMapTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 4/9/2007 17:47'!
map: aBlock
	self map with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
object
	"Defines an embedded object."

	^ self brush: WAObjectTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'pmm 2/11/2007 19:31'!
object: aBlock
	self object with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
orderedList
	"Defines an ordered list."

	^ self brush: WAOrderedListTag new! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 9/25/2005 11:52'!
orderedList: aBlock
	self orderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
paragraph
	"Defines a paragraph."

	^ self tag: 'p'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'avi 6/3/2005 15:40'!
paragraph: aBlock
	self paragraph with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
parameter
	"Defines a parameter for an object."

	^ self brush: WAParameterTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 2/13/2007 00:12'!
parameter: aBlock
	self parameter! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'ac 7/3/2005 15:46'!
popupAnchor
	^ self brush: WAPopupAnchorTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 7/10/2007 12:12'!
popupAnchor: aBlock
	self popupAnchor with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
preformatted
	"Defines preformatted text."

	^ self tag: 'pre'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'avi 6/3/2005 15:40'!
preformatted: aBlock
	self preformatted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
quote
	"Defines a short quotation."

	^ self tag: 'q'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
quote: aBlock
	self quote with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
ruby
	^ self tag: 'ruby'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
ruby: aBlock
	self ruby with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyBase
	^ self tag: 'rb'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyBase: aBlock
	self rubyBase with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyBaseContainer
	^ self tag: 'rbc'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyBaseContainer: aBlock
	self rubyBaseContainer with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses
	^ self tag: 'rp'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses: aBlock
	self rubyParentheses with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyText
	^ self brush: WARubyTextTag new! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyText: aBlock
	self rubyText with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyTextContainer
	^ self tag: 'rtc'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyTextContainer: aBlock
	self rubyTextContainer with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
sample
	"Defines sample computer code."

	^ self tag: 'samp'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
sample: aBlock
	self sample with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'pmm 12/18/2007 20:41'!
sampleOutput
	"Sample output, from a program or script.
	This selector has been renamed."

	self deprecatedApi.
	^ self sample! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 7/10/2007 12:13'!
sampleOutput: aBlock
	self deprecatedApi.
	self sampleOutput with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
script
	"Defines a script."

	^ self brush: WAScriptTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'avi 6/3/2005 15:40'!
script: aBlock
	self script with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
small
	"Defines small text."

	^ self tag: 'small'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'avi 6/3/2005 15:40'!
small: aBlock
	self small with: aBlock! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'mb 10/31/2006 16:13'!
space
	self html: self spaceEntity! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'lr 8/20/2007 21:34'!
space: anInteger
	anInteger timesRepeat: [ self space ]! !

!WAHtmlCanvas methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
spaceEntity
	"The HTML entity representing a space. To be subclassed as needed."

	^ '&nbsp;'! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'lr 10/28/2007 14:42'!
span
	"Defines a section in a document."

	^ self tag: 'span'! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'avi 6/3/2005 15:40'!
span: aBlock
	self span with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
strong
	"Defines strong text."

	^ self tag: 'strong'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'ac 3/20/2005 01:24'!
strong: aBlock
	self strong with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
subscript
	"Defines subscripted text."

	^ self tag: 'sub'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:46'!
subscript: aBlock
	self subscript with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
superscript
	"Defines superscripted text."

	^ self tag: 'sup'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:46'!
superscript: aBlock
	self superscript with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
table
	"Defines a table."

	^ self brush: WATableTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 4/9/2007 17:05'!
table: aBlock
	self table with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableBody
	"Defines a table body."

	^ self tag: 'tbody'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableBody: aBlock
	self tableBody with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableCaption
	"Defines a table caption."

	^ self tag: 'caption'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/8/2006 16:17'!
tableCaption: aBlock
	self tableCaption with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableColumn
	"Defines attributes for table columns."

	^ self brush: WATableColumnTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/7/2006 20:27'!
tableColumn: aBlock
	self tableColumn with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableColumnGroup
	"Defines groups of table columns."

	^ self brush: WATableColumnGroupTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/7/2006 20:27'!
tableColumnGroup: aBlock
	self tableColumnGroup with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableData
	"Defines a table cell."

	^ self brush: WATableDataTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableData: aBlock
	self tableData with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableFoot
	"Defines a table footer."

	^ self tag: 'tfoot'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 4/9/2007 17:06'!
tableFoot: aBlock
	^ self tableFoot with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableHead
	"Defines a table header."

	^ self tag: 'thead'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableHead: aBlock
	self tableHead with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableHeading
	"Defines a table header."

	^ self brush: WATableHeadingTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'ac 3/16/2005 16:15'!
tableHeading: aBlock
	self tableHeading with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableRow
	"Defines a table row."

	^ self tag: 'tr'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableRow: aBlock
	self tableRow with: aBlock! !

!WAHtmlCanvas methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
tag: aString
	"Defines a generic tag with the name aString."

	^ self brush: (WAGenericTag tag: aString)! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
teletype
	"Defines teletype text."

	^ self tag: 'tt'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
teletype: aBlock
	self teletype with: aBlock! !

!WAHtmlCanvas methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
text: anObject
	"Emit anObject onto the target document."

	self flush.
	self document print: anObject! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
unorderedList
	"Defines an unordered list."

	^ self brush: WAUnorderedListTag new! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'avi 6/3/2005 15:40'!
unorderedList: aBlock
	self unorderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
variable
	"Defines a variable."

	^ self tag: 'var'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'pmm 9/30/2006 20:06'!
variable: aBlock
	self variable with: aBlock! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'pmm 5/10/2007 10:16'!
withLineBreaks: aString
	"Renders text preserving line breaks."
	| stream |
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [
		self text: stream nextLine.
		stream atEnd ifFalse: [ self break ] ]! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'avi 6/23/2006 10:16'!
withLineBreaksAndUrls: aString
	| stream |
	aString ifNil: [^ self].
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self withUrls: stream nextLine.
		stream atEnd ifFalse: [self break]]! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
withUrls: aString
	| stream url |
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [
		self text: (stream upToAndSkipThroughAll: 'http://').
			stream atEnd ifFalse: [
				url := 'http://', (stream upTo: Character space).
				self anchor
					url: url;
					with: url.
				self text: ' '] ]! !

WAHtmlCanvas subclass: #WARenderCanvas
	instanceVariableNames: 'context callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WARenderCanvas commentStamp: 'pmm 4/20/2007 11:35' prior: 0!
This canvas knows about callbacks and is intertwined with the rest of the framework.!

!WARenderCanvas class methodsFor: 'instance creation' stamp: 'avi 6/13/2004 00:59'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 10/28/2007 14:42'!
button
	^ self brush: WAButtonTag new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
callbacks
	"Answer the callback registry."

	^ callbacks! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 10/28/2007 14:42'!
cancelButton
	^ self brush: WACancelButtonTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
checkbox
	^ self brush: WACheckboxTag new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
context
	"Answer the rendering context."

	^ context! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:09'!
dateInput
	^ self brush: WADateInput new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
document
	"Answer the XHTML document."

	^ self context document! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
fileUpload
	^ self brush: WAFileUploadTag new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'avi 1/9/2006 21:52'!
form
	^ self brush: WAFormTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
hiddenInput
	^ self brush: WAHiddenInputTag new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 10/28/2007 14:42'!
imageButton
	^ self brush: WAImageButtonTag new! !

!WARenderCanvas methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 01:01'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context := aRenderingContext.
	callbacks := aCallbackStore! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
multiSelect
	^ self brush: WAMultiSelectTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 6/6/2007 18:00'!
multiSelect: aBlock
	^ self multiSelect with: aBlock! !

!WARenderCanvas methodsFor: 'public' stamp: 'lr 3/28/2006 20:16'!
nextId
	^ 'id' , context advanceKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
option
	^ self brush: WAOptionTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:14'!
option: aBlock
	^ self option with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
optionGroup
	^ self brush: WAOptionGroupTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'pmm 4/24/2007 10:52'!
optionGroup: aBlock
	^ self optionGroup with: aBlock! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
painter
	"Answer the component that is supposed to paint this canvas."

	^ callbacks owner! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
passwordInput
	^ self brush: WAPasswordInputTag new! !

!WARenderCanvas methodsFor: 'public' stamp: 'mb 3/31/2006 11:38'!
peekNextId
	^ 'id' , context nextKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
radioButton
	^ self brush: WARadioButtonTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:46'!
radioButton: aBlock
	^ self radioButton with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 11:29'!
radioGroup
	^ WARadioGroup canvas: self! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:44'!
radioGroup: aBlock
	^ aBlock value: self radioGroup! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
select
	^ self brush: WASelectTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'pmm 4/24/2007 11:07'!
select: aBlock
	^ self select with: aBlock! !

!WARenderCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
submitButton
	^ self brush: WASubmitButtonTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/22/2005 17:50'!
textArea
	^ self brush: WATextAreaTag new! !

!WARenderCanvas methodsFor: 'tags-input' stamp: 'lr 4/9/2007 17:20'!
textInput
	^ self brush: WATextInputTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:10'!
timeInput
	^ self brush: WATimeInput new! !

!WARenderCanvas methodsFor: 'public' stamp: 'lr 5/23/2007 19:57'!
urlForAction: aBlock
	"Answer an action URL that will evaluate aBlock when beeing requested."

	^ self context actionUrl withParameter: (self callbacks registerActionCallback: aBlock)! !

WAHtmlCanvas subclass: #WAStaticHtmlCanvas
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WAStaticHtmlCanvas commentStamp: 'pmm 4/15/2007 22:10' prior: 0!
This canvas can be used to generate static/RESTful HTML pages.!

!WAStaticHtmlCanvas class methodsFor: 'instance creation' stamp: 'avi 9/10/2005 17:20'!
document: aDocument
	^ self basicNew initializeWithDocument: aDocument! !

!WAStaticHtmlCanvas class methodsFor: 'instance creation' stamp: 'lr 3/26/2007 21:30'!
root: anHtmlRoot
	^ self document: WAHtmlStreamDocument new! !

!WAStaticHtmlCanvas methodsFor: 'accessing' stamp: 'avi 9/10/2005 17:20'!
document
	^ document! !

!WAStaticHtmlCanvas methodsFor: 'accessing' stamp: 'ac 6/9/2006 12:42'!
document: aDocument
	document := aDocument! !

!WAStaticHtmlCanvas methodsFor: 'initialize-release' stamp: 'avi 9/10/2005 17:20'!
initializeWithDocument: aDocument
	document := aDocument! !

!WAStaticHtmlCanvas methodsFor: 'form-elements' stamp: 'ac 6/10/2006 18:52'!
textArea
	^ self brush: WATextAreaTag new! !

Object subclass: #WAClosingConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAClosingConditionalComment methodsFor: 'printing' stamp: 'lr 3/27/2007 11:37'!
encodeOn: aDocument
	aDocument nextPutAll: '<!![endif]-->'! !

Object subclass: #WAClosingRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAClosingRevealedConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:55'!
encodeOn: aDocument
	aDocument nextPutAll: '<!!--<!![endif]-->'! !

Object subclass: #WAConditionalComment
	instanceVariableNames: 'condition root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAConditionalComment commentStamp: 'pmm 11/25/2007 21:49' prior: 0!
A WAConditionalComment is an implementation of Downlevel-hidden Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
These are only visible for the IE family of browsers.!

!WAConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:37'!
root: anHtmlRoot
	^self new initializeWithRoot: anHtmlRoot! !

!WAConditionalComment methodsFor: 'private' stamp: 'lr 3/27/2007 11:36'!
addToCondition: aString
	condition := condition , aString! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:51'!
closingConditionClass
	^WAClosingConditionalComment! !

!WAConditionalComment methodsFor: 'public' stamp: 'pmm 11/25/2007 21:51'!
do: aBlock
	root add: (self openingConditionClass condition: condition).
	aBlock value.
	root add: (self closingConditionClass new)! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:19'!
equal
	"implicit of nothing else"! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:14'!
greaterThan
	self addToCondition: ' gt'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie
	self addToCondition: ' IE'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie5
	self addToCondition: ' IE 5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie50
	self addToCondition: ' IE 5.0'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie55
	self addToCondition: ' IE 5.5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie6
	self addToCondition: ' IE 6'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie7
	self addToCondition: ' IE 7'! !

!WAConditionalComment methodsFor: 'initialization' stamp: 'pmm 10/11/2006 17:36'!
initializeWithRoot: anHtmlRoot
	root := anHtmlRoot.
	condition := 'if'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:15'!
lessThan
	self addToCondition: ' lt'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'tbn 11/21/2007 12:41'!
not
	self addToCondition: ' !!'! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:51'!
openingConditionClass
	^WAOpeningConditionalComment! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/19/2006 20:19'!
orEqual
	self addToCondition: 'e'! !

WAConditionalComment subclass: #WARevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WARevealedConditionalComment commentStamp: 'pmm 11/25/2007 21:50' prior: 0!
A WAConditionalComment is an implementation of Downlevel-revealed Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
Non-IE family browsers see them always.!

!WARevealedConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:55'!
closingConditionClass
	^WAClosingRevealedConditionalComment! !

!WARevealedConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:55'!
openingConditionClass
	^WAOpeningRevealedConditionalComment! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAConfiguration commentStamp: 'rew 10/7/2007 12:50' prior: 0!
A configuration for a Seaside application contains attributes which can be used by Seaside and the application. WAConfiguration hierarchy uses the composite pattern. Subclasses of WASystemConfiguration define related groups of attributes. A WASystemConfiguration subclass defines the name and optionally default values for attributes. See WASystemConfiguration class comment for information on defining your own group of attributes. WAUserConfiguration is a composite of configurations. The set of configurations contained in WAUserConfiguration is called the ancestors. Attribute values in a configuration override the attribute values in the ancestors. WAUserConfiguration also holds the non-default values of attributes.

Seaside applications start with a WAUserConfiguration (see WAApplication>>configuration) that start with three configurations (WARenderLoopConfiguration, WAGlobalConfiguration and WASessionConfiguration). Other configurations can be added to an application on the Seaside configuration page for the application or in your application. Values for the attributes can be given in either location. 

See Seaside documentation (http://www.seaside.st/documentation) on configuration and preferences (http://www.seaside.st/documentation/Configuration%20and%20Preferences) for more information.

Example of setting attributes and adding configurations in code
ASubclassOfWAComponent class>>initialize
	"self initialize"
	| application |
	application := self registerAsApplication: 'GlorpExample'.
	"set a standard attribute"
	application preferenceAt: #sessionClass put: Glorp.WAGlorpSession. 

	"add a configuration"
	application configuration addAncestor: GlorpConfiguration new.
	application preferenceAt: #databaseLogin put: 'foo'. "set attribute defined in GlorpConfiguration"

Subclasses must implement the following messages:
	name
		return the name of the configuration

	localValueAt:ifAbsent:
		return the value of the attribute given as first argument!

!WAConfiguration class methodsFor: 'instance creation' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:27'!
addAncestorsTo: tempCollection linearization: linearCollection
	(linearCollection includes: self)
		ifTrue: [tempCollection do: [:ea | linearCollection add: ea before: self].
				tempCollection removeAllSuchThat: [:ea | true]]
		ifFalse: [tempCollection add: self.
				self ancestors isEmpty
					ifTrue: [linearCollection addAll: tempCollection.
							tempCollection removeAllSuchThat: [:ea | true]]
					ifFalse: [self ancestors do: [:ea | ea addAncestorsTo: tempCollection linearization: linearCollection]]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'lr 3/19/2007 19:25'!
allAncestors
	| temp linear |
	temp := OrderedCollection new.
	linear := OrderedCollection new.
	self addAncestorsTo: temp linearization: linear.
	^ linear removeFirst; asArray! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestorsDo: aBlock
	self allAncestors do: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
allAttributes
	^ Array streamContents:
		[:s |
		self withAllAncestorsDo: [:ea | s nextPutAll: ea attributes]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/24/2004 11:59'!
allPotentialAncestors
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ #()! !

!WAConfiguration methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
attributeNamed: aSymbol
	^ self allAttributes
		detect: [ :each | each key = aSymbol ]
		ifNone: [ self error: 'No attribute named ', aSymbol printString ]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 2/1/2004 17:34'!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:32'!
attributesAndValuesDo: keyValueBlock
	^ self allAttributes do:
		[:ea |
		keyValueBlock value: ea value: (self valueForAttribute: ea)]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
groupedAttributes
	| grops attributes |
	grops := Dictionary new.
	attributes := SortedCollection sortBlock: [ :a :b | a key <= b key].
	self allAttributes do: [ :each |
		(grops at: each group ifAbsentPut: [ SortedCollection sortBlock: [:a :b | a key <= b key ] ] )
			add: each ].
	grops associationsDo: [ :associaction |
		attributes add: associaction ].
	^ attributes! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 1/30/2004 16:21'!
hasAttributeNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea key = aSymbol]! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 2/3/2004 22:59'!
hasLocalValueForAttribute: anAttribute
	self localValueAt: anAttribute key ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 14:53'!
hasMutableAncestry
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
inheritedValueAndSourceAt: aSymbol do: aBlock
	self allAncestorsDo:
		[:ea |
		(ea localValueAt: aSymbol ifAbsent: [])
			ifNotNilDo: [:val | ^ aBlock value: val value: ea]].
	^ nil! !

!WAConfiguration methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
inheritsFrom: aConfiguration
	^ self allAncestors anySatisfy: [:ea | ea = aConfiguration]! !

!WAConfiguration methodsFor: 'initializing' stamp: 'lr 10/28/2007 14:42'!
initialize! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
localValueAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
lookupValueAt: aSymbol
	^ self inheritedValueAndSourceAt: aSymbol do: [:value :source | value]! !

!WAConfiguration methodsFor: 'accessing' stamp: 'avi 3/24/2004 11:55'!
name
	^ self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/23/2004 14:47'!
potentialAncestors
	^ self allPotentialAncestors reject: [:ea | ea = self or: [(self inheritsFrom: ea) or: [ea inheritsFrom: self]]]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
valueAt: aSymbol
	^ self localValueAt: aSymbol ifAbsent: [self lookupValueAt: aSymbol]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:59'!
valueForAttribute: anAttribute
	^ self valueAt: anAttribute key! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:28'!
withAllAncestorsDo: aBlock
	aBlock value: self.
	^ self allAncestorsDo: aBlock! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

!WASystemConfiguration commentStamp: 'rew 10/19/2007 10:54' prior: 0!
Subclass WASystemConfiguration to define a group of attributes for a Seaside application. The method "attributes" returns a collection of attributes in this configuration. If a configuration requires other configurations then implement the method "ancestors", which returns a collection of configuration classes. Subclasses can define default values for attributes. If you define an attribute named "useSessionCookie" you can provide a default value by implementing a method "useSessionCookie" that returns the default value. See existing subclasses for examples. Non-default values for attributes are not stored in WASystemConfiguration subclasses, but are stored in WAUserConfiguration.

WAUserConfiguration is a singleton class to avoid implementing = and hash. Only need one instance of WAUserConfiguration and its subclasses.

Subclasses must implement the following messages:
	attributes
		return a collection of attribute objects!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WAAuthConfiguration methodsFor: 'ancestry' stamp: 'lr 8/1/2007 20:19'!
ancestors
	^ Array with: WARenderLoopConfiguration new! !

!WAAuthConfiguration methodsFor: 'attributes' stamp: 'pmm 12/9/2007 12:24'!
attributes
	^ Array
		with: (WAStringAttribute
			key: #login
			group: #authentication
			comment: 'The username for this application.')
		with: (WAStringAttribute
			key: #password
			group: #authentication
			comment: 'The password for this application.')! !

!WAAuthConfiguration methodsFor: 'accessing' stamp: 'lr 4/18/2007 09:38'!
mainClass
	^ WAAuthMain! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: 'DeploymentMode'
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAGlobalConfiguration commentStamp: 'rew 10/19/2007 10:43' prior: 0!
WAGlobalConfiguration defines attributes (properties) about the Seaside server. It defines
 	server protocol (http, https) 
	host name
	port number 
	server path (first part of URL path, default "seaside" in Squeak "seaside/go" in WV, maps to 
		top level WADispatcher, if you change value make sure WADispatcher is configured correctly)
	deployment mode (false = development mode)

Note setting these attributes does not change the values the server using. Changing the first four changes how Seaside generates the URLs in pages returned to the client. 

By default all applications contain this configuration.!

!WAGlobalConfiguration class methodsFor: 'initialization' stamp: 'avi 3/16/2006 23:39'!
initialize
	DeploymentMode ifNil: [self setDevelopmentMode]! !

!WAGlobalConfiguration class methodsFor: 'configuration' stamp: 'avi 3/16/2006 23:35'!
setDeploymentMode
	DeploymentMode := true! !

!WAGlobalConfiguration class methodsFor: 'configuration' stamp: 'avi 3/16/2006 23:36'!
setDevelopmentMode
	DeploymentMode := false! !

!WAGlobalConfiguration methodsFor: 'attributes' stamp: 'pmm 12/9/2007 12:20'!
attributes
	^ Array
		with: ((WAListAttribute
			key: #serverProtocol
			group: #server
			comment: 'Overrides the protocol in URLs generated by Seaside to this value.') options: #(http https))
		with: (WAStringAttribute
			key: #serverHostname
			group: #server
			comment: 'Overrides the hostname in URLs generated by Seaside to this value.')
		with: (WANumberAttribute
			key: #serverPort
			group: #server
			comment: 'Overrides the port in URLs generated by Seaside to this value. The default of HTTP is 80, the default of HTTPS is 443.')
		with: (WAStringAttribute
			key: #serverPath
			group: #server
			comment: 'Overrides the path in URLs generated by Seaside to this value.')
		with: (WABooleanAttribute
			key: #deploymentMode
			comment: 'When in deployment mode, the development toolbar is disabled.')! !

!WAGlobalConfiguration methodsFor: 'defaults' stamp: 'avi 3/16/2006 23:35'!
deploymentMode
	^ DeploymentMode! !

!WAGlobalConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:00'!
serverPort
	^ 80! !

!WAGlobalConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:00'!
serverProtocol
	^ #http! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARenderLoopConfiguration methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
ancestors
	^ Array with: WASessionConfiguration new! !

!WARenderLoopConfiguration methodsFor: 'accessing' stamp: 'pmm 12/9/2007 12:23'!
attributes
	^ Array
		with: ((WAListAttribute
			key: #rootComponent
			comment: 'The root component of this seaside application.') options: self rootComponents)
		with: (WAStringAttribute
			key: #resourceBaseUrl
			group: #server
			comment: 'Sets the base URL for URLS generated with #resourceUrl:')! !

!WARenderLoopConfiguration methodsFor: 'defaults' stamp: 'lr 1/3/2008 12:26'!
errorHandler
	^ WASimpleErrorHandler! !

!WARenderLoopConfiguration methodsFor: 'defaults' stamp: 'lr 4/20/2007 15:00'!
mainClass
	^ WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'defaults' stamp: 'lr 11/18/2007 15:30'!
rootComponents
	^ (WAComponent allSubclasses select: [ :each | each canBeRoot ])
		asSortedCollection: [ :a :b | a name <= b name ]! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WASessionConfiguration commentStamp: 'pmm 10/20/2007 23:33' prior: 0!
WASessionConfiguration defines attributes with default values about the Seaside session used by an application. 
It defines 
	sessionClass (WASession or subclass)	
	mainClass   (a subclass of WAMain)
	errorHandler	(a subclass of WAErrorHander)	
	renderContinuationClass (WARenderContinuation or subclass)
	redirectContinuationClass (WARedirectContinuation or subclass)
	useSessionCookie (
		true:
			put session id in cookie if client supports cookies
		false:
			put session id in all urls returned in the _s parameter
		default:
			false)

This configuration is added to all applications by default.!

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 1/3/2008 13:21'!
allDecorationClasses
	^ WADecoration allSubclasses asSortedCollection: [ :a :b | a name < b name ]! !

!WASessionConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: WAGlobalConfiguration new! !

!WASessionConfiguration methodsFor: 'attributes' stamp: 'lr 1/3/2008 13:20'!
attributes
	^ OrderedCollection new
		add: (WANumberAttribute key: #sessionExpirySeconds);
		add: ((WAListAttribute key: #sessionClass)
			options: self sessionClasses);
		add: ((WAListAttribute key: #mainClass)
			options: self mainClasses);
		add: ((WAListAttribute key: #errorHandler)
			options: self errorHandlerClasses);
		add: ((WAListAttribute key: #redirectHandler)
			options: self redirectHandlerClasses);
		add: ((WAListAttribute key: #renderContinuationClass)
			options: self renderContinuationClasses);
		add: ((WAListAttribute key: #redirectContinuationClass)
			options: self redirectContinuationClasses);
		add: (WABooleanAttribute key: #useSessionCookie);
		add: ((WACollectionAttribute key: #libraries)
			options: self libraryClasses);
		add: ((WACollectionAttribute key: #decorationClasses)
			options: self allDecorationClasses);
		yourself! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 1/3/2008 13:19'!
decorationClasses
	^ #()! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 1/3/2008 12:25'!
errorHandler
	^ WASimpleErrorHandler! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 11/18/2007 15:18'!
errorHandlerClasses
	^ WAErrorHandler withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 11/18/2007 15:22'!
libraries
	^ Array with: WAStandardFiles! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 11/18/2007 15:18'!
libraryClasses
	^ WALibrary allSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 11/18/2007 15:18'!
mainClasses
	^ WAMain allSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 8/17/2007 09:56'!
redirectContinuationClass
	^ WARedirectContinuation! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 11/18/2007 15:18'!
redirectContinuationClasses
	^ WARedirectContinuation withAllSubclasses! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 10/11/2007 09:40'!
redirectHandler
	^ WARedirectHandler! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 10/11/2007 09:40'!
redirectHandlerClasses
	^ WARedirectHandler withAllSubclasses! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 8/17/2007 09:53'!
renderContinuationClass
	^ WARenderContinuation! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 8/17/2007 09:53'!
renderContinuationClasses
	^ WARenderContinuation withAllSubclasses! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:05'!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'lr 11/18/2007 15:19'!
sessionClasses
	^ WASession withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 2/2/2004 15:05'!
sessionExpirySeconds
	^ 600! !

!WASessionConfiguration methodsFor: 'defaults' stamp: 'avi 11/12/2005 21:42'!
useSessionCookie
	^ false! !

!WASystemConfiguration class methodsFor: 'accessing' stamp: 'lr 5/3/2006 09:44'!
instance
	^ instance ifNil: [ instance := self basicNew initialize ]! !

!WASystemConfiguration class methodsFor: 'instance creation' stamp: 'avi 11/16/2005 23:33'!
new
	^ self instance! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
attributes
	self subclassResponsibility! !

!WASystemConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 23:00'!
localValueAt: aSymbol ifAbsent: absentBlock
	^ (self respondsTo: aSymbol)
		ifTrue: [self perform: aSymbol]
		ifFalse: [absentBlock value]! !

!WASystemConfiguration methodsFor: 'accessing' stamp: 'avi 11/16/2005 23:31'!
name
	^ self class name! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'values ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAUserConfiguration commentStamp: 'rew 10/7/2007 12:55' prior: 0!
WAUserConfiguration is a composite of configurations.  This composite of configurations is stored in the field "ancestors". WAUserConfiguration also contains all the non-default values of attributes for an application. WAUserConfiguration inherits attribute values defined in its ancestors. If WAUserConfiguration does not have a value for an attribute it will search its ancestors for a value, stopping when it finds a value.

WAUserConfiguration is the first configuration added to a Seaside application (WAApplication). All other configurations added to the application are added as ancestors to WAUserConfiguration. When a value for an attribute is set either by the standard Seaside component configuration page or in code the value is added to the "values" dictionary in WAUserConfiguration.

Instance Variables:
	ancestors	<Collection of: WAConfiguration>	 hierarchy of configurations defining all attributes for this instance of WAUserConfiguration
	values	<Dictionary>	the dictionary key is an attribute key, dictionary value is value of that attribute 
!

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:39'!
addAncestor: aConfiguration
	(self inheritsFrom: aConfiguration)
		ifFalse: [ancestors add: aConfiguration]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:39'!
allPotentialAncestors
	^ WASystemConfiguration allSubclasses collect: [:ea | ea new]! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'avi 11/16/2005 23:39'!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'menu' stamp: 'lr 10/28/2007 14:42'!
clear
	values := Dictionary new! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:51'!
clearValueForAttribute: anAttribute
	values removeKey: anAttribute key ifAbsent: []! !

!WAUserConfiguration methodsFor: 'testing' stamp: 'avi 11/16/2005 23:39'!
hasMutableAncestry
	^ true! !

!WAUserConfiguration methodsFor: 'initialization' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	values := Dictionary new.
	ancestors := OrderedCollection new! !

!WAUserConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 14:51'!
localValueAt: aSymbol ifAbsent: errorBlock
	^ values at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
localValues
	| dict |
	dict := Dictionary new.
	self allAttributes do:
		[:attr | (self localValueAt: attr key ifAbsent: [nil])
			ifNotNilDo: [:value | dict at: attr key put: (attr stringForValue: value)]].

	^ dict! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:51'!
localValues: aDictionary
	self allAttributes do:
		[:attr | (aDictionary at: attr key ifAbsent: [nil])
			ifNotNilDo: [:string | self valueAt: attr key put: (attr valueFromString: string)]]! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:51'!
overrideAttribute: anAttribute
	self takeValue: (self valueForAttribute: anAttribute) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'copying' stamp: 'lr 12/12/2006 11:24'!
postCopy
	super postCopy.
	values := values copy.
	ancestors := ancestors collect: [ :each | each copy ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'avi 11/16/2005 23:39'!
removeAncestor: aConfiguration
	ancestors remove: aConfiguration ifAbsent: []! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'avi 3/23/2004 15:21'!
takeValue: anObject forAttribute: anAttribute
	^ anObject ifNotNil: [values at: anAttribute key put: anObject]! !

!WAUserConfiguration methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:51'!
valueAt: aSymbol put: anObject
	^ self takeValue: anObject forAttribute: (self attributeNamed: aSymbol)! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key group comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAConfigurationAttribute commentStamp: 'rew 10/7/2007 12:50' prior: 0!
WAConfigurationAttribute represents a value of a specified type in a Seaside application configuration. Some attributes are used are needed by Seaside for your application like deployment Mode and session timeout. Attributes like a database login may be used internally by the application.  

Each subclass of WAConfigurationAttribute handles one type (Number, Boolean, etc) of attribute. The "group" of the attribute is used to place all attributes in the same group together on the Seaside configuration page. The "key" of the attribute identifies the attribute. See WAConfiguration for example of accessing a configuration attribute. 

Subclasses must implement the following messages:
	valueFromString: aString
		convert "aString" into type represented by the class, return result of the conversion
	
	accept: aVisitor with: anObject
		Typical implementation is:
			aVisitor visitXXXAttribute: self with: anObject

		where XXX is the type of this attribute. The method visitXXXAttribute:with: must be implemented in all visitors, in particular WAConfigurationEditor which creates the configuration page for Seaside applications.

Instance Variables:
	group	<Symbol>	name of the group the attribute belongs to
	key	<Symbol>	key or name of the attribute, used to look up the attribute!

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WABooleanAttribute commentStamp: 'rew 10/7/2007 12:49' prior: 0!
WABooleanAttribute  represents a boolean attribute. It converts between text entered on the configuration page and boolean values.!

!WABooleanAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'converting' stamp: 'lr 10/28/2007 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]! !

!WAConfigurationAttribute class methodsFor: 'instance-creation' stamp: 'avi 2/5/2004 13:15'!
key: aSymbol
	^ self key: aSymbol group: nil! !

!WAConfigurationAttribute class methodsFor: 'instance-creation' stamp: 'pmm 12/9/2007 12:14'!
key: keySymbol comment: commentString
	^ self basicNew
		initializeWithKey: keySymbol
		group: nil
		comment: commentString! !

!WAConfigurationAttribute class methodsFor: 'instance-creation' stamp: 'pmm 12/9/2007 12:12'!
key: keySymbol group: groupSymbol
	^ self
		key: keySymbol
		group: groupSymbol
		comment: ''! !

!WAConfigurationAttribute class methodsFor: 'instance-creation' stamp: 'pmm 12/9/2007 12:11'!
key: keySymbol group: groupSymbol comment: commentString
	^ self basicNew
		initializeWithKey: keySymbol
		group: groupSymbol
		comment: commentString! !

!WAConfigurationAttribute methodsFor: 'visiting' stamp: 'lr 10/28/2007 14:42'!
accept: aVisitor with: anObject
	self subclassResponsibility! !

!WAConfigurationAttribute methodsFor: 'accessing' stamp: 'pmm 12/9/2007 12:10'!
comment
	^ comment! !

!WAConfigurationAttribute methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAConfigurationAttribute methodsFor: 'initialization' stamp: 'pmm 12/9/2007 12:11'!
initializeWithKey: keySymbol group: groupSymbol comment: commentString
	key := keySymbol.
	group := groupSymbol.
	comment := commentString! !

!WAConfigurationAttribute methodsFor: 'accessing' stamp: 'avi 1/30/2004 16:40'!
key
	^ key! !

!WAConfigurationAttribute methodsFor: 'converting' stamp: 'pmm 11/20/2007 15:40'!
stringForValue: anObject
	^ anObject toString! !

!WAConfigurationAttribute methodsFor: 'converting' stamp: 'lr 10/28/2007 14:42'!
valueFromString: aString
	self subclassResponsibility! !

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAListAttribute commentStamp: 'rew 10/7/2007 12:51' prior: 0!
WAListAttribute is an attribute that is restricted to a list of values. 

Instance Variables:
	options	<Collection of: (Object | String | Symbol)>	list of possible values for the attribute!

WAListAttribute subclass: #WACollectionAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WACollectionAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitCollectionAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:12'!
options
	^ options! !

!WAListAttribute methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:11'!
options: aCollection
	options := aCollection! !

!WAListAttribute methodsFor: 'converting' stamp: 'pmm 11/24/2007 17:15'!
valueFromString: aString
	^ self options
		detect: [ :each | each toString = aString ]
		ifNone: [ self error: 'No matching list option' ]! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WANumberAttribute commentStamp: 'rew 10/7/2007 12:51' prior: 0!
WANumberAttribute represents a number attribute. It converts between text entered on the configuration page and numbers.
!

!WANumberAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'converting' stamp: 'jf 2/8/2004 17:10'!
valueFromString: aString
	^ Number readFrom: aString! !

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAStringAttribute commentStamp: 'rew 10/7/2007 12:52' prior: 0!
WAStringAttribute represents a string attribute. It does the trivial conversion between text entered on the Seaside configuration page and a string.!

WAStringAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAPasswordAttribute commentStamp: 'rew 10/7/2007 12:52' prior: 0!
WAPasswordAttribute represents a password attribute. On the Seaside configuration page it displays the attribute differently than WAStringAttribute.
!

!WAPasswordAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitPasswordAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'converting' stamp: 'lr 5/3/2006 09:56'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !

Object subclass: #WACookie
	instanceVariableNames: 'key value path expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WACookie commentStamp: 'pmm 4/15/2007 22:26' prior: 0!
I represent a cookie, a piece of information that is stored on the client and read and writable by the server. I am basically a key/value pair of strings.
You can never trust information in a cookie, the client is free to edit it.
I model only a part of the full cookie specification.

For more information see  RFC2965 (http://tools.ietf.org/html/rfc2965)!

!WACookie class methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:59'!
key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself! !

!WACookie methodsFor: 'comparing' stamp: 'lr 4/18/2007 00:45'!
= other
	^ self species = other species
		and: [ self key = other key
		and: [ self path = other path ] ]! !

!WACookie methodsFor: 'api' stamp: 'avi 5/18/2004 23:13'!
expireIn: aDuration
	self expiry: DateAndTime now + aDuration! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
expiry
	^ expiry! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
expiry: aDateTime
	expiry := aDateTime asUTC! !

!WACookie methodsFor: 'private' stamp: 'pmm 11/20/2007 15:41'!
expiryString
	^ String streamContents: [ :stream |
		stream
			nextPutAll: (expiry dayOfWeekName first: 3);
			nextPutAll: ', ';
			nextPutAll: expiry dayOfMonth toString;
			nextPut: $-;
			nextPutAll: expiry monthName;
			nextPut: $-;
			nextPutAll: expiry year toString;
			space;
			nextPutAll: expiry hour24 toString;
			nextPut: $:;
			nextPutAll: expiry minute toString;
			nextPut: $:;
			nextPutAll: expiry second toString;
			nextPutAll: ' GMT']! !

!WACookie methodsFor: 'comparing' stamp: 'pmm 10/12/2006 16:53'!
hash
	^self key hash
		bitXor: self path hash! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:21'!
key
	^ key! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
key: aString
	key := aString! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
path
	^ path ifNil: ['/']! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
path: aString
	path := aString! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:21'!
value
	^ value! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
value: aString
	value := aString! !

!WACookie methodsFor: 'api' stamp: 'mb 2/27/2006 08:02'!
valueWithExpiry
	^ expiry
		ifNil: [self value]
		ifNotNil: [(self value ifNil: ['']), '; expires=', self expiryString]! !

!WACookie methodsFor: 'writing' stamp: 'lr 9/3/2007 21:20'!
writeOn: aStream
	aStream nextPutAll: self key; nextPut: $=; nextPutAll: (self value ifNil: [ '' ]).
	expiry isNil
		ifFalse: [ aStream nextPutAll: '; expires='; nextPutAll: self expiryString ].
	path isNil
		ifFalse: [ aStream nextPutAll: '; path='; nextPutAll: self path ]! !

Object subclass: #WAEncoder
	instanceVariableNames: 'stream table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

WAEncoder class
	instanceVariableNames: 'table'!

!WAEncoder commentStamp: 'lr 4/8/2007 15:49' prior: 0!
I encode everything that is written to myself using #nextPut: and #nextPutAll: onto the wrapped stream. To be efficient I use an encoding table to be able to transform the most used characters from the UTF Basic Multilingual Plane as efficiently as possible. The convertion of a single character is defined in #encode:on: on the class-side of my subclasses.!

WAEncoder class
	instanceVariableNames: 'table'!

!WAEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 13:42'!
encode: aCharacter on: aStream
	self subclassResponsibility! !

!WAEncoder class methodsFor: 'initialization' stamp: 'pmm 10/2/2007 22:02'!
initializeBMP
	"Initializes the BMP, the Basic Multilingual Plane of UTF characters, using the encoding strategy of the receiver. This chaching strategy ensures that most commonly used characters can be encoded as efficient as possible."

	| stream characterLimit |
	characterLimit := "find the maximum value of a character that we can instantiate, for Squeak 3.7 this is 255"
		[ Character value: 16rFFFF.
		16rFFFF ]
			on: Error
			do: [ 16rFF ].
	table := Array new: characterLimit.
	stream := WriteStream on: (String new: 6).
	1 to: characterLimit do: [ :index |
		self encode: (Character value: index - 1) on: stream reset.
		table at: index put: (stream position = 1
			ifTrue: [ stream contents first ]
			ifFalse: [ stream contents ]) ]! !

!WAEncoder class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 20:51'!
on: aStream
	^ self on: aStream table: table! !

!WAEncoder class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 20:29'!
on: aStream table: anArray
	^ self basicNew initializeOn: aStream table: anArray! !

!WAEncoder methodsFor: 'initialization' stamp: 'lr 3/26/2007 20:30'!
initializeOn: aStream table: anArray
	stream := aStream.
	table := anArray! !

!WAEncoder methodsFor: 'accessing' stamp: 'lr 4/8/2007 13:57'!
nextPut: aCharacter
	| value encoded |
	value := aCharacter asInteger.
	value < table size
		ifFalse: [ self class encode: aCharacter on: stream ]
		ifTrue: [
			encoded := table at: value + 1.
			encoded isString
				ifTrue: [ stream nextPutAll: encoded ]
				ifFalse: [ stream nextPut: encoded ] ]! !

!WAEncoder methodsFor: 'accessing' stamp: 'lr 4/8/2007 13:57'!
nextPutAll: aString
	| character value encoded |
	"uses #to:do: for speed reasons (on Squeak)
	this is not premature optimization, this is a hotspot method method
	and #to:do: shows measurable speed improvements for rendering seaside pages"
	1 to: aString size do: [ :index |
		character := aString at: index.
		value := character asInteger.
		value < table size
			ifFalse: [ self class encode: character on: stream ]
			ifTrue: [
				encoded := table at: value + 1.
				encoded isString
					ifTrue: [ stream nextPutAll: encoded ]
					ifFalse: [ stream nextPut: encoded ] ] ]! !

WAEncoder subclass: #WAHtmlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlEncoder commentStamp: 'lr 4/6/2007 19:45' prior: 0!
I encode XHTML text.!

!WAHtmlEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 14:05'!
encode: aCharacter on: aStream
	aCharacter = $" ifTrue: [ ^ aStream nextPutAll: '&quot;' ].
	aCharacter = $< ifTrue: [ ^ aStream nextPutAll: '&lt;' ].
	aCharacter = $& ifTrue: [ ^ aStream nextPutAll: '&amp;'].
	aCharacter = $> ifTrue: [ ^ aStream nextPutAll: '&gt;' ].
	aStream nextPut: aCharacter! !

!WAHtmlEncoder class methodsFor: 'initialization' stamp: 'lr 4/8/2007 14:01'!
initialize
	self initializeBMP! !

WAEncoder subclass: #WAUrlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAUrlEncoder commentStamp: 'lr 4/6/2007 19:45' prior: 0!
I encode path segments and arguments of an URL.!

!WAUrlEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 15:42'!
encode: aCharacter on: aStream
	| value |
	('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: aCharacter)
		ifTrue: [ ^ aStream nextPut: aCharacter ].
	aCharacter = Character space
		ifTrue: [ ^ aStream nextPut: $+ ].
	value := aCharacter asInteger.
	[ aStream nextPut: $%; nextPutAll: (((value \\ 256) printStringBase: 16) padded: #left to: 2 with: $0).
	  value := value // 256.
	  value = 0 ] whileFalse! !

!WAUrlEncoder class methodsFor: 'initialization' stamp: 'lr 4/8/2007 15:43'!
initialize
	self initializeBMP! !

Object subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAErrorHandler commentStamp: 'pmm 5/27/2007 21:46' prior: 0!
Error handlers are invoked when an error in a Seaside application occurs. They handle
- errors
- warnings
- internal errors in the Seaside core

I am the base class for all error handlers and handle only internal errors which which I display a code 500 error with a short stackframe.

See WAWalkbackErrorHandler for examples of how to do rendering with the canvas API.!

!WAErrorHandler class methodsFor: 'actions' stamp: 'avi 3/28/2004 21:22'!
handleError: anError
	^ self new handleError: anError! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'avi 3/28/2004 21:23'!
handleWarning: aWarning
	^ self new handleWarning: aWarning! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'pmm 2/24/2007 22:13'!
internalError: anError
	^ self new internalError: anError! !

!WAErrorHandler methodsFor: 'actions' stamp: 'lr 4/20/2007 14:41'!
handleError: anError
	anError pass! !

!WAErrorHandler methodsFor: 'actions' stamp: 'avi 2/2/2004 16:54'!
handleWarning: aWarning
	self handleError: aWarning! !

!WAErrorHandler methodsFor: 'actions' stamp: 'lr 4/20/2007 14:42'!
internalError: anError
	^ WAResponse internalError: anError! !

WAErrorHandler subclass: #WASimpleErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WASimpleErrorHandler commentStamp: 'pmm 5/27/2007 21:48' prior: 0!
I am like WAErrorHandler except that I display the code 500 error with a short stackframe for errors and warnings too.!

!WASimpleErrorHandler methodsFor: 'actions' stamp: 'lr 4/20/2007 15:21'!
handleError: anError
	WACurrentSession value
		returnResponse: (WAResponse internalError: anError)! !

Object subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAFile commentStamp: 'pmm 4/15/2007 22:22' prior: 0!
I represent a file that was uploaded by the user via #fileInput.!

!WAFile methodsFor: 'accessing' stamp: 'avi 4/28/2004 11:13'!
contentType
	^ contentType! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:07'!
contentType: aMimeTypeOrString
	contentType := aMimeTypeOrString toMimeType! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:39'!
contents
	"Answer a ByteArray"
	^ contents! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:37'!
contents: aByteArray
	contents := aByteArray! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 7/24/2007 22:03'!
fileName
	"compensate for windows explorer behavior"
	^ self isWindowsPath
		ifTrue: [ fileName copyAfterLast: $\ ]
		ifFalse: [ fileName ]! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:21'!
fileName: aString
	fileName := aString! !

!WAFile methodsFor: 'private' stamp: 'pmm 7/24/2007 22:02'!
isWindowsPath
	"'#:\*' match: fileName is broken on Squeak for WideString arguments"
	^fileName notEmpty
		and: [ fileName first isLetter
		and: [ fileName size >= 3
		and: [ (fileName copyFrom: 2 to: 3) = ':\' ] ] ]! !

Object subclass: #WAHtmlBuilder
	instanceVariableNames: 'canvasClass fullDocument documentRoot rootBlock callbackOwner rootClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WAHtmlBuilder commentStamp: 'pmm 8/18/2007 12:40' prior: 0!
A WAHtmlBuilder is a convenience class to render html. I am supposed to be used like this.

WARenderCanvas builder render: [ :html |
	html anchor
		url: 'htttp://www.seaside.st';
		with: 'Seaside Homepage' ]

See WAHtmlBuilderTest for more examples.

Instance Variables
	callbackOwner:		<Object>
	canvasClass:		<WACanvas class>
	documentRoot:		<WARoot>
	fullDocument:		<Boolean>
	rootBlock:			<BlockContext>

callbackOwner
	- optional, the owner of the callbacks

canvasClass
	- the canvas class to use, on the class side it must implement #context:callbacks: as an object construction method

documentRoot
	- for private use only, the instantiated root of the document

fullDocument
	- whether a full html document including the head section should be rendered

rootBlock
	- a one argement block to customize the document root. The argument of the block is the root
!

!WAHtmlBuilder class methodsFor: 'instance creation' stamp: 'pmm 8/31/2007 09:35'!
new
	^self basicNew initialize! !

!WAHtmlBuilder class methodsFor: 'instance creation' stamp: 'pmm 8/12/2007 11:58'!
on: aCanvasClass
	^self new
		canvasClass: aCanvasClass;
		yourself! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/16/2007 22:53'!
actionUrl
	^WAUrl new! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:10'!
callbackOwner
	^callbackOwner! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:10'!
callbackOwner: anObject
	callbackOwner := anObject! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 11:58'!
canvasClass
	^canvasClass! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
canvasClass: aClass
	canvasClass := aClass! !

!WAHtmlBuilder methodsFor: 'private' stamp: 'pmm 8/12/2007 11:54'!
closeDocument: aDocument
	self fullDocument ifTrue: [
		documentRoot close: aDocument ]! !

!WAHtmlBuilder methodsFor: 'private' stamp: 'pmm 8/12/2007 12:11'!
createCallbacksFor: aContext
	^self callbackOwner isNil
		ifTrue: [ nil ]
		ifFalse: [ aContext callbacksFor: self callbackOwner ]! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 11:53'!
fullDocument
	^fullDocument! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
fullDocument: aBoolean
	fullDocument := aBoolean! !

!WAHtmlBuilder methodsFor: 'initialize-release' stamp: 'pmm 8/31/2007 09:34'!
initialize
	self fullDocument: false! !

!WAHtmlBuilder methodsFor: 'private' stamp: 'pmm 8/16/2007 22:59'!
openDocumentDocument: aDocument context: aContext
	self fullDocument ifTrue: [
		documentRoot := self rootClass context: aContext.
		self rootBlock value: documentRoot.
		documentRoot open: aDocument ]! !

!WAHtmlBuilder methodsFor: 'rendering' stamp: 'pmm 8/16/2007 22:53'!
render: anObject
	^String streamContents: [ :stream |
		| context docRoot document html callbacks |
		document := (WAHtmlStreamDocument new) stream: stream.
		context := WARenderingContext new.
		context document: document.
		context actionUrl: self actionUrl.
		callbacks := self createCallbacksFor: context.
		html := self canvasClass context: context callbacks: callbacks.
		self openDocumentDocument: document context: context.
		html context document stream: stream.
		html render: anObject.
		html flush.
		self closeDocument: document ]! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:00'!
rootBlock
	rootBlock isNil ifTrue: [
		rootBlock := [ :html | ] ].
	^rootBlock! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:00'!
rootBlock: anObject
	rootBlock := anObject! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/16/2007 22:57'!
rootClass
	rootClass isNil ifTrue: [
		rootClass := WAHtmlRoot ].
	^rootClass! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/16/2007 22:58'!
rootClass: anHtmlRootClass
	rootClass := anHtmlRootClass! !

Object subclass: #WAHtmlDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlDocument class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 21:28'!
new
	^ self basicNew initialize! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 22:23'!
closeTag: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'initialization' stamp: 'lr 3/26/2007 21:28'!
initialize! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
nextPut: aCharacter
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
nextPutAll: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 21:38'!
openTag: aString
	self openTag: aString attributes: nil closed: false! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 21:38'!
openTag: aString attributes: anAttributes
	self openTag: aString attributes: anAttributes closed: false! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 22:23'!
openTag: aString attributes: anAttributes closed: aBoolean
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
print: anObject
	self subclassResponsibility! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'stream htmlEncoder urlEncoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlStreamDocument methodsFor: 'actions' stamp: 'lr 3/27/2007 11:47'!
close: aHtmlRoot
	aHtmlRoot close: self! !

!WAHtmlStreamDocument methodsFor: 'writing-xhtml' stamp: 'lr 4/9/2007 10:28'!
closeTag: aString
	stream nextPutAll: '</'.
	stream nextPutAll: aString.
	stream nextPut: $>! !

!WAHtmlStreamDocument methodsFor: 'accessing-encoders' stamp: 'lr 3/26/2007 20:22'!
htmlEncoder
	^ htmlEncoder! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:06'!
nextPut: aCharacter
	stream nextPut: aCharacter! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:07'!
nextPutAll: aString
	stream nextPutAll: aString! !

!WAHtmlStreamDocument methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
open: aHtmlRoot
	aHtmlRoot open: self! !

!WAHtmlStreamDocument methodsFor: 'writing-xhtml' stamp: 'lr 5/23/2007 10:49'!
openTag: aString attributes: anAttributes closed: aBoolean
	stream nextPut: $<.
	stream nextPutAll: aString.
	anAttributes encodeOn: self.
	aBoolean ifTrue: [ stream nextPut: $/ ].
	stream nextPut: $>! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:16'!
print: anObject
	anObject encodeOn: self! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:39'!
stream
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'lr 3/26/2007 20:42'!
stream: aStream
	stream := aStream.
	htmlEncoder := WAHtmlEncoder on: stream.
	urlEncoder := WAUrlEncoder on: stream! !

!WAHtmlStreamDocument methodsFor: 'accessing-encoders' stamp: 'lr 3/26/2007 20:22'!
urlEncoder
	^ urlEncoder! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'root attributes children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

WAHtmlElement subclass: #WABaseElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WABaseElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:26'!
tag
	^ 'base'! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
target: aString
	self attributeAt: 'target' put: aString! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
url: aString
	self attributeAt: 'href' put: aString! !

WAHtmlElement subclass: #WAContentElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAContentElement methodsFor: 'attributes' stamp: 'lr 3/27/2007 13:33'!
contents: aString
	self document: aString! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString
	self document: aString mimeType: self typeOrNil! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString fileName: fileName
	self document: aString mimeType: self typeOrNil fileName: fileName! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString mimeType: mimeType
	self document: aString mimeType: mimeType fileName: nil! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:33'!
document: aString mimeType: mimeType fileName: fileName
	self url: (root context urlForDocument: aString mimeType: mimeType fileName: fileName)! !

!WAContentElement methodsFor: 'testing' stamp: 'lr 11/5/2007 17:20'!
isClosed
	^ false! !

!WAContentElement methodsFor: 'attributes' stamp: 'lr 4/10/2007 09:55'!
resourceUrl: aString
	self url: (root context absoluteUrlForResource: aString)! !

!WAContentElement methodsFor: 'attributes' stamp: 'pmm 11/21/2007 20:48'!
type: aMimeTypeOrString
	self attributeAt: 'type' put: aMimeTypeOrString! !

!WAContentElement methodsFor: 'private' stamp: 'lr 3/27/2007 10:51'!
typeOrNil
	^ self attributeAt: 'type' ifAbsent:  [ nil ]! !

!WAContentElement methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
url: aString
	self subclassResponsibility! !

WAContentElement subclass: #WALinkElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WALinkElement commentStamp: 'pmm 4/7/2007 00:32' prior: 0!
This element defines a link. Unlike A, it may only appear in the HEAD section of a document, although it may appear any number of times. Although LINK has no content, it conveys relationship information that may be rendered by user agents in a variety of ways (e.g., a tool-bar with a drop-down menu of links).!

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAll
	self addMedia: 'all'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAural
	self addMedia: 'aural'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addBraille
	self addMedia: 'braille'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addHandheld
	self addMedia: 'handheld'! !

!WALinkElement methodsFor: 'media' stamp: 'lr 10/28/2007 14:42'!
addMedia: aString
	| media |
	media :=	(((attributes at: 'media' ifAbsent: [ '' ])
		findTokens: $,)
			collect: [ :each | each trimBlanks ])
				asSet.

	media add: aString.

	self media: (String streamContents: [ :stream |
		media
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream nextPutAll: ', ' ] ])! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addPrint
	self addMedia: 'print'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addProjection
	self addMedia: 'projection'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addScreen
	self addMedia: 'screen'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTeletype
	self addMedia: 'tty'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTelevision
	self addMedia: 'tv'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:54'!
beAlternate
	"Gives alternate representations of the current document."
	self relationship: 'alternate'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:14'!
beAlternateStylesheet
	self relationship: 'alternate stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beAppendix
	self relationship: 'appendix'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:56'!
beArchives
	"Provides a link to a collection of records, documents, or other materials of historical interest."
	self relationship: 'archives'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 11/21/2007 20:52'!
beAtom
	self type: 'application/atom+xml' toMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beBookmark
	self relationship: 'bookmark'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beChapter
	self relationship: 'chapter'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beClossary
	self relationship: 'lossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beCopyright
	self relationship: 'copyright'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 11/21/2007 20:52'!
beCss
	self type: 'text/css' toMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:05'!
beFirst
	"Indicates that the current document is a part of a series, and that the first document in the series is the referenced document."
	self relationship: 'first'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:17'!
beFontDefinition
	self relationship: 'fontdef'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:57'!
beGlossary
	self relationship: 'glossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beHelp
	self relationship: 'help'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beIndex
	self relationship: 'index'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beLast
	self relationship: 'last'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:58'!
beMicrosummary
	"http://wiki.mozilla.org/Microsummaries"
	self relationship: 'microsummary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
beNext
	"Indicates that the current document is a part of a series, and that the next document in the series is the referenced document."
	self relationship: 'next'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
bePrevious
	"Indicates that the current document is a part of a series, and that the previous document in the series is the referenced document."
	self relationship: 'previous'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 11/21/2007 20:52'!
beRss
	self type: 'application/rss+xml' toMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
beSearch
	"Gives a link to a resource that can be used to search through the current document and its related pages. "
	self relationship: 'search'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beSection
	self relationship: 'section'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:16'!
beShortcutIcon
	self relationship: 'shortcut icon'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:03'!
beStart
	"Refers to the first document in a collection of documents. This link type tells search engines which document is considered by the author to be the starting point of the collection."
	self relationship: 'start'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:58'!
beStylesheet
	"Imports a stylesheet."
	self relationship: 'stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beSubsection
	self relationship: 'subsection'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beTableOfContents
	self relationship: 'contents'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beTop
	self relationship: 'top'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:58'!
beUp
	"Provides a link to a document giving the context for the current document."
	self relationship: 'up'! !

!WALinkElement methodsFor: 'testing' stamp: 'lr 11/5/2007 17:20'!
isClosed
	^ children isEmptyOrNil! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:02'!
media: aString
	"This attribute specifies the intended destination medium for style information. It may be a single media descriptor or a comma-separated list. The default value for this attribute is 'screen'."
	self attributeAt: 'media' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:01'!
relationship: aString
	"This attribute describes the relationship from the current document to the anchor specified by the href(url) attribute. The value of this attribute is a space-separated list of link types."
	self attributeAt: 'rel' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:00'!
reverse: aString
	"This attribute is used to describe a reverse link from the anchor specified by the href attribute to the current document. The value of this attribute is a space-separated list of link types."
	self attributeAt: 'rev' put: aString! !

!WALinkElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:27'!
tag
	^ 'link'! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:09'!
title: aString
	self attributeAt: 'title' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'href' put: aString! !

WAContentElement subclass: #WAScriptElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAScriptElement methodsFor: 'types' stamp: 'pmm 11/25/2007 15:41'!
beJavascript
	self type: 'text/javascript' toMimeType! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 9/22/2007 07:36'!
defer
	"When set, this boolean attribute provides a hint to the user agent that the script is not going to generate any document content (e.g., no 'document.write' in javascript) and thus, the user agent can continue parsing and rendering."
		self attributeAt: 'defer' put: true! !

!WAScriptElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:27'!
tag
	^ 'script'! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAHtmlElement class methodsFor: 'instance-creation' stamp: 'lr 3/27/2007 13:26'!
root: aRoot
	^ self basicNew initializeWithRoot: aRoot! !

!WAHtmlElement methodsFor: 'accessing-children' stamp: 'lr 3/27/2007 10:47'!
add: anElement
	children ifNil: [ children := OrderedCollection new ].
	children add: anElement! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString
	^ self attributes at: aString! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString ifAbsent: aBlock
	^ self attributes at: aString ifAbsent: aBlock! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString put: anObject
	^ self attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'lr 3/21/2007 15:58'!
attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]! !

!WAHtmlElement methodsFor: 'accessing-children' stamp: 'lr 3/27/2007 10:47'!
childrenDo: aBlock
	children ifNotNil: [ children do: aBlock ]! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 3/27/2007 11:30'!
encodeOn: aDocument
	aDocument openTag: self tag attributes: attributes closed: self isClosed.
	self isClosed ifTrue: [ ^ self ].
	self childrenDo: [ :each | each encodeOn: aDocument ].
	aDocument closeTag: self tag! !

!WAHtmlElement methodsFor: 'initialization' stamp: 'lr 3/27/2007 13:26'!
initializeWithRoot: aRoot
	root := aRoot! !

!WAHtmlElement methodsFor: 'testing' stamp: 'lr 3/27/2007 11:24'!
isClosed
	^ true! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:24'!
tag
	self subclassResponsibility! !

!WAHtmlElement methodsFor: 'public' stamp: 'lr 11/5/2007 17:22'!
with: anObject
	self add: anObject! !

WAHtmlElement subclass: #WAMetaElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 10/7/2006 18:20'!
beLeftToRight
	self textDirection: 'LTR'! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 10/7/2006 18:20'!
beRightToLeft
	self textDirection: 'RTL'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
content: aString
	self attributeAt: 'content' put: aString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 11/21/2007 21:17'!
contentScriptType: aMimeTypeOrString
	self responseHeaderName: 'Content-Script-Type'.
	self content: aMimeTypeOrString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 11/21/2007 21:17'!
contentType: aMimeTypeOrString
	self responseHeaderName: 'Content-Type'.
	self content: aMimeTypeOrString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:18'!
language: aString
	self attributeAt: 'lang' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 11/20/2007 15:46'!
redirectAfter: seconds to: aString
	self responseHeaderName: 'refresh'.
	self content: seconds toString , ';URL=' , aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:25'!
responseHeaderName: aString
	self attributeAt: 'http-equiv' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
scheme: aString
	self attributeAt: 'scheme' put: aString! !

!WAMetaElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:26'!
tag
	^ 'meta'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:19'!
textDirection: aString
	self attributeAt: 'dir' put: aString! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WALRUCache commentStamp: 'pmm 10/20/2007 23:23' prior: 0!
WALRUCache implements at Least Recently Used cache. Items are removed from the cache when they reach "max" age. The age of an item is the number of additions to the cache done since the item itself was added. WALRUCache does not worry about the size of the cache. The "capacity:" method is misleading, it sets how long items will remain in the cache.

Instance Variables:
	ageTable	<Dictionary>	The age each time in the cache
	max	<SmallInteger>	The age at which items are removed from the cache
	table	<Dictionary>	Items in the cache, each item has key
			
WALRUCache is used to store the last n continutations of a session.

!

!WALRUCache class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WALRUCache class methodsFor: 'instance creation' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 3/19/2007 20:18'!
at: aKey
	^ self at: aKey ifAbsent: [ self error: 'No entry for ' , aKey ]! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 3/19/2007 20:37'!
at: aKey ifAbsent: anErrorBlock
	| result |
	result := table at: aKey ifAbsent: [ ^ anErrorBlock value ].
	ageTable at: result put: 0.
	^ result! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey put: aValue
	| removals |
	table at: aKey put: aValue.
	ageTable at: aValue put: 0.
	removals := OrderedCollection new.
	ageTable associationsDo: [ :assoc |
		assoc value > max
			ifTrue: [ removals add: assoc key ]
			ifFalse: [ assoc value: assoc value + 1 ] ].
	removals do: [ :each | self remove: each ]! !

!WALRUCache methodsFor: 'initialize-release' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max := aNumber! !

!WALRUCache methodsFor: 'initialize-release' stamp: 'lr 3/19/2007 20:16'!
initialize
	max := 20.
	table := Dictionary new.
	ageTable := Dictionary new! !

!WALRUCache methodsFor: 'testing' stamp: 'avi 1/31/2004 17:45'!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'callbacks' stamp: 'pmm 11/20/2007 15:46'!
nextKey
	| key |
	[ table includesKey: (key := WAExternalID new toString) ] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'removing' stamp: 'lr 10/28/2007 14:42'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache methodsFor: 'callbacks' stamp: 'lr 3/19/2007 20:43'!
store: anObject
	| key |
	key := self nextKey.
	self at: key put: anObject.
	^ key! !

Object subclass: #WALibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

WALibrary class
	instanceVariableNames: 'default'!

!WALibrary commentStamp: 'pmm 4/22/2007 12:56' prior: 0!
I'm the common superclass of file and string libraries.!

WALibrary class
	instanceVariableNames: 'default'!

WALibrary subclass: #WAFileLibrary
	instanceVariableNames: ''
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAFileLibrary commentStamp: 'pmm 8/17/2007 06:58' prior: 0!
What does FileLibrary do
=============================
It allows to serve static files directly from seaside without the need for a standalone server like Apache or to configure Kom. These files can reference each other (say a CSS references an image) and can be distrubuted the same way as normal Smalltalk code (Monticello, SqueakMap, ...).

Each file in a file library is represented by a method. The method name is created from the file name, the dot is removed and the first letter of the suffix in capitalized. This puts certain limitations to the allowed filenames. Eg. 'main.css' becomes #mainCss.

Like Script- and StyleLibraries FileLibraries can be added to an application so that they automatically include themselves in the document root. Implement #selectorsToInclude and return the selectors you whish to be added to the document root.

How to create a FileLibrary
================================
- First create the static files and put them in some directory. From there they can reference the other files in the same directory normally with their filenames.
- Make sure you have a "Files" entry that serves your files. This is a normal entry point type that you can find in your /seaside/config application. If you don't already have one, you can create it if you select "Files" in the type field of the "add entry point" dialog. For the rest of this text we assume you chose "files" as the path.
- Create a subclass of WAFileLibrary, for the rest of this text I assume its name is MyFileLibrary.
- To add the files to your file library there are two ways.
1. Programmatically with MyFileLibrary class >> #addAllFilesIn: / #addFileNamed:. For example MyFileLibrary addAllFilesIn: '/path/to/directory/with/files' or MyFileLibrary addFileNamed: '/path/to/background.png'.
2. Via the web interface. Go to your /seaside/config application and there click configure for your "Files". Click "configure" behind MyFileLibrary. There you can add a file by uploading it (select the file, then click "Add")

Note that a "Files" can consist of several file libraries and can even have tradional script or style libraries.

How to integrate a FileLibrary into your application
=============================================================
Files from a FileLibrary are ingetrated the same way other static files are integrated. They have a constant path that is '/seaside/<Static File Library>/<FileLibrary class name>/<filename>' so for example '/seaside/files/MyFileLibrary/background.png'. These can be conveniently generated by 'MyFileLibrary / #aSelector' where #aSelector is the name of the method representing that file. For example 'MyFileLibrary / #backgroundPng'.

How to get back the files in a FileLibrary
=================================================
The contents of a file library can be written out to disk. Writing out a file library first makes a folder with the name of the file library in the folder of your Smallatlk image. Then a file for each file in the file library is created in this folder. Writing out to disk can happen in three ways
1. MyFileLibrary default deployFiles
2. Via the configuration interface of the file library. On the same page where you can add files to your file library there is also a button 'write to disk' which will write out all the files in this library.
3. Via the configuration interface of your application. In the section where you can add libraries to your application there is a a button 'write to disk' which will write out all the libraries of this application.

Examples:
==========

The following code uses WAFileLibrary to add a CSS file to a page.

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: WAFileLibraryDemo / #mainCss
		
The folllowing code uses WAFileLibrary to display an image.

renderContentOn: html
	html image
		url: WAFileLibraryDemo / #mainJpg!

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/27/2007 20:35'!
/ aSymbol
	^self urlOf: aSymbol! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/4/2006 20:31'!
addAllFilesIn: aPathString
	"adds all files in the directory specified by aPathString to the current file library"
	(SeasidePlatformSupport filesIn: aPathString)
		do: [ :each | self addFileAt: each ]! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/5/2006 18:29'!
addFileAt: aPath
	"adds the file specified by aFilename to the current file library"
	self
		addFileAt: aPath
		contents: (SeasidePlatformSupport
			contentsOfFile: aPath
			binary: (self isBinaryAt: aPath))! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/4/2006 20:29'!
addFileAt: aPath contents: aByteArrayOrString
	self
		addFileNamed: (SeasidePlatformSupport localNameOf: aPath)
		contents: aByteArrayOrString! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
addFileNamed: aFilename contents: aByteArrayOrString
	| selector |
	selector := self asSelector: aFilename.
	(self isBinary: aFilename)
		ifTrue: [ self compileBinary: aByteArrayOrString selector: selector ]
		ifFalse: [ self compileText: aByteArrayOrString selector: selector ]! !

!WAFileLibrary class methodsFor: 'vw port-squeak' stamp: 'lr 10/28/2007 14:42'!
adjustForVisualWorks
	| newSource oldSource badCode goodCode |
	badCode := 'xxxCache := #(nil).'.
	goodCode := 'xxxCache := #(nil) beMutable.'.
	self selectors do: [:selector |
		oldSource := self sourceCodeAt: selector.
		(oldSource indexOfSubCollection: badCode startingAt: 1) > 0 ifTrue:
			[newSource := oldSource copyReplaceAll: badCode with: goodCode.
			self compile: newSource classified: self methodCategory]]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
asSelector: aFilename
	| mainPart extension |
	mainPart := (aFilename copyUpToLast: $.)
				reject: [:each | each isAlphaNumeric not].
	[mainPart first isDigit]
		whileTrue: [mainPart := mainPart allButFirst].
	extension := (aFilename copyAfterLast: $.) asLowercase capitalized.
	^ (mainPart , extension) asSymbol! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 5/22/2007 22:08'!
compileBinary: aByteArrayOrString selector: aSymbol
	"compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a byte array"
	| code |
	code := SeasidePlatformSupport asMethodReturningByteArray: aByteArrayOrString named: aSymbol.
	SeasidePlatformSupport compile: code into: self classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 11/20/2007 15:44'!
compileText: aByteArrayOrString selector: aSymbol
	"Compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a string literal.
	aSymbol
		^ aByteArrayOrString"
	| code |
	code := String streamContents: [ :stream |
		stream nextPutAll: aSymbol; cr.
		stream tab; nextPutAll: '^ '''.
		aByteArrayOrString toString do: [ :each |
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	SeasidePlatformSupport compile: code into: self classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 4/20/2006 20:52'!
defaultMimeType
	^ 'application/octet-stream'! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 9/6/2007 22:27'!
defaultMimeTypes
	^ #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htc' 'text/x-component'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash'

	)! !

!WAFileLibrary class methodsFor: 'class initialization' stamp: 'pmm 9/6/2007 22:28'!
initialize
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 1/4/2008 15:04'!
isBinary: aFilename
	^(self mimetypeFor: (aFilename copyAfterLast: $.)) isBinary! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
isBinaryAt: aPath
	^self isBinary: (SeasidePlatformSupport localNameOf: aPath)! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 4/7/2007 00:58'!
methodCategory
	"the method category for uploaded files"
	^#uploaded! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 15:03'!
mimetypeFor: aString
	^ (self mimetypes at: aString ifAbsent: [ self defaultMimeType ]) toMimeType! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:51'!
mimetypes
	^ MimeTypes! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/13/2007 18:03'!
register
	"no longer needed left in so that code can still be loaded since it is sent in class side initialize methods"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/16/2007 16:01'!
unregister
	"no longer used"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/16/2007 16:05'!
urlOf: aSymbol
	^self new urlOf: aSymbol! !

!WAFileLibrary methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
addFile: aFile
	"adds a file to the receiver

	aFile an instance of of WAFile"
	| contents |
	aFile isNil ifTrue: [ ^self "in case no file was selected for uploading" ].

	contents := (self class isBinary: aFile fileName)
		ifTrue: [ aFile contents ]
		ifFalse: [ SeasidePlatformSupport convertToSmalltalkNewlines: aFile contents ].
	self class addFileNamed: aFile fileName contents: contents! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 11/21/2007 14:28'!
asFilename: aSelector
	| dotIndex extension |
	dotIndex := self lastUpperCaseIndexIn: aSelector.
	dotIndex = 0
		"convert Symbol to String"
		ifTrue: [ ^ aSelector toString ].
	extension := (aSelector last: aSelector size - dotIndex + 1) asLowercase.
	^ (aSelector first: dotIndex - 1), '.', extension! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
asSelector: aFilename
	^ self class asSelector: aFilename! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
compileBinary: aString selector: aSymbol
	^self class compileBinary: aString selector: aSymbol! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
compileText: aString selector: aSymbol
	self class compileText: aString selector: aSymbol! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'pmm 4/22/2006 00:41'!
configurationComponent
	^ WAFileLibraryEditor new
		library: self;
		yourself! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/22/2007 07:21'!
fileSelectors
	^ (self class selectors
		select: [ :each | self isFileSelector: each ])
		removeAllFoundIn: self nonFileSelectors;
		yourself! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
isFileSelector: aSymbol
	^ aSymbol isUnary and: [ (self lastUpperCaseIndexIn: aSymbol) > 1 ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 2/18/2007 12:28'!
lastUpperCaseIndexIn: aString
	^ aString findLast: [ :each | each isUppercase ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:18'!
mimetypeForFile: aFilename
	^self class mimetypeFor: (aFilename copyAfterLast: $.)! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/22/2007 07:17'!
nonFileSelectors
	^#(
		nonFileSelectors
		selectorsToInclude
	)! !

!WAFileLibrary methodsFor: 'actions' stamp: 'pmm 4/21/2006 23:57'!
removeFile: aFilename
	SeasidePlatformSupport
		removeSelector: (self asSelector: aFilename)
		from: self class! !

!WAFileLibrary methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
renameFile: oldName to: newName
	| contents file |
	(self asSelector: oldName) = (self asSelector: newName)
		ifTrue: [ ^ nil ].
	contents := self perform: (self asSelector: oldName).
	file := WAFile new contents: contents.
	file fileName: newName.
	self addFile: file.
	self removeFile: oldName! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
selectorsToInclude
	"The files represented by the selectors this method returns will be automatically added to the html <head> if the receiver is added to the respective Seaside application.

	This makes only sense for CSS and JS files"
	^ #()! !

!WAFileLibrary methodsFor: 'processing' stamp: 'lr 4/9/2007 11:06'!
updateRoot: aHtmlRoot
	"Only override if you want to automatically include new types of resources. The default implementation knows how to reference CSS, JS and FavIcons into aHtmlRoot."

	self selectorsToInclude do: [ :each |
		(each endsWith: #Js)
			ifTrue: [ aHtmlRoot javascript url: (self urlOf: each) ].
		(each endsWith: #Ico)
			ifTrue: [ aHtmlRoot link beShortcutIcon; url: (self urlOf: each) ].
		(each endsWith: #Css)
			ifTrue: [ aHtmlRoot stylesheet url: (self urlOf: each) ] ]! !

WAFileLibrary subclass: #WAStandardFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAStandardFiles commentStamp: 'lr 6/5/2007 19:29' prior: 0!
A collection of standard scripts, styles, and images. They are needed for the configuration application and some basic look-and-feel in Seaside. The icons are from the Tango Desktop Project (tango.freedesktop.org), they are licensed under the Creative Commons Attribution Share-Alike license.!

!WAStandardFiles methodsFor: 'accessing-images' stamp: ''!
codebrowserPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 213 9 22 18 55 41 59 82 2 72 0 0 1 203 73 68 65 84 56 203 165 147 77 104 19 65 20 199 127 51 221 163 72 22 34 45 226 177 224 41 160 88 43 1 15 130 21 132 120 236 69 208 182 39 175 165 23 21 60 138 32 197 32 245 34 126 128 154 22 138 49 189 91 26 17 77 92 16 237 193 98 211 141 27 76 253 192 213 108 235 16 21 90 145 205 120 48 67 179 109 106 43 190 203 255 13 204 251 207 111 102 222 131 255 12 97 146 226 93 250 128 25 224 216 86 122 120 136 188 169 147 0 151 71 47 157 1 102 14 30 119 216 142 182 18 88 77 189 1 240 237 249 57 182 163 87 79 74 221 172 59 45 141 211 222 84 64 89 21 88 221 147 167 172 10 252 232 122 216 86 95 76 75 6 199 138 28 233 31 6 24 55 4 196 227 113 196 137 165 63 139 125 77 101 77 125 223 39 127 79 50 116 237 25 31 158 140 51 183 16 132 64 135 213 122 31 165 20 245 122 125 195 75 7 65 128 155 73 173 21 123 203 124 45 77 117 0 61 17 3 219 182 177 109 59 82 236 251 62 110 38 197 224 88 145 197 199 25 94 149 151 81 165 28 64 207 200 100 99 246 175 4 230 228 129 116 129 197 124 134 185 183 10 85 202 241 115 255 69 206 159 189 48 11 136 77 9 180 214 20 210 189 12 92 121 138 55 125 135 202 231 239 168 249 7 188 239 26 166 179 205 55 70 8 180 214 100 179 89 126 201 67 204 59 14 239 62 213 89 122 61 5 189 105 118 173 172 0 218 52 161 110 75 16 134 33 187 63 166 121 244 165 155 251 185 28 221 242 37 59 251 110 145 76 38 113 93 151 55 149 5 140 139 92 79 80 173 86 241 60 143 145 201 6 71 59 43 172 238 72 16 30 24 37 145 72 96 89 22 150 101 69 186 120 3 65 44 22 67 107 77 173 86 67 107 141 148 18 173 53 66 8 132 16 173 219 27 17 3 165 20 142 227 108 58 117 198 100 125 24 131 137 155 183 175 159 250 135 41 158 48 201 111 90 157 232 152 121 9 252 18 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!WAStandardFiles methodsFor: 'accessing-images' stamp: ''!
configPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 213 11 4 11 55 32 209 169 238 103 0 0 0 29 116 69 88 116 67 111 109 109 101 110 116 0 67 114 101 97 116 101 100 32 119 105 116 104 32 84 104 101 32 71 73 77 80 239 100 37 110 0 0 1 217 73 68 65 84 56 203 197 147 77 107 19 97 20 133 159 105 107 131 52 157 52 35 161 38 67 55 129 198 221 132 100 66 72 138 88 117 37 53 89 137 8 21 4 33 100 254 65 17 92 117 33 136 43 17 55 45 253 3 165 45 8 67 178 81 12 88 65 145 188 249 152 162 130 219 36 148 137 52 37 89 180 136 31 113 97 103 72 219 116 213 133 119 117 121 207 229 112 239 57 231 133 115 150 116 22 240 244 217 147 190 211 63 90 122 124 230 220 152 211 220 189 119 39 163 235 113 19 64 136 74 22 32 159 51 88 93 91 57 134 157 36 115 9 116 61 110 230 115 6 150 101 1 152 161 160 74 203 110 16 10 170 160 99 166 146 105 52 77 3 232 15 146 140 13 178 89 150 197 165 105 63 183 179 11 238 91 44 17 37 70 212 197 79 214 168 211 248 21 191 248 211 255 189 24 185 50 75 171 209 98 251 221 118 175 109 183 61 59 214 78 111 202 55 229 153 240 78 80 42 149 16 162 146 253 242 249 235 183 99 27 56 130 133 130 42 0 181 90 173 103 219 223 95 9 81 221 84 20 229 170 36 141 62 92 200 220 10 56 231 232 122 220 213 98 196 97 202 231 12 98 137 127 171 250 124 62 185 217 108 110 110 172 111 153 157 78 231 189 44 123 3 206 57 249 156 49 220 133 213 181 21 66 65 149 88 34 202 193 193 225 225 220 92 122 9 32 28 14 27 221 110 183 7 200 213 114 157 194 110 241 180 6 111 94 191 93 246 43 126 49 57 233 93 188 113 237 38 63 127 253 184 208 110 183 3 145 200 236 3 73 226 242 252 245 121 121 220 51 78 69 84 16 162 146 125 241 252 229 253 161 54 166 146 105 90 118 3 117 70 69 157 81 47 30 65 178 51 147 74 166 1 204 141 245 45 215 198 145 193 117 52 77 99 207 222 167 96 22 169 150 235 0 84 203 117 10 102 145 61 123 223 201 193 112 13 142 84 237 187 73 212 49 51 211 25 10 187 69 39 153 230 199 79 31 78 37 241 220 127 225 255 215 95 179 89 175 43 2 12 187 45 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'pmm 2/13/2007 19:16'!
externalAnchorsJs
	^ '// See http://www.sitepoint.com/article/standards-compliant-world
function externalLinks() {
	if (!!document.getElementsByTagName) return;
	var anchors = document.getElementsByTagName("a");
	for (var i=0; i<anchors.length; i++) {
	var anchor = anchors[i];
	if (anchor.getAttribute("href") && anchor.getAttribute("rel") == "external")
		anchor.target = "_blank";
	}
}'! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'lr 5/28/2007 17:49'!
haloCss
	^ '.halo {
	margin: 2px;
	border: 1px solid #aaa;
}

/* header */
.halo-header {
	overflow: hidden;
	padding: 2px;
	color: #444;
	background-color: #eee;
	border-bottom: 1px solid #aaa;
	font: 10pt Verdana, Arial, Helvetica, sans-serif;
}
.halo-header a {
	text-decoration: none;
}
.halo-header div {
	float: left;
}
.halo-header div.classnamehaloplugin,
.halo-header div.browserhaloplugin,
.halo-header div.inspectorplugin,
.halo-header div.styleshaloplugin {
	float: left;
	display: block;
	padding-right: 5px;
}
.halo-header div.browserhaloplugin {
	background: url(codebrowser.png) no-repeat;
}
.halo-header div.inspectorplugin {
	background: url(inspector.png) no-repeat;
}
.halo-header div.styleshaloplugin {
	background: url(styleeditor.png) no-repeat;
}
.halo-header div.browserhaloplugin a,
.halo-header div.inspectorplugin a,
.halo-header div.styleshaloplugin a {
	width: 16px;
	display: block;
	text-indent: -32000px;
	background-position: 0 50%;
	outline: none;
}
.halo-header div.modehaloplugin {
	float: right;
	display: block;
}
.halo-header div.modehaloplugin a {
	color: #444;
}
.halo-header div.modehaloplugin a:hover {
	color: #111;
}
.halo-header div.modehaloplugin a.active {
	font-weight: bold;
}

/* body */
.halo-body {
	clear: both;
	padding: 2px;
}

/* source */
.halo-source .tag-known {
	font-weight: bold;
	color: navy;
}
.halo-source .attribute-known {
	color: navy;
}
.halo-source .attribute-value {
	color: purple;
}
.halo-source .comment {
	font-style: italic;
	color: green;
}'! !

!WAStandardFiles methodsFor: 'accessing-images' stamp: ''!
inspectorPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 240 0 240 0 239 52 6 103 27 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 213 11 5 16 15 5 37 253 173 47 0 0 1 246 73 68 65 84 56 203 157 146 77 107 19 81 24 133 159 59 201 36 77 154 102 134 74 82 10 10 181 93 104 26 69 20 193 133 184 20 10 85 119 226 38 191 192 111 169 244 31 136 182 36 65 68 20 116 89 119 85 16 197 77 168 59 65 236 162 84 40 164 137 86 171 150 80 53 141 205 71 39 77 50 51 215 69 72 73 66 82 170 103 119 15 239 61 239 225 188 71 60 121 250 120 49 247 39 119 140 61 64 85 213 231 19 183 38 47 182 144 211 209 187 150 220 35 238 77 223 145 237 162 78 41 235 92 62 191 185 235 118 77 211 59 242 78 33 196 206 35 153 76 118 28 10 133 66 93 133 119 28 180 15 102 50 25 102 95 204 2 144 152 75 0 208 180 107 119 7 223 190 175 146 74 167 57 122 106 140 109 197 139 105 43 184 100 133 212 252 107 38 110 223 140 196 162 247 159 53 254 40 237 14 52 93 35 149 78 115 232 228 24 159 11 94 6 7 2 140 28 8 82 18 62 180 209 113 252 154 62 115 237 198 149 227 93 29 36 230 18 12 135 79 179 82 112 115 233 204 16 190 30 21 211 182 81 29 10 239 150 37 193 35 227 54 75 111 22 0 1 160 116 10 75 122 3 12 13 232 88 182 100 219 52 169 212 44 202 85 139 126 159 155 95 101 181 37 9 69 74 137 148 118 75 48 110 183 11 132 160 92 181 168 214 36 155 91 53 220 170 131 253 253 30 164 16 45 93 112 2 182 105 154 45 78 108 99 131 53 163 138 223 163 162 247 185 176 45 137 223 227 228 211 70 129 125 61 150 157 107 114 174 212 43 234 66 211 116 52 77 231 194 185 243 164 23 222 18 236 19 124 249 153 39 155 43 145 55 42 124 92 89 167 84 174 144 91 122 229 44 21 139 63 26 2 34 26 159 154 177 44 43 210 124 13 195 48 112 56 84 78 156 141 176 188 86 100 203 84 24 236 149 172 47 190 100 248 224 8 0 31 230 223 167 30 62 120 116 88 116 107 216 213 235 151 167 2 129 224 100 51 231 235 245 17 30 13 243 59 155 173 247 101 245 43 130 127 68 44 30 149 13 145 255 18 0 148 88 60 106 1 148 13 131 191 6 140 246 211 127 51 231 46 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'lr 10/28/2007 14:42'!
kalseyTabsCss
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}


.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!WAStandardFiles methodsFor: 'accessing-images' stamp: ''!
memoryPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 213 10 19 17 58 52 159 194 36 103 0 0 1 240 73 68 65 84 56 203 165 147 61 104 20 65 24 134 159 221 153 157 221 189 194 20 34 18 209 75 97 12 66 208 72 2 1 33 96 97 115 96 17 36 106 180 17 82 88 137 193 70 17 15 46 133 164 176 178 49 130 149 86 134 147 72 136 88 156 66 42 27 65 68 61 73 180 9 130 7 241 206 52 10 130 119 59 127 22 49 49 33 39 74 124 225 101 186 103 158 225 251 38 40 149 138 15 128 115 108 35 222 251 105 74 165 162 111 181 154 190 217 106 250 191 197 57 231 51 157 173 183 84 42 122 185 70 155 184 59 79 185 82 253 167 155 71 11 135 185 112 162 7 0 9 16 69 138 114 165 138 234 0 37 99 136 20 103 142 46 67 16 50 251 166 11 156 7 60 24 139 54 134 114 165 202 248 233 62 0 194 141 100 21 167 68 105 202 217 161 58 23 135 7 17 74 146 38 9 105 46 69 37 41 34 151 144 36 9 0 214 152 223 6 107 17 42 70 36 49 253 61 123 8 115 5 250 187 27 168 232 19 143 23 14 32 188 3 35 201 66 13 128 177 118 171 65 148 40 70 6 107 236 219 213 193 203 165 6 93 249 83 136 72 146 36 49 81 162 16 113 132 138 213 159 13 78 14 212 8 3 137 200 21 224 219 44 65 48 130 144 130 171 199 159 179 80 223 141 179 14 235 44 83 111 3 140 109 3 184 60 122 157 128 128 143 181 25 222 47 127 37 191 23 14 229 119 114 164 211 48 216 55 142 247 0 158 169 251 183 218 3 110 207 220 68 40 129 148 17 66 10 62 55 230 232 221 63 202 195 215 53 204 247 59 88 99 177 198 254 122 130 221 10 120 242 174 155 40 85 168 88 17 197 10 33 63 112 176 243 25 190 89 35 12 2 158 46 245 210 252 145 1 139 237 13 96 117 222 22 71 232 29 206 57 46 61 234 192 249 29 104 109 208 86 99 113 171 6 27 1 90 103 140 13 15 112 111 238 213 38 220 226 60 192 139 182 155 184 242 101 101 179 193 149 243 67 92 27 59 134 214 25 89 43 67 27 141 214 107 231 134 26 77 163 81 95 135 73 96 122 114 242 198 246 127 227 255 230 39 112 67 0 83 217 168 244 129 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'lr 10/28/2007 14:42'!
miscJs
	^ '
	function swapDisplay(a, b) {
		var tmp = document.getElementById(a).style.display;
		document.getElementById(a).style.display = document.getElementById(b).style.display;
		document.getElementById(b).style.display = tmp;
	}

	function submitFormTriggeringCallback(formName, callbackKey, value) {
		if (value)
			{
				var ele = document.createElement("input");
				ele.type = "hidden";
				ele.name = callbackKey;
				ele.value = value;
				document.forms[formName].appendChild(ele)
			}
		submitForm(formName)
	}

	function submitForm(formName) {
		document.forms[formName].submit();
	}

	function chooseOther(select, hiddenId, p) {
		value = prompt(p);
		document.getElementById(hiddenId).value = value;
		select.options[select.options.length-1].text = value;
	}

	function enableChoice(enableID, disableID) {
		document.getElementById(enableID).disabled = false;
		document.getElementById(disableID).disabled = true;
	}

	function setFocus(elementId) {
		document.getElementById(elementId).focus();
	}

	function setSelection(elementId, start, stop) {
		var input = document.getElementById(elementId);
		input.focus();
		/* When stop parameter not supplied, all field is selected */
		if (!!start) start = 1;
		if (!!stop) stop = input.value.length + 1;
		if (typeof document.selection !!= "undefined") {
	    		/* Place selection in MS-IE */
	    		var range = document.selection.createRange();
	     	range.moveStart("character", start - 1);
	     	range.moveEnd("character", stop - start);
	 		range.select();
	  	} else if (typeof input.selectionStart !!= "undefined") {
		  	/* Place selection in Gecko browsers */
	    		input.selectionStart = start - 1;
	    		input.selectionEnd = stop - 1;
	  	} else {
	  		/* Other browsers, please feel free to implement */
			alert("unknown browser");
		}
	}

'! !

!WAStandardFiles methodsFor: 'accessing-images' stamp: ''!
profilerPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 115 66 73 84 8 8 8 8 124 8 100 136 0 0 0 9 112 72 89 115 0 0 4 157 0 0 4 157 1 124 52 107 161 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 119 119 119 46 105 110 107 115 99 97 112 101 46 111 114 103 155 238 60 26 0 0 3 25 73 68 65 84 56 141 101 147 79 104 219 117 24 198 63 223 111 218 181 105 27 243 167 165 127 213 181 22 35 181 171 237 198 152 204 22 230 193 169 200 14 67 24 84 152 135 194 16 188 8 66 17 113 243 44 115 189 120 16 65 135 5 157 90 240 160 224 230 182 67 41 108 172 44 235 97 3 219 117 90 211 218 37 105 154 52 77 211 52 77 242 203 239 251 199 131 53 108 250 192 115 123 223 207 203 3 239 35 172 181 60 170 177 209 113 25 104 14 156 10 132 90 94 110 244 53 29 208 74 233 236 230 230 189 108 58 115 253 171 111 63 185 202 127 36 30 5 188 59 246 241 96 248 64 223 55 62 191 127 64 169 138 168 171 3 173 20 219 185 50 78 197 213 249 173 252 157 244 218 218 91 95 127 255 233 234 255 0 227 239 157 127 59 220 223 247 89 93 67 77 176 183 219 71 103 48 129 150 65 124 161 126 42 21 205 159 75 113 230 34 247 217 217 113 210 235 177 216 169 139 151 206 223 168 2 206 156 254 176 249 224 139 135 127 243 135 188 29 195 71 2 120 202 119 168 245 182 83 44 149 8 118 190 134 244 120 81 74 145 201 100 185 118 121 150 100 114 251 143 116 34 49 48 57 53 81 145 0 79 247 118 127 39 106 100 199 161 161 30 230 102 127 165 232 212 163 157 36 30 247 47 246 213 122 144 82 34 165 36 24 244 51 114 236 32 96 194 77 1 255 231 0 114 108 116 92 120 27 26 15 181 181 122 233 122 178 131 55 222 252 128 153 217 24 209 165 251 56 187 15 1 133 16 226 159 188 66 208 209 217 194 11 131 61 212 213 213 31 5 144 66 136 103 129 64 40 244 4 198 24 16 130 177 119 206 177 190 219 207 236 92 148 197 197 69 172 181 143 185 185 37 136 54 170 125 108 116 188 94 122 106 106 142 26 107 106 125 190 122 86 86 163 104 173 81 74 113 226 228 25 86 182 70 184 114 245 38 174 235 98 173 197 24 67 98 45 134 223 223 132 209 38 4 246 57 169 149 138 56 101 199 221 201 151 120 170 107 127 21 176 177 177 129 197 195 240 240 8 214 90 180 214 24 99 104 111 235 36 159 47 0 228 64 44 73 107 237 239 21 167 146 201 110 230 80 74 85 125 225 194 4 199 143 191 194 208 208 32 90 235 170 141 49 100 82 89 132 144 201 201 169 137 162 156 156 154 176 197 194 238 194 194 252 67 50 153 44 74 41 92 215 229 236 217 143 8 135 195 184 174 91 133 106 173 201 109 21 184 125 123 30 167 84 140 0 72 128 92 38 115 122 183 224 108 220 186 113 143 157 157 66 117 120 59 159 163 92 46 85 33 197 221 50 215 126 185 9 200 196 149 235 63 156 171 2 38 167 38 74 15 22 238 126 17 141 166 203 63 253 56 67 34 190 177 119 85 163 181 65 107 67 124 53 205 165 201 203 36 83 185 98 36 50 125 49 182 22 13 10 33 164 176 214 34 132 104 4 122 7 250 142 188 62 252 210 171 239 123 27 26 219 189 245 251 232 238 105 163 226 104 150 151 227 184 174 182 249 252 86 106 122 230 231 47 227 201 149 8 240 0 88 174 118 65 8 225 7 158 169 173 217 183 255 240 208 177 147 173 173 157 207 55 183 180 117 25 173 77 42 21 95 79 165 18 75 119 231 111 77 91 107 215 128 5 32 102 173 181 143 181 113 239 227 26 129 16 224 7 124 123 49 139 64 1 200 0 219 214 90 243 239 206 223 67 200 195 25 126 17 209 190 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!WAStandardFiles methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
selectorsToInclude
	^#(
		toolbarCss
		haloCss
		windowCss

		kalseyTabsCss
		externalAnchorsJs
		miscJs
		shortcutsJs
	)! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'lr 10/28/2007 14:42'!
shortcutsJs
	^ '

	var shortcutKeys = [];
	var shortcutElements = [];

	function resetShortcuts() {
		shortcutKeys = [];
		shortcutElements = [];
	}

	function addShortcut(shortcut, elementID) {
		var elem = document.getElementById(elementID);
		if ((elem.tagName == "INPUT" & (elem.type == "submit" || elem.type == "checkbox" || elem.type == "radio")) || elem.tagName == "A")
			{
			shortcutKeys[shortcutKeys.length] = shortcut;
			shortcutElements[shortcutElements.length] = elem;
			}
		else alert("Attempt to assign a shortcut (" + shortcut + ") to something that is not clickable");
	}

	function onKeyDown(event) {
		var keyname = "";
		var element;
		var nav;
		if (navigator.userAgent.indexOf("Safari") > 0)
			nav = "Safari";
		else if (navigator.product == "Gecko")
			nav = "Gecko";
		else
			nav = "IE";
		// cope with MS-IE
		if (event == null) event = window.event;
		if (event) {
			if (event.ctrlKey) keyname = keyname + "Ctrl-";
			if (event.altKey) keyname = keyname + "Alt-";
			if (event.metaKey) keyname = keyname + "Meta-";
			// cope with Netscape
			var keyCode = event.which;
			if (keyCode == null) keyCode = event.keyCode;
			if (keyCode == null) keyCode = event.charCode;
			if (keyCode !!= 0) {
				var character = String.fromCharCode(keyCode);
				character = character.toLowerCase();
				if (event.shiftKey) character = character.toUpperCase();
				// cope with special keys, designated with some logical names
				if (keyCode == 27) character = "Esc";
				if (keyCode == 8) character = "Backspace";
				if (keyCode == 9) character = "Tab";
				if (keyCode == 13) character = "Return";
				if (keyCode == 37) character = "Left";
				if (keyCode == 38) character = "Up";
				if (keyCode == 39) character = "Right";
				if (keyCode == 40) character = "Down";
				// cope with func-keys (some keys not intercepted for MS-IE)
				if ((keyCode >= 112) & (keyCode <= 123)) character = "F" + (keyCode - 112 + 1);
				for ( var x = 1 ; x <= shortcutKeys.length ; x++ ) {
					if (shortcutKeys[x-1] == keyname+character) {
						// alert("key=" + keyCode + " " + keyname + character);
						element = shortcutElements[x-1];
						if (element.tagName == "A" & nav !!= "IE") {
							if (element.onclick)
								element.onclick.call();
							else
								/* This does not work for anchor in IE */
								location.href = element.href;
						} else  {
							element.click();
						}
					}
				}
				return false;
			}
		}
	}

'! !

!WAStandardFiles methodsFor: 'accessing-images' stamp: ''!
styleeditorPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 214 4 9 20 4 42 36 195 187 166 0 0 2 112 73 68 65 84 56 203 173 147 221 75 83 113 24 199 63 155 155 110 57 245 164 169 232 24 180 240 173 50 207 48 74 144 68 27 82 209 141 43 147 145 136 226 159 97 36 236 70 130 174 162 232 38 34 42 86 104 26 42 5 74 47 243 5 65 212 110 52 148 48 95 74 156 107 206 236 156 249 50 117 110 167 139 58 232 130 186 144 30 248 193 247 226 249 124 248 61 207 143 31 28 172 146 107 156 213 74 119 119 183 114 16 216 180 15 222 19 184 65 116 67 167 27 228 223 167 211 13 226 31 112 226 126 184 198 89 173 104 84 24 232 183 55 54 10 73 201 41 16 217 37 184 178 66 95 107 171 4 84 44 222 110 89 150 229 96 219 204 204 76 89 93 109 61 85 85 85 212 56 171 105 111 123 169 87 5 157 246 250 122 135 226 245 18 24 25 1 69 225 136 77 132 212 52 94 127 15 140 249 46 86 230 100 103 153 15 23 228 159 160 188 188 92 133 117 64 36 14 224 42 60 40 42 41 73 88 236 233 97 119 99 131 104 56 204 178 94 199 156 205 198 194 217 211 230 230 155 46 163 86 27 135 40 138 108 132 130 60 122 248 88 7 68 0 180 234 112 74 40 4 202 222 78 190 230 230 225 63 83 76 83 83 51 62 159 143 188 188 60 218 59 94 176 24 76 222 108 56 89 89 168 246 169 2 79 48 16 32 45 63 31 157 193 192 252 229 75 248 47 216 185 238 172 197 231 243 97 52 26 233 31 232 227 211 236 23 4 177 250 208 146 144 237 138 17 76 31 79 126 254 166 191 87 193 100 226 104 105 41 19 69 133 92 113 92 99 109 109 13 69 81 88 95 15 50 60 58 202 80 192 138 201 168 195 159 146 105 143 17 124 168 73 170 141 27 44 211 188 21 38 232 26 241 144 62 61 133 167 239 61 130 32 32 203 50 119 238 221 229 227 143 12 66 187 113 108 135 35 49 239 170 3 208 155 37 123 162 152 195 192 173 49 182 36 3 130 55 132 102 106 146 150 251 207 8 71 34 172 104 173 44 109 9 164 101 89 9 200 219 100 202 126 79 140 0 32 204 38 74 244 87 150 204 195 196 235 102 241 246 26 176 228 22 99 200 182 112 42 43 129 213 245 29 62 15 116 72 54 105 201 21 35 8 123 5 207 106 116 206 97 201 201 96 97 122 25 128 236 226 45 178 114 94 49 120 99 202 247 77 41 72 4 200 148 253 30 155 180 228 122 50 249 110 92 21 104 0 28 117 86 49 122 46 208 127 190 193 34 24 73 37 202 46 235 138 159 161 167 43 146 118 40 189 162 203 61 63 254 183 143 161 81 131 163 206 42 238 28 219 113 233 205 146 93 189 85 252 92 188 235 95 240 127 169 159 24 23 11 103 188 240 115 88 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'lr 10/28/2007 14:42'!
toolbarCss
	^ 'body {
	margin-bottom: 25px;
}
#toolbar {
	z-index: 20;
	position: fixed;
	left: 0;
	right: 0;
	bottom: 0;
	padding: 2px;
	color: #444;
	background-color: #eee;
	border-top: 1px solid #aaa;
	font: 10pt Verdana, Arial, Helvetica, sans-serif;
}
#toolbar a {
	color: #444;
	padding-left: 3px;
	padding-right: 3px;
	text-decoration: none;
}
#toolbar a:hover {
	color: #111;
}
#toolbar a.deprecated {
	color: #ff7000;
}'! !

!WAStandardFiles methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot bodyAttributes
		at: 'onkeydown'
		put: 'onKeyDown(event)'! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'lr 6/5/2007 19:25'!
windowCss
	^ '.window {
	border: 1px solid #aaa;
}
.window .window-titlebar {
	color: #444;
	padding: 5px;
	overflow: hidden;
	background-color: #eee;
	border-bottom: 1px solid #aaa;
	font: 10pt Verdana, Arial, Helvetica, sans-serif;
}
.window .window-titlebar .window-title {
	float: left;
	font-weight: bold;
	padding-left: 20px;
}
.window .window-titlebar .browserhaloplugin {
	background: url(codebrowser.png) no-repeat;
}
.window .window-titlebar .inspectorplugin {
	background: url(inspector.png) no-repeat;
}
.window .window-titlebar .styleshaloplugin {
	background: url(styleeditor.png) no-repeat;
}
.window .window-titlebar .configuretoolplugin {
	background: url(config.png) no-repeat;
}
.window .window-titlebar .profilertoolplugin {
	background: url(profiler.png) no-repeat;
}
.window .window-titlebar .memorytoolplugin {
	background: url(memory.png) no-repeat;
}
.window .window-titlebar .window-close {
	float: right;
}
.window .window-titlebar .window-close a {
	color: #444;
	text-decoration: none;
}
.window .window-titlebar .window-close a:hover {
	color: #111;
}
.window .window-content {
	clear: both;
	padding: 2px;
}'! !

!WALibrary class methodsFor: 'instance-creation' stamp: 'pmm 4/6/2007 13:27'!
default
	^ default ifNil: [ default := self new ]! !

!WALibrary class methodsFor: 'actions' stamp: 'pmm 8/14/2007 07:21'!
deployFiles
	^self default deployFiles! !

!WALibrary class methodsFor: 'accessing' stamp: 'pmm 7/21/2007 23:19'!
documentAt: aFilename ifAbsent: aBlock
	^self default
		documentAt: aFilename
		ifAbsent: aBlock! !

!WALibrary class methodsFor: 'testing' stamp: 'pmm 7/20/2007 06:56'!
handlesFolder: aSymbol
	^self name = aSymbol! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
asFilename: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
asSelector: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'pmm 4/21/2007 00:11'!
configurationComponent
	self subclassResponsibility! !

!WALibrary methodsFor: 'actions' stamp: 'pmm 8/14/2007 19:34'!
deployFiles
	"Write to disk the files that the receiver use to serve as methods.
	The files are stored in a subfolder named like the classname of the receiver in a subfolder of Smalltalk image folder."
	SeasidePlatformSupport ensureExistenceOfFolder: self name.
	self fileSelectors do: [ :each |
		SeasidePlatformSupport
			write: (self perform: each)
			toFile: (self asFilename: each)
			inFolder: self name ]! !

!WALibrary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
documentAt: aFilename ifAbsent: aBlock
	| selector |
	selector := self asSelector: aFilename.
	^(self fileSelectors includes: selector)
		ifTrue: [ WAResponse
			document: (self documentForFile: aFilename)
			mimeType: (self mimetypeForFile: aFilename) ]
		ifFalse: [ aBlock value ]! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:17'!
documentForFile: aFilename
	^self perform: (self asSelector: aFilename)! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
fileSelectors
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:20'!
filenames
	^ self fileSelectors collect: [ :each | self asFilename: each ]! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:24'!
mimetypeForFile: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:21'!
name
	^ self class name! !

!WALibrary methodsFor: 'processing' stamp: 'mb 2/23/2007 10:29'!
updateRoot: anHtmlRoot! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlForFile: aFilename
	^ self urlOf: (self asSelector: aFilename)! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlOf: aSymbol
	^ self urlOf: aSymbol using: WAFileHandler default! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlOf: aSymbol using: aHandler
	^ aHandler baseUrl
		addToPath: self className;
		addToPath: (self asFilename: aSymbol);
		yourself! !

Object subclass: #WALocale
	instanceVariableNames: 'language country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WALocale class methodsFor: 'instance creation' stamp: 'pmm 1/4/2008 14:47'!
fromString: aString
	| language country delimeter |
	delimeter := (aString includes: $_)
		ifTrue: [ $_ ]
		ifFalse: [ $- ].
	language := aString copyUpTo: delimeter.
	country := aString copyAfter: delimeter.
	country isEmpty ifTrue: [ country := nil ].
	^self
		language: language
		country: country! !

!WALocale class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 13:16'!
language: aLanguageString country: aCounryString
	^self new
		language: aLanguageString;
		country: aCounryString;
		yourself! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
country
	^ country! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
country: aString
	country := aString! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
language
	^ language! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:11'!
language: aString
	language := aString! !

!WALocale methodsFor: 'printing' stamp: 'pmm 11/20/2007 13:12'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self toString;
		nextPut: $)! !

!WALocale methodsFor: 'converting' stamp: 'pmm 11/21/2007 22:16'!
toString
	^String streamContents: [ :stream |
		stream nextPutAll: self language.
		self country isNil ifFalse: [
			stream
				nextPut: $-;
				nextPutAll: self country ] ]! !

Object subclass: #WAMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WAMain commentStamp: 'rew 10/19/2007 10:49' prior: 0!
WAMain subclasses are used to initialize applications when a new session is started.

Subclasses must implement the following messages:
	start:
		Does the initializing 
!

!WAMain methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
application
	"Answer the application to which this entry point is associated."

	^ self session application! !

!WAMain methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
session
	"Answer the session to which this entry point is associated."

	^ WACurrentSession value! !

!WAMain methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
start: aRequest
	"The main entry point into a session."

	self subclassResponsibility! !

WAMain subclass: #WARenderLoopMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARenderLoopMain commentStamp: 'rew 10/19/2007 10:50' prior: 0!
When a new session on a WAApplication is started WARenderLoopMain initializes the application, that is it:
 
	creates the top level component of the application, 
	informs each component(WAPresenter) of the application that the session started (via WAPresenter>>initialRequest:)
	starts a WARenderLoop to handle the request
!

WARenderLoopMain subclass: #WAAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WAAuthMain methodsFor: 'creational' stamp: 'lr 4/20/2007 15:09'!
createRoot
	^ super createRoot
		addDecoration: (WABasicAuthentication new authenticator: self);
		yourself! !

!WAAuthMain methodsFor: 'testing' stamp: 'lr 4/20/2007 15:09'!
verifyPassword: password forUser: username
	^ self application login = username and: [ self application password = password ]! !

!WARenderLoopMain methodsFor: 'processing' stamp: 'lr 4/20/2007 15:10'!
call: aComponent
	^ self renderLoopClass new call: aComponent! !

!WARenderLoopMain methodsFor: 'creational' stamp: 'lr 5/12/2007 11:39'!
createRoot
	^ self rootClass new! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'lr 4/20/2007 15:10'!
renderLoopClass
	^ WARenderLoop! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'lr 5/12/2007 11:39'!
rootClass
	^ self application preferenceAt: #rootComponent! !

!WARenderLoopMain methodsFor: 'processing' stamp: 'lr 4/20/2007 19:41'!
start: aRequest
	| root |
	root := self createRoot.
	root visiblePresentersDo: [ :each | each initialRequest: aRequest ].
	(self renderLoopClass new root: root) run! !

Object subclass: #WAMimeType
	instanceVariableNames: 'main sub parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAMimeType commentStamp: 'pmm 1/4/2008 14:44' prior: 0!
A WAMimeType abstracts a Internet media type, it is a two-part identifier for file formats on the Internet.

Instance Variables
	main:		<String>
	parameters:		<WASmallDictionary>
	sub:		<String>

main
	- the main type

parameters
	- a lazily initialized dictionary of optional parameters

sub
	- the subtype
!

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 13:05'!
fromString: aString
	| main endOfSub sub parts parameters |
	main  := aString copyUpTo: $/.
	endOfSub := aString indexOf: $;.
	endOfSub = 0
		ifTrue: [ endOfSub := aString size ]
		ifFalse: [ endOfSub := endOfSub - 1 ].
	sub := aString copyFrom: main size + 2 to: endOfSub.
	endOfSub = aString size ifTrue: [
		^self main: main sub: sub ].
	parts := (aString copyFrom: endOfSub + 1 to: aString size) findTokens: ';'.
	parameters := RBSmallDictionary new.
	parts do: [ :each | 
		parameters
			at: (each copyUpTo: $=) trimBlanks
			put: (each copyAfter: $=) trimBlanks ].
	^self main: main sub: sub parameters: parameters! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 10:58'!
main: aMainString sub: aSubString
	^self new
		main: aMainString;
		sub: aSubString;
		yourself! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 10:58'!
main: aMainString sub: aSubString parameters: aDictionary
	^(self main: aMainString sub: aSubString)
		parameters: aDictionary;
		yourself! !

!WAMimeType methodsFor: 'comparing' stamp: 'pmm 1/4/2008 15:08'!
= other
	^(other isKindOf: WAMimeType)
		and: [ self main = other main
		and: [ self sub = other sub ] ]! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 11/21/2007 15:17'!
charset: aString
	self parameters at: 'charset' put: aString! !

!WAMimeType methodsFor: 'comparing' stamp: 'pmm 1/4/2008 15:14'!
hash
	^self main hash bitXor: self sub hash! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 11/21/2007 14:30'!
isBinary
	| subTypes |
	self main = 'text' ifTrue: [ ^false ].
	self main = 'application' ifFalse: [ ^true ].
	subTypes := self sub findTokens: '+'.
	^ subTypes noneSatisfy: [ :each | 
		#('x-javascript' 'xml') includes: each ]! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:40'!
isNonStandard
	"tests if the receiver is a non-standard mime type that is not registered with IANA"
	^(self main beginsWith: 'x-')
		or: [ (self main beginsWith: 'X-')
		or: [ (self sub beginsWith: 'x-')
		or: [ self sub beginsWith: 'X-' ] ] ]! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:39'!
isVendorSpecific
	"tests if the receiver is a vendor specific mimetype"
	^self sub beginsWith: 'vnd.'! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
main
	^ main! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:57'!
main: aString
	main := aString! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 11/21/2007 15:12'!
matches: aMimeType
	"aMimeType is the pattern to match, it is a normal WAMimeType instance where main or sub can be wildcards"
	^(aMimeType main = '*'
		or: [ aMimeType main = self main ])
		and: [
			aMimeType sub = '*'
				or: [ aMimeType sub = self sub ] ]! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 11/21/2007 15:14'!
parameterAt: aKey put: aValue
	self parameters at: aKey put: aValue! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:57'!
parameters
	parameters isNil ifTrue: [
		parameters := WASmallDictionary new ].
	^ parameters! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
parameters: aDictionary
	parameters := aDictionary! !

!WAMimeType methodsFor: 'printing' stamp: 'pmm 11/20/2007 13:13'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self toString;
		nextPut: $)! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
sub
	^ sub! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:55'!
sub: aString
	sub := aString! !

!WAMimeType methodsFor: 'converting' stamp: 'pmm 11/21/2007 20:18'!
toMimeType
	^ self! !

!WAMimeType methodsFor: 'converting' stamp: 'pmm 11/20/2007 13:09'!
toString
	^String streamContents: [ :stream |
		stream
			nextPutAll: self main;
			nextPut: $/;
			nextPutAll: self sub.
		parameters isNil ifFalse: [
			parameters keysAndValuesDo: [ :key :value |
				stream
					nextPut: $;;
					nextPutAll: key;
					nextPut: $=;
					nextPutAll: value ] ] ]! !

Object subclass: #WAModelProxy
	instanceVariableNames: 'cache model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAModelProxy commentStamp: '<historical>' prior: 0!
I am a fake object that can be interposed between the real model object and the client, so that the data can be validated or collected before commiting to the real model.

If you have a model instance like

	model := WAStoreAddress new.
	model street: 'Rathausgasse 34'.

create a model proxy by evaluating the following code:

	proxy := WAModelProxy on: model.
	
Then use the accessors of the proxy as you would do with your model:

	proxy country: 'Switzerland'.
	proxy street -> 'Rathausgasse 34'
	...
	
To propagate the values into your model send #commit :

	proxy commit.
	model country -> 'Switzerland'!

!WAModelProxy class methodsFor: 'instance creation' stamp: 'ab 11/26/2002 17:21'!
on: anObject
	^ self new setModel: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'lr 10/28/2007 14:42'!
commit
	cache keysAndValuesDo:
		[:key :value |
		self performRealWrite: key with: value].

	cache := Dictionary new! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'pmm 9/12/2006 18:37'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [self performRead: aMessage selector]
		ifFalse: [
			(aMessage selector isKeyword and: [aMessage arguments size = 1])
				ifTrue: [self performWrite: aMessage selector allButLast with: aMessage argument]
				ifFalse: [super doesNotUnderstand: aMessage]]! !

!WAModelProxy methodsFor: 'accessing' stamp: 'ab 11/26/2002 17:22'!
model
	^ model! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
name
	^ model name! !

!WAModelProxy methodsFor: 'private' stamp: 'pmm 9/12/2006 18:36'!
performRead: aSymbol
	^ cache
		at: aSymbol asSymbol
		ifAbsent: [ model perform: aSymbol ]! !

!WAModelProxy methodsFor: 'private' stamp: 'mb 1/5/2006 13:51'!
performRealWrite: aSymbol with: anObject
	model perform: aSymbol asSymbol asMutator with: anObject! !

!WAModelProxy methodsFor: 'private' stamp: 'mb 1/5/2006 13:51'!
performWrite: aSymbol with: anObject
	cache at: aSymbol asSymbol put: anObject! !

!WAModelProxy methodsFor: 'initializing' stamp: 'lr 10/28/2007 14:42'!
setModel: anObject
	model := anObject.
	cache := Dictionary new! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
value
	^ model value! !

Object subclass: #WAOpeningConditionalComment
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAOpeningConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:38'!
condition: aString
	^self new
		condition: aString;
		yourself! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:36'!
condition
	^ condition! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'pmm 10/11/2006 17:31'!
condition: aString
	condition := aString! !

!WAOpeningConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:53'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']>'! !

WAOpeningConditionalComment subclass: #WAOpeningRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAOpeningRevealedConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:54'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']><!!-->'! !

Object subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WAComponent commentStamp: 'pmm 8/27/2007 12:55' prior: 0!
I am a class representing a graphical element of a seaside application. A component has state (instance variables, that might be backtracked using #states), behavior decorations, children and an appearance that is specified in #renderContentOn:. A component might chose to display another component with #call:.

Child Components:
It is common for a component to display instances of other components while rendering itself.  It does this by passing them into the #render: method of WACanvas.  For example, this #renderContentOn: method simply renders a heading and then displays a counter component 
immediately below it:

	renderContentOn: html
		html heading level3; with: 'My Counter'.
		html render: myCounter.

It's important that you use #render:, rather than directly calling the #renderContentOn: method of the subcomponent. The following is *not* correct:

	renderContentOn: html
		html heading level3; with: 'My Counter'.
		myCounter renderContentOn: html.   "DON'T DO THIS".

These subcomponents are usually instance variables of the component that is "embedding" them.  They are commonly created as part of the components #initialize method:

	initialize
		myCounter := WACounter new.

They may also be stored in a collection. One fairly common pattern is to keep a lazily initialized dictionary of subcomponents that match a collection of model items. For example, if you wanted a BudgetItemRow subcomponent for each member of budgetItems, you might do something like this:

	initialize
		budgetRows := Dictionary new.

	rowForItem: anItem
		^budgetRows at: anItem ifAbsentPut: [ BudgetItemRow item: anItem ].

	renderContentOn: html
		self budgetItems
			do: [ :each | html render: (self rowForItem: each) ]
			separatedBy: [ html horizontalLine ].

Each parent component *must* implement a #children method that returns a collection of all of the subcomponents that it might display on the next render. For the above two examples, #children might look like this:

	children
		^Array with: myCounter

or this:

	children
		^self budgetItems collect: [ :each | self rowForItem: each ].
		
Call/Answer:
If a subcomponent makes a #call: to another component, that component will appear in place of the subcomponent.  In the first example, if myCounter made a #call: to DateSelector, that DateSelector would appear in the context of the counter's parent, with the 'My Counter' heading 
above it.

Since a subcomponent has not been #call:'d, in general #answer: is a no-op.  However, the parent may attach an #onAnswer: block to the subcomponent to be notified if it sends #answer:. This allows one component to be used both from #call: and through embedding. For example:

	initialize
		dateSelector := WADateSelector new 
			onAnswer: [ :date | self dateChosen: date ].
			
Visibility:
A component is visible if
- it is the root component of an application
- a child of of a visible component (returned by #children) that has not been #call:'d
- passed as an argument to #call: on a visible component!

WAComponent subclass: #WAAlphabeticBatchedList
	instanceVariableNames: 'items currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'avi 12/18/2004 18:26'!
allPages
	^ $A to: $Z! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 11/20/2007 15:39'!
batch
	^ items select: [ :each |
		each toString asUppercase first = self currentPage ]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
currentPage
	^ currentPage ifNil: [currentPage := self validPages first]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:16'!
currentPage: aCharacter
	currentPage := aCharacter! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnFirstPage
	^ self validPages first = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnLastPage
	^ self validPages last = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:13'!
items
	^ items! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
items: aCollection
	items := aCollection! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
nextPage
	self isOnLastPage ifFalse: [currentPage := self validPages after: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
previousPage
	self isOnFirstPage ifFalse: [currentPage := self validPages before: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	items isEmpty ifFalse: [
		html div
			id: 'batch';
			with: [
				self renderPreviousOn: html.
				self renderPagesOn: html.
				self renderNextOn: html ] ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:15'!
renderPagesOn: html
	self allPages
		do: [ :char |
			currentPage = char
				ifFalse: [
					(self validPages includes: char)
						ifTrue: [ html anchor callback: [self currentPage: char]; with: char]
						ifFalse: [ html text: char ] ]
				ifTrue: [ html strong: char ] ]
		separatedBy: [ html space ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:55'!
states
	^ Array with: self! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 11/20/2007 15:40'!
validPages
	^ (items collect: [ :each |
		each toString asUppercase first]) asSet asSortedCollection! !

WAComponent subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WABatchSelection commentStamp: 'rew 9/24/2007 20:22' prior: 0!
WABatchSelection displays a list of objects. The list is show N (currently 8) items per page, with links to navigate to other pages if needed. Objects in the list must implement one method that returns text description of the item and one method that returns a name or label used as the link users click to select the item. The text description is displayed below the link.

Example
	items := OrderedCollection new.
	1 to: 20 do: [:each | items add: (Contact new name: each; phoneNumber: '54321';yourself)].
	selection := WABatchSelection items: items link: #name text: #phoneNumber.
	result := self call: selection.

	where the Contact class has methodsinstance vars "phoneNumber" and "name", with
	setter & getter methods.

Instance Variables:
	batcher	<WABatchedList>	description of batcher
	linkSelector	<Symbol>	method sent to items in list for link text
	textSelector	<Symbol>	method sent to items in list for text description

!

!WABatchSelection class methodsFor: 'instance-creation' stamp: 'pmm 4/19/2006 17:39'!
items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:35'!
batchSize
    ^batcher batchSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:34'!
batchSize: aSize
    batcher batchSize: aSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:43'!
children
	^ Array with: batcher! !

!WABatchSelection methodsFor: 'commands' stamp: 'avi 12/9/2003 13:17'!
choose: anItem
	self answer: anItem! !

!WABatchSelection methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
items: aCollection
	batcher := WABatchedList new
		items: aCollection;
		batchSize: 8;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
linkSelector: aSymbol
	linkSelector := aSymbol! !

!WABatchSelection methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html unorderedList: [
		batcher batch do: [ :each |
			html anchor
				callback: [ self choose: each ];
				with: (each perform: linkSelector).
			html break.
			html text: (each perform: textSelector).
			html paragraph ] ].
	html div
		style: 'text-align: center';
		with: batcher! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
textSelector: aSymbol
	textSelector := aSymbol! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WABatchedList class methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
example
	^self new
		items: (1 to: 100);
		yourself! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
batch
	^ self items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize := aNumber! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage := aNumber! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
endIndex
	^ self currentPage * self batchSize min: self items size! !

!WABatchedList methodsFor: 'initialization' stamp: 'lr 4/15/2007 19:55'!
initialize
	super initialize.
	self batchSize: 10.
	self currentPage: 1! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnFirstPage
	^ self currentPage = 1! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnLastPage
	^ self currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items := aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
maxPages
	^ (self items size / self batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
nextPage
	self isOnLastPage ifFalse: [self currentPage: self currentPage + 1]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
previousPage
	self isOnFirstPage ifFalse: [self currentPage: self currentPage - 1]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	self maxPages > 0 ifTrue: [
		html div
			id: 'batch';
			with: [
				self renderPreviousOn: html.
				self renderPagesOn: html.
				self renderNextOn: html ] ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:07'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			self currentPage = index
				ifFalse: [html anchor callback: [self currentPage: index]; with: index]
				ifTrue: [html strong: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
startIndex
	^ (self currentPage - 1) * self batchSize + 1! !

!WABatchedList methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:55'!
states
	^ Array with: self! !

!WAComponent class methodsFor: 'registration' stamp: 'lr 10/28/2007 14:42'!
applicationNamed: aString
	| application |
	application := WAApplication named: aString.
	application configuration addAncestor: WARenderLoopConfiguration new.
	application preferenceAt: #rootComponent put: self.
	^ application! !

!WAComponent class methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
canBeRoot
	"When returning true, the component can be registered as a standalone application from the config interface."

	^ false! !

!WAComponent class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:15'!
description
	^ self name! !

!WAComponent class methodsFor: 'accessing' stamp: 'pmm 5/24/2007 10:42'!
headerForExampleBrowser
	^self name = self description
		ifTrue: [ self name ]
		ifFalse: [ self description , ' (' , self name , ')' ]! !

!WAComponent class methodsFor: 'registration' stamp: 'lr 10/28/2007 14:42'!
registerAsApplication: aString
	"Use this to programatically register a component as an appliction.
	#canBeRoot does not have to return true"
	| path dispatcher |
	path := aString findTokens: '/'.
	dispatcher := path allButLast
		inject: WADispatcher default
		into: [ :result :each |
			result entryPoints at: each ifAbsent: [
				result register: (WADispatcher named: each) ] ].
	^ dispatcher register: (self applicationNamed: path last)! !

!WAComponent class methodsFor: 'registration' stamp: 'lr 10/28/2007 14:42'!
registerAsAuthenticatedApplication: aString
	"Like #registerAsApplication: but addtionally adds password protection. You will be prompted for a susername and password."
	| application user password |
	application := self registerAsApplication: aString.
	application configuration addAncestor: WAAuthConfiguration new.
	user := SeasidePlatformSupport
		request: 'Please choose a username for\the application ' withCRs , aString printString.
	password := SeasidePlatformSupport
		request: 'Please enter a password for ' , aString printString.
	application preferenceAt: #login put: user.
	application preferenceAt: #password put: password.
	^ application! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 5/19/2004 14:18'!
activeComponent
	self visiblePresentersDo: [:ea | ea isDecoration ifFalse: [^ ea]]! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 6/2/2004 22:16'!
addDecoration: newDecoration
	| prev dec |
	prev := nil.
	dec := self decoration.
	[dec ~~ self and: [self decoration: dec shouldWrap: newDecoration]] whileTrue:
		[prev := dec.
		dec := dec owner].
	newDecoration owner: dec.
	prev
		ifNil: [self decoration: newDecoration]
		ifNotNil: [prev owner: newDecoration].
	^ newDecoration! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:36'!
addMessage: aString
	"adds a decoration that renders a level 3 heading with <aString> around the receiver
	returns this decoration so don't forget #yourself"
	^self addDecoration: (WAMessageDecoration new message: aString)! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 10/19/2004 15:55'!
allDecorationsDo: aBlock
	| ea |
	ea := self decoration.
	[ea notNil and: [ea ~~ self]] whileTrue:
		[aBlock value: ea.
		ea := ea owner]! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 3/27/2004 00:55'!
answer
	self answer: self! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 4/17/2007 07:28'!
answer: anObject
	"Give back control to the component from which the receiver was called from. When returning, a component can additionally return anObject to the caller."

	self decorationChainDo: [ :each | each handleAnswer: anObject ]! !

!WAComponent methodsFor: 'convenience' stamp: 'ac 3/22/2006 15:04'!
asComponent
	^ self! !

!WAComponent methodsFor: 'decorations' stamp: 'lr 10/28/2007 14:42'!
authenticateWith: anAuthenticator during: aBlock
	^ self decorateWith: (WABasicAuthentication new authenticator: anAuthenticator) during: aBlock! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
call: aComponent
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. Code can return from here later on by sending #answer: to aComponent."

	^ AnswerContinuation currentDo: [ :cc |
		self show: aComponent onAnswer: cc.
		WARenderNotification raiseSignal ]! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
children
	"This method is really important. It should return a collection of all subcomponents of the current component that will be rendered in #renderContentOn:. Components that are displayed using #call: are *not* children.

	If the contents returned by this method change over time make sure to return them in #states as well, otherwise the back button will fail."

	^ #()! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:57'!
childrenDo: aBlock
	self children do: [:ea | ea ifNotNil: [aBlock value: ea]]! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:49'!
chooseFrom: aCollection
	"Choose an item from the given aCollection. Answer the selected item."
	^ self chooseFrom: aCollection caption: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:49'!
chooseFrom: aCollection caption: aString
	"Choose an item from the given aCollection with caption aString. Answer the selected item."
	^ self call: ((WAChoiceDialog new options: aCollection)
		addMessage: aString;
		yourself)! !

!WAComponent methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
confirm: aString
	"Display a yes/no dialog with caption queryString. Answer true if the
	response is yes, false if no. This is a modal question -- the user must
	respond yes or no."

	^ self call: (WAYesOrNoDialog new
		addMessage: aString;
		yourself)! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/27/2004 19:53'!
decorateWith: aDecoration during: aBlock
	| val |
	self addDecoration: aDecoration.
	val := aBlock value.
	self removeDecoration: aDecoration.
	^ val! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:48'!
decoration
	^ decoration contents! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 9/22/2004 13:59'!
decoration: aDecoration
	decoration contents: aDecoration! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/28/2004 20:49'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isDelegation and: [newDecoration isLocal]]! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 4/22/2004 14:50'!
decorationChainDo: aBlock
	aBlock value: self decoration! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:57'!
delegations
	| delegations |
	delegations := OrderedCollection new.
	self allDecorationsDo: [:ea | ea isDelegation ifTrue: [delegations add: ea]].
	^ delegations! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:13'!
handleAnswer: anObject
	^ false! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:56'!
home
	self delegations do: [:ea | self removeDecoration: ea]! !

!WAComponent methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
inform: aString
	"Display a dialog with aString to the user until he clicks 'OK'"
	self call: (WAFormDialog new
		addMessage: aString;
		yourself)! !

!WAComponent methodsFor: 'initialize-release' stamp: 'pmm 4/9/2007 13:36'!
initialize
	super initialize.
	self initializeDecoration! !

!WAComponent methodsFor: 'initialize-release' stamp: 'lr 9/5/2007 11:44'!
initializeDecoration
	decoration := WAValueHolder with: self! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
isolate: aBlock
	|txn val |
	txn := WATransaction new.
	val := self decorateWith: txn during: aBlock.
	txn close.
	^ val! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:59'!
nextPresentersDo: aBlock
	self childrenDo: [:ea | ea decorationChainDo: aBlock]! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
onAnswer: aBlock
	"Adds an answer handler aBlock to the receiver."

	^ self addDecoration: (WAAnswerHandler new block: aBlock)! !

!WAComponent methodsFor: 'decorations' stamp: 'lr 10/28/2007 14:42'!
removeDecoration: aDecoration
	| dec |
	dec := self decoration.
	dec = aDecoration ifTrue:
		[self decoration: dec owner.
		^ self].

	[dec notNil] whileTrue:
		[dec owner = aDecoration
			ifTrue: [dec owner: aDecoration owner.  ^ self]
			ifFalse: [dec := dec owner]]! !

!WAComponent methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderOn: aRenderer
	"Do not override this methods on your component, override instead #renderContentOn: and in addition to not invoke directly renderContentOn: on subcomponent in such method but use instead html render: subcomponent."

	self decorationChainDo: [ :each | each renderWithContext: aRenderer context ]! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:51'!
request: aString
	"Display an input dialog whose question is queryString and answer the string the user accepts."
	^ self request: aString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString default: initialString
	^ self request: aString label: nil default: initialString! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: requestString label: labelString
	^ self request: requestString label: labelString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:38'!
request: requestString label: labelString default: initialString
	^ self call: (WAInputDialog new
		label: labelString;
		default: initialString;
		addMessage: requestString;
		yourself)! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
show: aComponent
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. As opposed to #call: sending this message does not block and immediately returns."

	self
		show: aComponent
		onAnswer: [ :value | ]! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
show: aComponent onAnswer: aBlock
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. When #answer: is sent to aComponent, aBlock is evaluated. This can be used for continuation passing style programmation of a control flow. #show:onAnswer: does not block."

	self
		show: aComponent
		onAnswer: aBlock
		delegation: (WADelegation new
			delegate: aComponent;
			yourself)! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
show: aComponent onAnswer: aBlock delegation: aDelegation
	| event |
	event := nil.
	event := aComponent onAnswer: [ :value |
		aDelegation remove.
		event remove.
		aBlock value: value ].
	self addDecoration: aDelegation! !

!WAComponent methodsFor: 'updating' stamp: 'lr 4/20/2007 20:18'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	aSnapshot register: decoration! !

!WAComponent methodsFor: 'convenience' stamp: 'cds 7/25/2005 10:24'!
validateWith: aBlock
	^self addDecoration: (WAValidationDecoration new validateWith: aBlock)! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:58'!
visiblePresentersDo: aBlock
	self decorationChainDo: [:ea | ea withNextPresentersDo: aBlock]! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 08:02'!
date
	(self privateIsValidDay: day monthNumber: month year: year)
		ifFalse: [self error: 'Invalid date'].
	^ self dateClass year: year month: month day: day! !

!WADateSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
date: aDate
	day := aDate dayOfMonth.
	month := aDate monthIndex.
	year := aDate year! !

!WADateSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:59'!
dateClass
	^ Date! !

!WADateSelector methodsFor: 'testing' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day
	^day! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day: anObject
	^day := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear := anInteger! !

!WADateSelector methodsFor: 'initialize-release' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	startYear := Date today year - 1.
	endYear := Date today year + 5.
	self date: self dateClass today! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month
	^month! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month: anObject
	^month := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'private' stamp: 'pmm 9/11/2007 06:43'!
privateIsValidDay: theDay monthNumber: theMonth year: theYear
	| daysInMonth |
	(theMonth between: 1 and: 12) ifFalse: [^false].
	daysInMonth := Month daysInMonth: theMonth forYear: theYear.
	^(theDay between: 1 and: daysInMonth)! !

!WADateSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html select
		list: self months;
		on: #month of: self;
		labels: [ :each | self labelForMonth: each ].

	html select
		list: self days;
		on: #day of: self;
		labels: [ :each | self labelForDay: each ].

	html select
		list: self yearRange;
		on: #year of: self;
		labels: [ :each | self labelForYear: each ].

	self dateIsValid ifFalse: [self renderValidationErrorOn: html]! !

!WADateSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:00'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid date'! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear := anInteger! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year
	^year! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year: anObject
	^year := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WADateTable methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:42'!
datesDo: aBlock separatedBy: monthlyBlock
	| month |
	month := datesCache first monthIndex.
	datesCache do: [ :date |
		date monthIndex = month ifFalse: [month := date monthIndex. monthlyBlock value].
		aBlock value: date ].
	monthlyBlock value! !

!WADateTable methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
endDate: aDate
	endDate := aDate.
	self updateDatesCache! !

!WADateTable methodsFor: 'enumerating' stamp: 'pmm 5/16/2007 17:50'!
monthsAndLengthsDo: aTwoArgumentBlock
	| count last |
	count := 0.
	last := nil.
	self
		datesDo: [ :each |
			count := count + 1.
			last := each ]
		separatedBy: [
			aTwoArgumentBlock value: last month value: count.
			count := 0 ]! !

!WADateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:17'!
renderContentOn: html
	html table
		class: 'DateTable';
		border: 1;
		with: [
			html tableRow: [ self renderMonthHeadingsOn: html ].
			html tableRow: [ self renderDayHeadingsOn: html ].
			rows withIndexDo: [ :each :index |
				html tableRow: [self renderRow: each index: index on: html ] ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:19'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date |
			html tableHeading
				class: 'DayHeading';
				with: date dayOfMonth ]
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:20'!
renderHeadingForRow: anObject on: html
	html tableHeading
		class: 'RowHeading';
		with: anObject! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 12/18/2007 20:35'!
renderHeadingSpacerOn: html
	html tableData: ''! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:21'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo: [ :month :length |
		self renderHeadingSpacerOn: html.
		html tableHeading
			colSpan: length;
			class: 'MonthHeading';
			with: [
				html text: month name.
				html space.
				html text: month year ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [ :date | self renderCellForDate: date row: anObject index: aNumber on: html]
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows := aCollection! !

!WADateTable methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
startDate: aDate
	startDate := aDate.
	self updateDatesCache! !

!WADateTable methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].

	datesCache := OrderedCollection new.
	date := startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date := date next]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WASelectionDateTable methodsFor: 'selecting' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart := dateSelectionEnd := rowSelectionStart := rowSelectionEnd := nil! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:22'!
endDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:27'!
endRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'testing' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:27'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	| text |
	html tableData
		style: 'background-color: ', (self colorForDate: aDate rowIndex: aNumber);
		align: 'center';
		with: [
			text := cellBlock value: anObject value: aDate.
			html anchor callback: [self selectDate: aDate rowIndex: aNumber]; with: text ]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock := aBlock! !

!WASelectionDateTable methodsFor: 'editor access' stamp: 'lr 10/28/2007 14:42'!
selectAll
	dateSelectionStart := startDate.
	dateSelectionEnd := endDate.
	rowSelectionStart := 1.
	rowSelectionEnd := rows size! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart := dateSelectionEnd := aDate. rowSelectionStart := rowSelectionEnd := rowIndex]
		ifTrue: [dateSelectionEnd := aDate. rowSelectionEnd := rowIndex]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:22'!
startDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:27'!
startRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

WAComponent subclass: #WADateTimeSelector
	instanceVariableNames: 'dateSelector timeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:19'!
children

	^ Array with: dateSelector with: timeSelector! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:22'!
dateAndTime

	^ DateAndTime date: dateSelector date time: timeSelector time! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
dateAndTime: anObject

	dateSelector date: anObject asDate.
	timeSelector time: anObject asTime! !

!WADateTimeSelector methodsFor: 'initialize-release' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	dateSelector := WADateSelector new.
	timeSelector := WATimeSelector new! !

!WADateTimeSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html

	html span: dateSelector.
	html span: [html strong: ' : '].
	html span: timeSelector! !

WAComponent subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WAFormDialog commentStamp: 'rew 9/24/2007 20:23' prior: 0!
WAFormDialog is an empty html form. Used in WAComponent>>inform: to create a dialog component that displays text and an "Ok" button to close the component. See subclasses for sample usage & more functionality.

Instance Variables:
	form	<WAFormDecoration> Decorator that generates form tags
	validationError	<String>	Text descriping invalid data entered by user. Displayed when not nil. Set to nil when user submits form.
!

WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WAChoiceDialog commentStamp: 'pmm 9/25/2007 20:24' prior: 0!
WAChoiceDialog produces a form with select tag (dropdown menu) on a collection of options and "Ok" and "Cancel" buttons. Options can be any object. Returns actual object selected or nil if user select "Cancel". WAChoiceDialog is used to implement the chooseFrom:caption: convenience method in WAComponent.

	| selection |
	selection := WAChoiceDialog options: #('Smalltalk' 'Perl' 'Python' 'Ruby' 9).
	result := self call: selection.
	self inform: result printString

Instance Variables:
	options	<Collection of Objects> objects in list
	selection	<Object>	object selected by user or nil if user cancels

!

!WAChoiceDialog class methodsFor: 'examples' stamp: 'lr 1/7/2007 17:59'!
example
	^ self options: #('Smalltalk' 'Perl' 'Python' 'Ruby')! !

!WAChoiceDialog class methodsFor: 'instance-creation' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	^ self new options: aCollection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 01:00'!
buttons
	^ #(ok cancel)! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
cancel
	self answer: nil! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
ok
	self answer: selection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options
	^ options! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	options := aCollection! !

!WAChoiceDialog methodsFor: 'rendering' stamp: 'pmm 4/27/2007 00:18'!
renderContentOn: html
	html select
		list: options;
		selected: selection;
		callback: [ :value | selection := value ]! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 13:45'!
addForm
	form := WAFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/16/2004 14:05'!
addFormByDefault
	^ true! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:37'!
buttons
	^ #(ok)! !

!WAFormDialog methodsFor: 'accessing' stamp: 'mb 4/4/2006 13:41'!
defaultButton
	^self buttons first! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:41'!
divClass
	^ self class name! !

!WAFormDialog methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:51'!
initialize
	super initialize.
	self addFormByDefault ifTrue: [self addForm]! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/12/2004 16:35'!
isValid
	^ validationError isNil! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:35'!
model
	^ self! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 16:37'!
ok
	self answer! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/27/2004 16:59'!
removeForm
	form ifNotNil: [self removeDecoration: form]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html hiddenInput callback: [ validationError := nil ].
	validationError
		ifNotNil: [ self renderValidationError: validationError on: html ].
	html div
		class: self divClass;
		with: [ self renderDialogOn: html ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:55'!
renderSpacerRowOn: html
	html div class: 'dialog-spacer'; with: [ html space ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:56'!
renderValidationError: aString on: html
	html span class: 'dialog-validation'; with: aString! !

!WAFormDialog methodsFor: 'validation' stamp: 'avi 3/12/2004 16:35'!
validationError: aString
	validationError := aString! !

WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WALabelledFormDialog commentStamp: 'rew 9/24/2007 20:24' prior: 0!
WALabelledFormDialog is an abstract class for generating html forms. Given a data model WALabelledFormDialog displays a label and input field for each instance variable of interest. User supplied data is placed in the data model.

Subclasses need to implment the methods labelForSelector:, model, and rows. The "model" method just returns the object whose fields we wish to populate with date. The "rows" method returns a collections of symbols. One symbol for each row of data in the dialog. The symbol is used generate the accessor methods for the data in the model. The method "labelForSelector:" returns the labels for each row and each submit button in the form.

A standard text input field is used for each row of data. To use other html widgets for input for = a datum implement the method renderXXXOn: where XXX is the symbol for the row. See "renderNameOn:" in example below.

The default form has one button "Ok". Override the "buttons" method to change the text or number of submit buttons on the form. Override the "defaultButton" method to indicate which button is the default. For each button in the form the subclass needs a method with the same name as the button, which is called when the user clicks that button. See example below.

LabelledFormDialogExample subclass of WALabelledFormDialog instance methods
	initialize
		super initialize.
		contact := Contact new. "contact is an inst var"
		self addMessage: 'Please enter the followning information'.

	model
		^ contact

	ok
		self answer: contact

	cancel
		self answer

	rows
		^ #(name phoneNumber)

	buttons
		#(ok cancel)

	labelForSelector: aSymbol
		aSymbol == #name ifTrue: [^'Your Name'].
		aSymbol == #phoneNumber ifTrue: [^'Phone Number'].
		aSymbol == #ok ifTrue: [^'Ok'].
		aSymbol == #cancel ifTrue: [^'Cancel'].
		^ super labelForSelector: aSymbol

	renderNameOn: html 
		"Show how to specily special input instead of using simple text field."
		(html select)
				list: #('Roger' 'Pete');
				selected: 'Roger';
				callback: [:v | contact name: v]

Contact Class used above has instance variables name, phoneNumber with standard getter and setter methods
!

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:08'!
renderDefaultFieldForSelector: aSymbol on: html
	html textInput
		on: aSymbol of: self model! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 21:06'!
renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:41'!
renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderRowForSelector: aSymbol on: html
	html div
		id: 'dialog-row-' , aSymbol;
		class: 'dialog-row';
		with: [
			html span
				class: 'dialog-form-label';
				with: [self renderLabelForSelector: aSymbol on: html].
			html span
				class: 'dialog-form-field';
				with: [self renderFieldForSelector: aSymbol on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/10/2004 18:00'!
rows
	^ #()! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:29'!
style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !

WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WAYesOrNoDialog commentStamp: 'rew 9/24/2007 20:25' prior: 0!
WAYesOrNoDialog displays a yes/no dialog. Returns boolean indicating user selection. See WAComponent>>confirm: for sample usage and easy way to use WAYesOrNoDialog.!

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
buttons
	^ #(yes no)! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
no
	self answer: false! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
yes
	self answer: true! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WAInputDialog commentStamp: 'rew 9/24/2007 20:24' prior: 0!
WAInputDialog generates a simple form with a text input field and a submit button. The instance variable "value" is used for initial value of the text field and hold the text entered by user. WAInputDialog answers with text entered by user (value of "value"). See WAComponent>>request:label:default: for sample use and easy way to use WAInputDialog.

Instance Variables:
	label	<String>	label of submit button
	value	<Object | String>	
!

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
default: aString
	value := aString! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
label
	^label ifNil: [ label := 'OK' ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
label: aString
	label := aString! !

!WAInputDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 18:02'!
renderContentOn: html
	html form
		defaultAction: [ self answer: value ];
		with: [
			html textInput on: #value of: self.
			html space.
			html submitButton
				callback: [ self answer: value ];
				text: self label ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
value
	^value! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
value: aString
	value := aString! !

WAComponent subclass: #WAMiniCalendar
	instanceVariableNames: 'month date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAMiniCalendar class methodsFor: 'testing' stamp: 'dc 12/28/2005 14:20'!
canBeRoot
	^ true! !

!WAMiniCalendar class methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:37'!
example
	^self new! !

!WAMiniCalendar methodsFor: 'testing' stamp: 'lr 12/28/2006 22:37'!
canSelect: aDate
	^ canSelectBlock value: aDate! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 15:16'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 15:25'!
date
	^ date contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 12/12/2004 13:39'!
date: aDate
	date contents: aDate.
	month contents: aDate month! !

!WAMiniCalendar methodsFor: 'initialization' stamp: 'lr 9/5/2007 11:47'!
initialize
	super initialize.
	month := WAValueHolder with: Date today month.
	date := WAValueHolder new.
	canSelectBlock := [ :value | true ].
	selectBlock := [ :value | self answer: value ]! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 22:56'!
month
	^ month contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 22:56'!
month: aMonth
	^ month contents: aMonth! !

!WAMiniCalendar methodsFor: 'private' stamp: 'pmm 11/20/2007 15:46'!
monthHeading
	^ self month name , ' ' , self month year toString! !

!WAMiniCalendar methodsFor: 'private' stamp: 'lr 12/28/2006 22:41'!
months
	^ (1 to: 12) collect: [ :i | Month month: i year: self year ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderCellForDate: aDate on: html
	html tableData: [
		aDate month = self month ifTrue: [
			html span
				class: (self date = aDate ifTrue: [ 'calendarArchiveDate' ]);
				with: [
					(self canSelect: aDate)
						ifTrue: [
							html anchor
								callback: [ self select: aDate ];
								with: aDate dayOfMonth ]
						ifFalse: [ html text: aDate dayOfMonth ] ] ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html div
		class: 'calendar';
		with: [
			html span
				class: 'calendarCaption';
				with: [ self renderMonthHeadingOn: html ].
			html table: [
				html tableRow
					class: 'calendarTitle';
						with: [
						self weekDays do: [ :each |
							html tableData: each ] ].
				self month weeksDo: [ :week |
					self renderRowForWeek: week on: html ] ].

			self renderMonthNavigationOn: html.
			html space; space.
			self renderYearNavigationOn: html ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:09'!
renderMonthHeadingOn: html
	html form: [
		html select
			list: self months;
			on: #month of: self;
			labels: [:eachMonth | eachMonth name].
		html textInput
			maxLength: 4;
			on: #year of: self.
		html submitButton text: 'Refresh' ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderMonthNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [self month: self month previous];
				with: (self month previous name first: 3) ].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [self month: self month next];
				with: (self month next name first: 3) ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/11/2006 23:28'!
renderRowForWeek: aWeek on: html
	html tableRow: [
		aWeek datesDo: [ :each | self renderCellForDate: each on: html ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderYearNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [self year: self year - 1];
				with: (self year - 1) ].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [self year: self year + 1];
				with: (self year + 1) ]! !

!WAMiniCalendar methodsFor: 'action' stamp: 'lr 12/28/2006 22:38'!
select: aDate
	self date: aDate.
	selectBlock value: aDate! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 17:39'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:58'!
states
	^ Array with: date with: month! !

!WAMiniCalendar methodsFor: 'private' stamp: 'lr 12/28/2006 22:42'!
weekDays
	^ (1 to: 7) collect: [ :i | (Date nameOfDay: i) first: 3 ]! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dc 12/29/2005 11:44'!
year
	^ self month year! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'pmm 12/9/2007 12:29'!
year: anIntegerOrString
	| year |
	year := [ anIntegerOrString asInteger ] on: Error do: [ :error | 1900 ].
	self month: (Month month: self month monthIndex year: year)! !

WAComponent subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Frames'!

!WANavigation methodsFor: 'initialize' stamp: 'lr 9/5/2007 11:20'!
initialize
	super initialize.
	selection := WAValueHolder new! !

!WANavigation methodsFor: 'query' stamp: 'pmm 11/20/2007 15:46'!
labelForOption: anObject
	^ anObject toString! !

!WANavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 16:27'!
options
	^ #()! !

!WANavigation methodsFor: 'rendering' stamp: 'lr 6/6/2007 17:49'!
renderContentOn: html
	html div class: 'kalsey'; with: [
		html div
			class: 'navigation-options';
			with: [ self renderOptionsOn: html ].
		html div
			class: 'navigation-content';
			with: [ self renderSelectionOn: html ] ]! !

!WANavigation methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderOptionsOn: html
	html unorderedList
		list: self options;
		selected: self selection;
		callback: [ :value | self select: value ];
		labels: [ :each | self labelForOption: each ]! !

!WANavigation methodsFor: 'rendering' stamp: 'avi 3/15/2004 16:13'!
renderSelectionOn: html! !

!WANavigation methodsFor: 'selection' stamp: 'lr 6/6/2007 17:54'!
select: anObject
	selection contents: anObject.
	self selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selection
	^ selection contents! !

!WANavigation methodsFor: 'selection' stamp: 'lr 10/28/2007 14:42'!
selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'lr 4/15/2007 19:57'!
states
	^ Array with: selection! !

WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Frames'!

!WASimpleNavigation commentStamp: 'lr 11/29/2004 16:30' prior: 0!
I'm a simple tab panel, that can be styled with stylesheets. New tabs can be added using #add:label:!

!WASimpleNavigation class methodsFor: 'example' stamp: 'lr 10/28/2007 14:42'!
example
	^self new
		add: WACounter example label: 'Counter';
		add: WAPath example label: 'Path';
		select: 'Counter';
		yourself! !

!WASimpleNavigation methodsFor: 'behavior' stamp: 'avi 3/15/2004 19:24'!
add: aComponent label: aString
	components add: aString -> aComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
children
	^ Array with: self selectedComponent! !

!WASimpleNavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 19:25'!
initialize
	super initialize.
	components := OrderedCollection new! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:28'!
labels
	"Return the tabs labels"

	^ self options! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
options
	^ components collect: [ :each | each key ]! !

!WASimpleNavigation methodsFor: 'rendering' stamp: 'sd 11/28/2004 21:15'!
renderSelectionOn: html
	html render: self selectedComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
selectedComponent
	^ (components detect: [ :each | each key = self selection ] ifNone: [ ^ nil ]) value! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector := aSymbol! !

!WANavigationBar methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	actionsSelector := #actions! !

!WANavigationBar methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
owner: anObject
	owner := anObject! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:32'!
renderContentOn: html
	self actions do: [ :symbol |
		symbol numArgs = 0
			ifTrue: [ self renderLink: symbol on: html ]
			ifFalse: [ self renderInput: symbol on: html ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderInput: aSymbol on: html
	html form: [
		html strong: aSymbol capitalized.
		html space.
		html textInput
			callback: [ :value |
				self target perform: aSymbol with: value ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderLink: aSymbol on: html
	html anchor
		on: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:31'!
target
	^ owner activeComponent! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAPath commentStamp: '<historical>' prior: 0!
I represent a path navigation such as the one that is displayed on the top of the web inspector when you toggle on the halos.

Here is an example of path:

	xxx >> yyy >> zzz

Useful methods are 
	- #currentSegment returns zzz
	- pushSegment: anObject name: 'lulu'!

!WAPath class methodsFor: 'example' stamp: 'lr 10/28/2007 14:42'!
example
	^self new
		pushSegment: 123 name: 'xxx';
		pushSegment: 456 name: 'yyy';
		pushSegment: 789 name: 'zzz';
		yourself! !

!WAPath methodsFor: 'behavior' stamp: 'lr 10/28/2007 14:42'!
choose: anAssociation
	"Install a new stack of navigation from the old one and the specified association."

	| newStack |
	newStack := Array new writeStream.
	stack do:
		[:ea |
		newStack nextPut: ea.
		ea == anAssociation
			ifTrue: [stack := newStack contents. ^ self]]! !

!WAPath methodsFor: 'accessing' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'initialize' stamp: 'lr 4/15/2007 19:55'!
initialize
	super initialize.
	stack := #()! !

!WAPath methodsFor: 'behavior' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack := stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html

	stack isEmpty ifTrue: [^ self].

	html div
		id: 'path';
		with: [
		stack allButLast do:
			[:assoc |
			html anchor callback: [self choose: assoc]; with: assoc key.
			html text: ' >> '].

		html strong: stack last key]! !

!WAPath methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:56'!
states
	^ Array with: self! !

WAComponent subclass: #WAReport
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAReport methodsFor: 'initialize' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	rows := #()! !

!WAReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:03'!
rows: anArray
	rows := anArray! !

WAReport subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WATableReport methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
chooseRow: aRow column: aColumn
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'private' stamp: 'lr 7/12/2007 20:28'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber - 1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns := anArray! !

!WATableReport methodsFor: 'accessing' stamp: 'lr 9/5/2007 11:21'!
initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAValueHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3! !

!WATableReport methodsFor: 'testing' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:12'!
renderColumn: aColumn row: aRow on: html
	| text |
	aColumn canRender ifTrue: [
		^html tableData: [aColumn renderValue: aRow on: html]].
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [ text := ' ' ].
	html tableData: [
		aColumn canChoose
			ifFalse: [ html text: text ]
			ifTrue: [
				html anchor
					callback: [ self chooseRow: aRow column: aColumn ];
					with: text ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:17'!
renderContentOn: html
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderFooterForColumn: aColumn on: html
	html tableHeading: (aColumn totalForRows: rows)! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:46'!
renderHeaderForColumn: aColumn on: html
	html tableHeading:  [
		aColumn canSort
			ifTrue: [
				html anchor
					callback: [self sortColumn: aColumn];
					with: aColumn title]
			ifFalse: [ html text: aColumn title ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:48'!
renderRowNumber: index item: row on: html
	html tableRow
		style: 'background-color: ' , (self colorForRowNumber: index);
		with: [
			columns do: [ :each |
				self renderColumn: each row: row on: html ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 1/31/2003 11:26'!
renderRowsOn: html
	self rows withIndexDo: [:row :i | self renderRowNumber: i item: row on: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:38'!
renderTableFooterOn: html
	html tableRow: [
		columns do: [ :each |
			self renderFooterForColumn: each on: html] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:39'!
renderTableHeaderOn: html
	html tableRow: [
			columns do: [ :each |
				self renderHeaderForColumn: each on: html] ]! !

!WATableReport methodsFor: 'state variables' stamp: 'DataCurator 04/24/2007 14:10'!
reverse

	isReversed := isReversed not! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors := colorArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod := aNumber! !

!WATableReport methodsFor: 'accessing' stamp: 'AC 1/31/2003 11:46'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r := self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'state variables' stamp: 'lr 10/28/2007 14:42'!
sortColumn: anObject
	isReversed := anObject = self sortColumn and: [isReversed not ].
	sortColumn contents: anObject! !

!WATableReport methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:51'!
states
	^ Array with: sortColumn! !

WAComponent subclass: #WASelection
	instanceVariableNames: 'items labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WASelection commentStamp: 'rew 9/24/2007 20:25' prior: 0!
WASelection creates a selectable list. Items can be any object. If optional labelBlock is not given the string versions of the items are displayed to user, otherwise labelBlock is used to generate the text to display for each item. Returns the item selected by user, (not the index nor the text shown the user). 

	| selection |
	selection := WASelection new.
	selection items: #(1 'cat' 'rat').
	selection 
		labelBlock: [:item | item = 1 ifTrue: ['First'] ifFalse: [item asUppercase]].
	result := self call: selection.
	self inform: result printString

Instance Variables:
	items	<Array of Objects> 	
	labelBlock	<One arg Block>	

!

!WASelection methodsFor: 'initialization' stamp: 'pmm 11/20/2007 15:47'!
initialize
	super initialize.
	items := #().
	labelBlock := [ :each | each toString ]! !

!WASelection methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:04'!
items
	^ items! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
items: aCollection
	items := aCollection! !

!WASelection methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:06'!
labelBlock
	^ labelBlock! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WASelection methodsFor: 'rendering' stamp: 'lr 1/7/2007 18:05'!
renderContentOn: html
	html unorderedList
		list: self items;
		labels: self labelBlock;
		callback: [ :value | self answer: value ]! !

WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WATask commentStamp: 'pmm 6/30/2007 19:02' prior: 0!
I am a subclass of WAComponent, specialized for defining workflow.  The difference between a task and a component is the following:

Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn't render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.

In terms of implementation, you can think of a WATask in the following way: it is a component which renders two things:
- a link whose callback invokes the #go method
- a header that immediately redirects to the URL of that link

Subclasses must not implement #renderContentOn:

An example can be found in WAConvenienceTest.
!

!WATask methodsFor: 'decorations' stamp: 'avi 3/28/2004 20:50'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isLocal and: [newDecoration isDelegation]]! !

!WATask methodsFor: 'processing' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

!WATask methodsFor: 'processing' stamp: 'lr 8/20/2007 21:38'!
updateRoot: aHtmlRoot
	| callbacks url |
	callbacks := WACallbackRegistry context: aHtmlRoot context owner: self.
	url := aHtmlRoot context actionUrl withParameter: (callbacks registerActionCallback: [ [ self answer: self go ] repeat ]).
	self session redirectTo: url! !

WAComponent subclass: #WATimeSelector
	instanceVariableNames: 'second hour minute startHour endHour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
date: aDate
	second := aDate dayOfMonth.
	hour := aDate monthIndex.
	minute := aDate year! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:37'!
days
	^ 1 to: 31! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
endHour
	^endHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
endHour: anInteger
	endHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour
	^hour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour: anObject
	^hour := anObject! !

!WATimeSelector methodsFor: 'initialize-release' stamp: 'mb 5/6/2006 16:10'!
initialize
	super initialize.
	startHour := 0.
	endHour := 23.
	self time: Time midnight! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute
	^minute! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute: anObject
	^minute := anObject! !

!WATimeSelector methodsFor: 'private' stamp: 'pmm 10/2/2006 21:13'!
privateIsValidSecond: theSecond hourNumber: theHour minuteNumber: theMinute

	^ (theHour between: 0 and: 23)
		and: [ theMinute between: 0 and: 59 ]
		and: [ theSecond between: 0 and: 59 ]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html select
		list: (0 to: 23);
		on: #hour of: self.
	html  select
		list: (0 to: 59);
		on: #minute of: self.
	html  select
		list: (0 to: 59);
		on: #second of: self.

	self timeIsValid ifFalse: [self renderValidationErrorOn: html]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:23'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid time'! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second
	^second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second: anObject
	^second := anObject! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
startHour
	^startHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
startHour: anInteger
	startHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
time
	(self
		privateIsValidSecond: second
		hourNumber: hour
		minuteNumber: minute) ifFalse: [self error: 'Invalid time'].
	^self timeClass
		hour: hour
		minute: minute
		second: second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
time: aTime
	second := aTime second.
	hour := aTime hour.
	minute := aTime minute! !

!WATimeSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:22'!
timeClass
	^Time! !

!WATimeSelector methodsFor: 'testing' stamp: 'jlr 4/4/2006 23:46'!
timeIsValid
	[self time] on: Error do: [:e | ^ false].
	^ true! !

WAComponent subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WATrail class methodsFor: 'instance creation' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	| last selected |
	last := nil.
	html unorderedList
		class: 'trail';
		with: [
			root visiblePresentersDo: [ :each |
				(each isDecoration and: [each isDelegation]) ifTrue: [
					(each component respondsTo: #trailName) ifTrue: [
						last := each.
						html listItem: [
							html anchor
								callback: [ each remove ];
								with: each component trailName ] ] ] ].
			selected := last ifNil: [ root ] ifNotNil: [ last delegate ].
			(selected respondsTo: #trailName) ifTrue: [
				html listItem: selected trailName ] ]! !

!WATrail methodsFor: 'accessing' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root := anObject! !

!WATrail methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
style
^'	ul.trail {
		margin-left: 0;
		padding-left: 0;
		display: inline;
		border: none;
	}
	ul.trail li {
        	margin-left: 0;
        	padding-left: 2px;
        	border: none;
        	list-style: none;
        	display: inline;
	}

	ul.trail  li:before {
        content: "\0020 \0020 \0020 \00BB \0020";
        }

	ul.trail li.first:before {
        content: " ";
        }
'! !

WAComponent subclass: #WATree
	instanceVariableNames: 'root selected expanded childrenBlock labelBlock canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WATree class methodsFor: 'examples' stamp: 'lr 3/27/2006 11:13'!
exampleCollectionClasses
	^ self new
		root: Collection;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		yourself! !

!WATree class methodsFor: 'examples' stamp: 'pmm 11/20/2007 15:48'!
exampleObjectExplorer
	^ self new
		root: 'dispatcher' -> WADispatcher default;
		labelBlock: [ :assoc | assoc key toString , ': ' , assoc value printString ];
		childrenBlock: [ :assoc | assoc value inspectorFields ];
		yourself! !

!WATree class methodsFor: 'instance-creation' stamp: 'lr 3/27/2006 11:08'!
root: anObject
	^ self new
		root: anObject;
		yourself! !

!WATree class methodsFor: 'instance-creation' stamp: 'lr 3/27/2006 11:09'!
root: anObject path: anArray
	^ (self root: anObject)
		expandAll: anArray;
		selected: anArray last;
		yourself! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
canSelect: aNode
	^self selectBlock notNil
		and: [ self canSelectBlock isNil
			or: [ self canSelectBlock value: aNode ] ]! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 12:11'!
canSelectBlock
	^canSelectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 3/7/2005 17:40'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
childrenBlock
	^childrenBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 3/27/2006 09:12'!
childrenOf: aNode
	| children |
	children := self childrenBlock value: aNode.
	^ children ifNil: [ Array new ]! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
collapse: aNode
	expanded remove: aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
expand: aNode
	expanded add: aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
expandAll: aCollection
	expanded addAll: aCollection! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
hasChildren: aNode
	^(self childrenOf: aNode)
		isEmpty not! !

!WATree methodsFor: 'initialization' stamp: 'pmm 11/20/2007 15:48'!
initialize
	super initialize.
	expanded := IdentitySet new.
	self selectBlock: [ :node | self answer: node ].
	self childrenBlock: [ :node | Array new ].
	self labelBlock: [ :node | node toString ]! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isExpanded: aNode
	^expanded includes: aNode! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
labelBlock
	^labelBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 10/28/2007 14:42'!
labelOf: aNode
	^self labelBlock value: aNode! !

!WATree methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	self renderTreeOn: html! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:27'!
renderNode: aNode on: html
	html listItem: [
		self renderNodeButton: aNode on: html.
		self renderNodeLabel: aNode on: html.
		self renderNodeChildren: aNode on: html ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 10/28/2007 14:42'!
renderNodeButton: aNode on: html
	| isExpanded |
	html span
		class: 'button';
		with: [
			(self hasChildren: aNode) ifTrue: [
				isExpanded := self isExpanded: aNode.
				self
					renderNodeButtonLink: aNode
					action: (MessageSend
						receiver: self
						selector: (isExpanded
							ifTrue: [ #collapse: ]
							ifFalse: [ #expand: ])
						argument: aNode)
					text: (isExpanded
						ifTrue: [ '-' ]
						ifFalse: [ '+' ])
					on: html ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:24'!
renderNodeButtonLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 10/28/2007 14:42'!
renderNodeChildren: aNode on: html
	| children |
	children := self childrenOf: aNode.
	children isEmpty ifFalse: [
		(self isExpanded: aNode) ifTrue: [
			html unorderedList: [
				children do: [ :each |
					self renderNode: each on: html ] ] ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 10/28/2007 14:42'!
renderNodeLabel: aNode on: html
	| label |
	html span
		class: 'label';
		class: (self selected == aNode
			ifTrue: [ 'active' ]
			ifFalse: [ 'inactive' ]);
		with: [
			label := self labelOf: aNode.
			(self canSelect: aNode)
				ifFalse: [ html render: label ]
				ifTrue: [
					self
						renderNodeLabelLink: aNode
						action: (MessageSend
							receiver: self
							selector: #select:
							argument: aNode)
						text: label on: html ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:28'!
renderNodeLabelLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderTreeOn: html
	html unorderedList: [ self renderNode: self root on: html ]! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root
	^root! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root: aNode
	root := aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
select: aNode
	(self canSelect: aNode) ifTrue: [
		self selected: aNode.
		self selectBlock isNil
			ifFalse: [ self selectBlock value: aNode ] ]! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock
	^selectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected
	^selected! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected: aNode
	selected := aNode! !

!WATree methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:56'!
states
	^ Array with: expanded! !

WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WADecoration commentStamp: '<historical>' prior: 0!
I am an abstract decoration around instances of WAComponent. I can be added to aComponent by calling #addDecoration: and I change the basic behaviour or look of a component. There are several methods that can be overriden to archive this:

- #renderContentOn: to emit xhtml around the decorated component. Call #renderOwnerOn: to let the owner emit its output.

- #processChildCallbacks: to intercept the callback processing of the owner.

- #handleAnswer: to intercept the answer processing.!

WADecoration subclass: #WAAnswerHandler
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WAAnswerHandler methodsFor: 'accessing' stamp: 'avi 6/2/2004 21:59'!
block: aBlock
	block := aBlock! !

!WAAnswerHandler methodsFor: 'processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	block value: anObject! !

WADecoration subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WABasicAuthentication commentStamp: 'rew 9/24/2007 20:28' prior: 0!
WABasicAuthentication password protects its component using the standard Http basic authentication, which passes usernames & passwords in clear text. You must set the authenticator, which validates usernames and passwords.

Seaside has a number of ways to authenticate a user: WAComponent>>registerAsAuthenticatedApplication:, WAAuthMain, WAAuthConfiguration. One can also use a task or a session to authenticate. These methods can be used to authenicate a session or application rather than a single component.

Instance Variables:
	authenticator	<Authenticator>	Any object that implements the method verifyPassword:forUser:
	realm	<String>	An http realm is a string used to identify a set of pages that are convered by the same login

!

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 2/2/2004 13:03'!
authenticator: anAuthenticator
	authenticator := anAuthenticator! !

!WABasicAuthentication methodsFor: 'testing' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WABasicAuthentication methodsFor: 'processing' stamp: 'lr 8/20/2007 23:41'!
processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self respondWithChallenge ]! !

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:04'!
realm
	^ realm ifNil: [self session application basePath]! !

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:52'!
realm: aString
	realm := aString! !

!WABasicAuthentication methodsFor: 'processing' stamp: 'avi 5/19/2004 14:16'!
respondWithChallenge
	self session returnResponse: (WAResponse basicAuthWithRealm: self realm)! !

!WABasicAuthentication methodsFor: 'processing' stamp: 'lr 8/20/2007 23:42'!
updateRoot: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [ super updateRoot: aStream ]
		ifFalse: [ self respondWithChallenge ]! !

!WABasicAuthentication methodsFor: 'processing' stamp: 'lr 8/20/2007 23:41'!
verifyRequest: aRequest
	^ authenticator verifyPassword: aRequest password forUser: aRequest user! !

!WADecoration methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
asComponent
	^ self component! !

!WADecoration methodsFor: 'accessing' stamp: 'avi 3/27/2004 22:13'!
component
	^ self owner isDecoration
		ifTrue: [self owner component]
		ifFalse: [self owner]! !

!WADecoration methodsFor: 'call/answer' stamp: 'avi 6/22/2004 11:02'!
handleAnswer: anObject
	(self owner handleAnswer: anObject) ifFalse:
		[self handleAnswer: anObject continueWith: [^ false]].
	^ true! !

!WADecoration methodsFor: 'processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	aBlock value! !

!WADecoration methodsFor: 'initialization' stamp: 'lr 9/5/2007 11:21'!
initialize
	super initialize.
	next := WAValueHolder new! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ true! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 22:23'!
isDelegation
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:48'!
isGlobal
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:49'!
isLocal
	^ (self isGlobal or: [self isDelegation]) not! !

!WADecoration methodsFor: 'iterating' stamp: 'avi 6/8/2004 12:43'!
nextPresentersDo: aBlock
	aBlock value: self owner! !

!WADecoration methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:49'!
owner
	^ next contents! !

!WADecoration methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:49'!
owner: aPresenter
	next contents: aPresenter! !

!WADecoration methodsFor: 'actions' stamp: 'avi 3/29/2004 16:10'!
remove
	self component removeDecoration: self! !

!WADecoration methodsFor: 'rendering' stamp: 'avi 3/27/2004 21:07'!
renderOwnerOn: html
	self owner ifNotNilDo: [:owner | owner renderWithContext: html context]! !

!WADecoration methodsFor: 'rendering' stamp: 'lr 2/20/2007 12:08'!
showHalo
	^ false! !

!WADecoration methodsFor: 'updating' stamp: 'lr 4/20/2007 20:18'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	aSnapshot register: next! !

WADecoration subclass: #WADelayedAnswerDecoration
	instanceVariableNames: 'delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'lr 5/23/2007 19:58'!
delay
	^ delay ifNil: [ 1 ]! !

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:34'!
delay: aNumber
	delay := aNumber! !

!WADelayedAnswerDecoration methodsFor: 'path' stamp: 'pmm 11/20/2007 15:42'!
updateRoot: aRoot
	| callbacks url |
	callbacks := WACallbackRegistry context: aRoot context owner: self.
	url := aRoot context actionUrl withParameter: (callbacks registerActionCallback: [self component answer]).
	aRoot meta redirectAfter: self delay to: url toString! !

WADecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate
	^ delegate! !

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate: aComponent
	delegate := aComponent! !

!WADelegation methodsFor: 'testing' stamp: 'avi 3/27/2004 22:26'!
isDelegation
	^ true! !

!WADelegation methodsFor: 'iterating' stamp: 'avi 4/22/2004 14:51'!
nextPresentersDo: aBlock
	delegate decorationChainDo: aBlock! !

WADecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAFormDecoration commentStamp: 'rew 9/13/2007 21:21' prior: 0!
A WAFormDecoration places its component inside an html form tag. The buttons inst var must be set. The component that a WAFormDecoration decorates must implement the method "defaultButton", which returns the string/symbol of the default button (one selected by default) of the form. Don't place any decorators between WAFormDecoration and its component otherwise "defaultButton" method fails. For each string/symbol in the buttons inst var the decorated component must implement a method of the same name, which is called when the button is selected.

Instance Variables
	buttons:		<Collection of strings or symbols>

buttons
	- list of strings or symbols, each string/symbol is the label (first letter capitalized) for a button and the name of the callback method on component when button is pressed, 
!

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:36'!
buttons
	^ buttons! !

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:34'!
buttons: selectorArray
	buttons := selectorArray! !

!WAFormDecoration methodsFor: 'actions' stamp: 'lr 12/1/2007 08:18'!
defaultAction
	self component perform: self component defaultButton! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderButtonForSelector: aSymbol on: html
	html submitButton on: aSymbol of: self component! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'lr 9/25/2007 23:29'!
renderButtonsOn: html
	html div class: 'dialog-buttons'; with: [
		self buttons do: [ :each |
			html  span
				class: 'dialog-button-' , each;
				with: [ self renderButtonForSelector: each on: html ] ] ]! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 15:50'!
renderContentOn: html
	html form
		defaultAction: [ self defaultAction ];
		with: [
			self renderOwnerOn: html.
			self renderButtonsOn: html ]! !

WADecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAMessageDecoration commentStamp: 'rew 9/13/2007 16:57' prior: 0!
I add a string message on top of the WAComponent I decorate. For example if change WACounter>>initialize as below the text "Counter Example" will appear on above the counter when rendered.

WACounter>>initialize
	super initialize.
	self count: 0.
	self addMessage: 'Counter Example'	"added line"

!

!WAMessageDecoration methodsFor: 'accessing' stamp: 'avi 3/12/2004 00:43'!
message: aString
	message := aString! !

!WAMessageDecoration methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html heading level3; with: message.
	self renderOwnerOn: html! !

WADecoration subclass: #WASessionProtector
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WASessionProtector commentStamp: 'pmm 5/2/2007 21:46' prior: 0!
I bind a session to an IP address.

The problem I solve is when you navigate from a Seaside "page" to a different page then this page will have enough information to hijack your old session. This can happen for example with blogs that display the referer.

I don't work for users that have the same IP. This is the case if they are NATed (universities, companies, ...). I can be circumvened if the application is not behind an Apache proxy.

An alternative to solve the same problem is to use a session cookie.

Usage:
In your root component class implement

initialize
	super initialize.
	self addDecoration: WASessionProtector new!

!WASessionProtector methodsFor: 'testing' stamp: 'lr 1/3/2008 13:15'!
isGlobal
	^ true! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 8/31/2004 19:36'!
processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
remoteAddressFromRequest: aRequest
	^aRequest
		headerAt: 'x-forwarded-for'
		ifAbsent: [ aRequest nativeRequest remoteAddress ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'pmm 8/26/2007 14:26'!
renderContentOn: html
	self renderOwnerOn: html! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 10/28/2007 14:42'!
respondNotVerified
	self session redirectTo: self session application basePath! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 8/31/2004 19:38'!
storedRemoteAddress
	remoteAddress isNil
		ifTrue: [ remoteAddress := self remoteAddressFromRequest: self session currentRequest ].
	^remoteAddress! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'pmm 8/26/2007 14:26'!
updateRoot: html
	super updateRoot: html.
	(self verifyRequest: self session currentRequest)
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'testing' stamp: 'lr 8/31/2004 19:31'!
verifyRequest: aRequest
	^(self remoteAddressFromRequest: aRequest) = self storedRemoteAddress! !

WADecoration subclass: #WATransaction
	instanceVariableNames: 'active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WATransaction commentStamp: 'pmm 9/25/2007 20:27' prior: 0!
WATransaction ensures that the component it decorates is not repeated once the "transaction" is completed. For example once a user has submitted an order you don't want them to use the web browser's back button to accidentally resubmit the order. WATransaction does not support rollbacks.

Normally you will not use this class directly. Instead use WAComponent>>isolate: in a task.

Instance Variables:
	active	<Boolean>	false indicates the transaction is over.
!

!WATransaction methodsFor: 'open/close' stamp: 'ab 1/15/2003 21:55'!
close
	active := false! !

!WATransaction methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:36'!
initialize
	super initialize.
	active := true! !

!WATransaction methodsFor: 'testing' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WATransaction methodsFor: 'forwarding' stamp: 'lr 8/17/2007 10:01'!
processChildCallbacks: aStream
	^ active
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self session pageExpired ]! !

!WATransaction methodsFor: 'rendering' stamp: 'avi 9/8/2004 12:18'!
renderContentOn: html
	active
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self session pageExpired ]! !

WADecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock exceptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAValidationDecoration commentStamp: 'rew 9/13/2007 22:16' prior: 0!
A WAValidationDecoration validates its component form data when the component returns using "answer" or "answer:". A WAValidationDecoration can be added to component via the method "validateWith:" as below.

	SampleLoginComponent>>intialize
		form := WAFormDecoration new buttons: self buttons.
		self addDecoration: form.
		self validateWith: [:answerArgOrSelf | answerArgOrSelf validate].
		self addMessage: 'Please enter the following information'.

If component returns via "answer:" the answer: argument is passed to the validate block. If the component returns using "answer" the sender of "answer" is passed to the validate block.

Instance Variables
	exceptionClass:		<Notification>
	message:		<String>
	validationBlock:		<one arg block>

exceptionClass
	- Type of notication that is raised by validation code when validation fails. Default value is WAValidationNotification

message
	- String message displayed on validation failure. Obtained from the notification

validationBlock
	- One arg block, 
!

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 6/3/2006 22:40'!
exceptionClass
	^exceptionClass ifNil: [exceptionClass := WAValidationNotification]! !

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 7/25/2005 10:19'!
exceptionClass: aClass
	exceptionClass := aClass! !

!WAValidationDecoration methodsFor: 'call/answer' stamp: 'pmm 11/2/2005 23:04'!
handleAnswer: anObject
	^(super handleAnswer: anObject)
		or: [(self validate: anObject) not]! !

!WAValidationDecoration methodsFor: 'request processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	(self validate: anObject) ifTrue: [aBlock value]! !

!WAValidationDecoration methodsFor: 'initialization' stamp: 'lr 9/5/2007 11:21'!
initialize
	super initialize.
	message := WAValueHolder new! !

!WAValidationDecoration methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	message contents ifNotNilDo: [ :msg |
		html div
			class: 'validation-error';
			with: msg].
	self renderOwnerOn: html! !

!WAValidationDecoration methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:58'!
states
	^ Array with: message! !

!WAValidationDecoration methodsFor: 'request processing' stamp: 'pmm 11/1/2007 21:33'!
validate: anObject
	[ validationBlock value: anObject.
	message contents: nil.
	^ true ]
		on: self exceptionClass
		do: [ :exception | message contents: exception messageText ].
	^ false! !

!WAValidationDecoration methodsFor: 'convenience' stamp: 'avi 12/10/2003 12:49'!
validateWith: aBlock
	validationBlock := aBlock! !

WADecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAWindowDecoration commentStamp: 'pmm 10/3/2007 21:11' prior: 0!
WAWindowDecoration adds a simple title and close button in a bordered area at the top of the page. When closed button is selected nil is "answer"ed. Useful for a quick & dirty dialog window. Used by WAPlugin and SCTestRunner.

Instance Variables:
	cssClass	<String>	String added to "window-title " to generate cssClass for the title
	title	<String>	title of page
!

!WAWindowDecoration class methodsFor: 'instance creation' stamp: 'pmm 10/3/2007 21:12'!
title: aTitle
	^self new
		title: aTitle;
		yourself! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'lr 5/28/2007 17:52'!
cssClass: aString
	cssClass := aString! !

!WAWindowDecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:52'!
isGlobal
	^ true! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'pmm 10/3/2007 21:12'!
renderCloseButtonOn: html
	html anchor
		title: 'Close';
		callback: [ self component answer: nil ];
		with: [ html html: '&times;' ]! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'lr 5/28/2007 17:56'!
renderContentOn: html
	html div class: 'window'; with: [
		html div class: 'window-titlebar'; with: [
			html div class: 'window-title'; class: cssClass; with: title.
			html div class: 'window-close'; with: [ self renderCloseButtonOn: html ] ].
		html div class: 'window-content'; with: [ self renderOwnerOn: html ] ]! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title := aString! !

!WAPresenter class methodsFor: 'instance creation' stamp: 'avi 4/13/2004 20:14'!
new
	^ self basicNew initialize! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:41'!
application
	^ self session application! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:45'!
fieldsAt: key
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If key is not found, an error is sent."
	^ self session fieldsAt: key! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:45'!
fieldsAt: key ifAbsent: aBlock
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If key is not found, aBlock is evaluated."
	^ self session fieldsAt: key ifAbsent: aBlock! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 11/5/2006 12:46'!
fieldsAt: key ifPresent: aBlock
	"Returns the string value associated to the key in the argument given to your webapplication. The argument can have been sent by a form or written at the end of the url (using ...?key=value construction). If the key is present, execute the block and give it the value as a parameter. Otherwise, answer nil."
	^ self session fieldsAt: key ifPresent: aBlock! !

!WAPresenter methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
handleAnswer: anObject
	self subclassResponsibility! !

!WAPresenter methodsFor: 'request processing' stamp: 'lr 10/28/2007 14:42'!
initialRequest: aRequest
	"When a new session is started, all visible presenters (components or tasks) receive this message with the request as argument.

	A common usage for this is to initialize their state depending on the URL of the request. This is one building block for bookmarkable URL. The other is updateUrl: where you can manipulate the anchor urls generated by Seaside.

	You can not use #call: in here. Consider using a WATask instead and sending #call: in #go.

	See WABrowser for examples."! !

!WAPresenter methodsFor: 'initialization' stamp: 'ab 2/13/2003 01:10'!
initialize! !

!WAPresenter methodsFor: 'decoration' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ false! !

!WAPresenter methodsFor: 'tree' stamp: 'lr 10/28/2007 14:42'!
nextPresentersDo: aBlock
	self subclassResponsibility! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:48'!
preferenceAt: aSymbol
	^ self application preferenceAt: aSymbol! !

!WAPresenter methodsFor: 'convenience' stamp: 'dc 7/16/2006 16:53'!
preferenceAt: aSymbol put: anObject
	^ self application preferenceAt: aSymbol put: anObject! !

!WAPresenter methodsFor: 'request processing' stamp: 'lr 10/28/2007 14:42'!
processCallbackStream: aCallbackStream
	aCallbackStream processCallbacksWithOwner: self.
	self processChildCallbacks: aCallbackStream.
	aCallbackStream processCallbacksWithOwner: self! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 6/8/2004 00:54'!
processChildCallbacks: aStream
	self nextPresentersDo: [:ea | ea processCallbackStream: aStream]! !

!WAPresenter methodsFor: 'deprecated' stamp: 'lr 6/5/2007 21:36'!
registerForBacktracking
	self deprecatedApi: '#registerForBacktracking is not supported, implement #states to backtrack your object'! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 20:59'!
renderContentOn: aRenderer
	self nextPresentersDo: [:ea | ea renderWithContext: aRenderer context]! !

!WAPresenter methodsFor: 'rendering' stamp: 'lr 4/20/2007 22:18'!
renderWithContext: aRenderingContext
	| html callbacks |
	callbacks := aRenderingContext callbacksFor: self.
	html := self rendererClass context: aRenderingContext callbacks: callbacks.
	(self showHalo and: [ aRenderingContext isDebugMode ])
		ifTrue: [ (WAHalo for: self) renderContentOn: html ]
		ifFalse: [ self renderContentOn: html ].
	html flush! !

!WAPresenter methodsFor: 'rendering' stamp: 'pmm 4/7/2007 01:16'!
rendererClass
	"Override this method if you want a custom renderer."
	^ WARenderCanvas! !

!WAPresenter methodsFor: 'rendering' stamp: 'pmm 4/7/2007 17:16'!
script
	"The same as #style except that it is for JavaScript. This is rarely used, consider using WAFileLibrary or exernal files instead."
	^ nil! !

!WAPresenter methodsFor: 'convenience' stamp: 'avi 4/13/2004 19:48'!
session
	^ WACurrentSession value! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 17:27'!
showHalo
	^ true! !

!WAPresenter methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
states
	"Answer a collection of states that should be backtracked."

	^ #()! !

!WAPresenter methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
style
	"Returns a CSS stylesheet associated with this component. This stylesheet will be added to <head> section of the html document so it will be global and not scoped.

	This is done for all visible components (see class comment of WAComponent for what visible means).

	Nice for demos but consider using WAFileLibrary or exernal files instead."

	^ nil! !

!WAPresenter methodsFor: 'updating' stamp: 'lr 10/28/2007 14:42'!
updateRoot: anHtmlRoot
	"This method allows you customize the <head> section of an HTML document. The API is very similar to the 'Canvas API' for rendering in the <body> section (where you 'draw' in #renderContentOn:).

	anHtmlRoot is an instance of WAHtmlRoot

	Whenever you override this method don't forget to send super"

	self script ifNotNilDo: [:script | anHtmlRoot addScript: script].
	self style ifNotNilDo: [:style | anHtmlRoot addStyle: style]! !

!WAPresenter methodsFor: 'updating' stamp: 'lr 10/28/2007 14:42'!
updateStates: aSnapshot
	"This method allows to register objects for backtracking. Don't forget to send super in all cases."

	self states do: [ :each | aSnapshot register: each ]! !

!WAPresenter methodsFor: 'updating' stamp: 'lr 10/28/2007 14:42'!
updateUrl: aUrl! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 3/27/2004 20:59'!
withNextPresentersDo: aBlock
	aBlock value: self.
	self nextPresentersDo: [:ea | ea withNextPresentersDo: aBlock]! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'mutex process semaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAProcessMonitor commentStamp: 'rew 10/19/2007 10:49' prior: 0!
WAProcessMonitor executes a block in a new process. Ensures that only one such block is executed at a time. See method critical:ifError:

Instance Variables:
	mutex	<Semaphore>	Used to sure that only one block is executed at a time
	process	<Process>	New process used to execute block
	semaphore	<Semaphore>	Used to signal when process is done

!

!WAProcessMonitor class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAProcessMonitor methodsFor: 'mutual exclusion' stamp: 'pmm 7/8/2007 16:44'!
critical: aBlock ifError: anErrorBlock
	"Evaluate aBlock as a mutual exclusive block within a new processes and wait for the process to finish. Evaluate anErrorBlock in case of a problem. Answer the result of evaluating the blocks. Note, that the semaphore needs to be an instance-variable, otherwise continuations might screw up the debugger."

	| value |
	mutex critical: [
		semaphore := SeasidePlatformSupport semaphoreClass new.
		process := [
			[ value := aBlock on: Error do: anErrorBlock ]
				ensure: [ semaphore signal ] ] fork.
		semaphore wait ].
	process := nil.
	^ value! !

!WAProcessMonitor methodsFor: 'initialization' stamp: 'pmm 7/8/2007 16:44'!
initialize
	mutex := SeasidePlatformSupport semaphoreClass forMutualExclusion! !

!WAProcessMonitor methodsFor: 'controlling' stamp: 'avi 1/16/2005 00:38'!
terminate
	process ifNotNil: [process terminate]! !

Object subclass: #WAQualifiedValue
	instanceVariableNames: 'value quality'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAQualifiedValue commentStamp: 'pmm 1/4/2008 14:45' prior: 0!
A WAQualifiedValue is an Object with an assigned quality value.

Instance Variables
	quality:		<Float>
	value:		<Object>

quality
	- between 0.0 and 1.0 or Float infinity if no value is given

value
	- the qualified object!

WAQualifiedValue subclass: #WAAccept
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAccept class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:56'!
valueClass
	^WAMimeType! !

WAQualifiedValue subclass: #WAAcceptLanguage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAcceptLanguage class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:59'!
valueClass
	^WALocale! !

!WAQualifiedValue class methodsFor: 'instance creation' stamp: 'pmm 11/21/2007 22:14'!
fromString: aString
	^Array streamContents: [ :stream |
		| values |
		values := aString findTokens: ','.
		values do: [ :each |
			| value quality |
			(each includes: $;)
				ifTrue: [
					value := self valueClass fromString: (each copyUpTo: $;) trimBlanks.
					quality := Float readFrom: ((each copyAfter: $;) copyAfter: $=) readStream ]
				ifFalse: [
					value := self valueClass fromString: each trimBlanks.
					quality := Float infinity ].
			stream nextPut: (self value: value quality: quality) ] ]! !

!WAQualifiedValue class methodsFor: 'instance creation' stamp: 'pmm 11/21/2007 21:54'!
value: anObject quality: aFloat
	^self new
		value: anObject;
		quality: aFloat;
		yourself! !

!WAQualifiedValue class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:51'!
valueClass
	self subclassResponsibility! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:47'!
quality
	^ quality! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:48'!
quality: aFloat
	quality := aFloat! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:48'!
value
	^ value! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:47'!
value: anObject
	value := anObject! !

Object subclass: #WARadioGroup
	instanceVariableNames: 'canvas key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WARadioGroup class methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:30'!
canvas: aRenderCanvas
	^ self basicNew initializeWithCanvas: aRenderCanvas! !

!WARadioGroup methodsFor: 'initialize-release' stamp: 'lr 10/28/2007 14:42'!
initializeWithCanvas: aRenderCanvas
	canvas := aRenderCanvas.
	key := aRenderCanvas callbacks registerDispatchCallback! !

!WARadioGroup methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:32'!
key
	^ key! !

!WARadioGroup methodsFor: 'public api' stamp: 'ac 7/6/2005 11:31'!
radioButton
	^ canvas radioButton group: self! !

Object subclass: #WARedirectHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WARedirectHandler class methodsFor: 'actions' stamp: 'lr 10/11/2007 11:05'!
redirectPageExpiredTo: aUrl
	^ self new redirectPageExpiredTo: aUrl! !

!WARedirectHandler class methodsFor: 'actions' stamp: 'lr 10/11/2007 09:43'!
redirectTo: aUrl
	^ self new redirectTo: aUrl! !

!WARedirectHandler methodsFor: 'actions' stamp: 'pmm 12/31/2007 11:50'!
redirectPageExpiredTo: aUrl
	^ (WAResponse
		refreshWithMessage: 'That page has expired.'
		location: aUrl toString
		delay: 3)
		gone;
		yourself! !

!WARedirectHandler methodsFor: 'actions' stamp: 'pmm 11/20/2007 15:47'!
redirectTo: aUrl
	^ WAResponse redirectTo: aUrl toString! !

Object subclass: #WARenderLoop
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARenderLoop methodsFor: 'accessing-conveniance' stamp: 'lr 10/28/2007 14:42'!
application
	"Answer the application to which this entry point is associated."

	^ self session application! !

!WARenderLoop methodsFor: 'processing' stamp: 'lr 1/3/2008 13:29'!
call: aComponent
	^ AnswerContinuation currentDo: [ :cc |
		aComponent onAnswer: cc.
		self root: aComponent.
		self run ]! !

!WARenderLoop methodsFor: 'accessing-properties' stamp: 'lr 8/17/2007 09:56'!
renderContinuationClass
	^ self application preferenceAt: #renderContinuationClass! !

!WARenderLoop methodsFor: 'accessing' stamp: 'lr 4/20/2007 15:12'!
root
	^ root! !

!WARenderLoop methodsFor: 'accessing' stamp: 'lr 1/3/2008 13:29'!
root: aComponent
	root := aComponent.
	self application decorationClasses
		do: [ :each | root addDecoration: each new ]! !

!WARenderLoop methodsFor: 'processing' stamp: 'lr 8/17/2007 09:54'!
run
	(self renderContinuationClass root: self root) run! !

!WARenderLoop methodsFor: 'accessing-conveniance' stamp: 'lr 10/28/2007 14:42'!
session
	"Answer the session to which this entry point is associated."

	^ WACurrentSession value! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'session actionUrl count callbacks document mode properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WARenderingContext class methodsFor: 'instance creation' stamp: 'avi 3/25/2004 02:21'!
new
	^ self basicNew initialize! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
absoluteUrlForResource: aString
	| url |
	(aString isNil or: [ aString beginsWith: 'http' ])
		ifTrue: [ ^ aString ].
	url := self session application resourceBaseUrl.
	url ifNil: [ ^ aString ].
	^ url , aString! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:13'!
actionUrl: anObject
	actionUrl := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 00:42'!
advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 4/19/2006 08:05'!
callbackAt: aString
	^ callbacks at: aString ifAbsent: [ ]! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 02:01'!
callbackStreamForRequest: aRequest
	^ WACallbackStream callbacks: callbacks request: aRequest! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:17'!
callbacksFor: anObject
	^ WACallbackRegistry context: self owner: anObject! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
clearMode
	mode := nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count
	^ count! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count: anInteger
	count := anInteger! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
debugMode
	mode := #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 11/27/2005 19:22'!
increaseKey
	count contents: count contents + 1! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'lr 9/5/2007 11:47'!
initialize
	count := WAValueHolder with: 1.
	callbacks := Dictionary new! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:20'!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'pmm 11/20/2007 15:47'!
nextKey
	^ count contents toString! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
properties
	^ properties ifNil: [properties := Dictionary new]! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key ifAbsent: aBlock
	^ self properties at: key ifAbsent: aBlock! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key put: value
	^ self properties at: key put: value! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:52'!
registry
	^ WACurrentSession value application! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'lr 4/20/2007 19:57'!
release
	super release.
	document := nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 4/10/2007 10:06'!
session
	^ session! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 4/10/2007 10:06'!
session: aSession
	session := aSession! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
storeCallback: aCallback
	| key |
	key := self advanceKey.
	callbacks at: (aCallback convertKey: key) put: aCallback.
	^ key! !

!WARenderingContext methodsFor: 'documents' stamp: 'lr 10/28/2007 14:42'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:02'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'pmm 11/20/2007 15:47'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ (self registry urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)) toString! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'mb 5/30/2006 12:13'!
renderBlock: aBlock title: aString
	^ self new
		title: aString;
		valueBlock: aBlock;
		yourself! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 17:42'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock;
		yourself! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:49'!
canRender
	^valueBlock numArgs > 1! !

!WAReportColumn methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
canSort
	^self canRender not and: [sortBlock notNil]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock := aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
hasTotal: aBoolean
	hasTotal := aBoolean! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock := [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'initialize-release' stamp: 'pmm 11/20/2007 15:47'!
initialize
	formatBlock := [ :x | x toString ].
	sortBlock := [ :a :b | a <= b ].
	valueBlock := [ :row | nil ].
	clickBlock := nil.
	title := 'Untitled'.
	hasTotal := false! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:47'!
renderValue: anObject on: html
	valueBlock value: anObject value: html! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock := [:row | row perform: aSymbol]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs := anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs := assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title := aString! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 11/12/2002 14:31'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
valueBlock: aBlock
	valueBlock := aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields headers cookies method nativeRequest responseStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WARequest commentStamp: 'pmm 5/27/2007 21:54' prior: 0!
I am a server independent http request object. Instance of me can be aquired through WASession >> #currentRequest!

!WARequest class methodsFor: 'instance-creation' stamp: 'avi 8/29/2005 21:19'!
blankRequest
	^ self
			method: 'GET'
			url: ''
			headers: Dictionary new
			fields: Dictionary new
			cookies: Dictionary new! !

!WARequest class methodsFor: 'instance-creation' stamp: 'ab 8/26/2003 19:34'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	^ self new setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict! !

!WARequest class methodsFor: 'instance-creation' stamp: 'avi 4/28/2004 10:57'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict nativeRequest: anObject
	^ (self method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict)
		nativeRequest: anObject;
		yourself! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
accept
	^ self headerAt: 'accept'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:28'!
acceptCharset
	^ self headerAt: 'accept-charset'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:27'!
acceptEncoding
	^ self headerAt: 'accept-encoding'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:27'!
acceptLanguage
	^ self headerAt: 'accept-language'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'ac 11/12/2005 00:46'!
at: key ifPresent: aBlock
	^ fields at: key ifPresent: aBlock! !

!WARequest methodsFor: 'private' stamp: 'ab 1/13/2003 22:40'!
authorization
	^ (self headerAt: 'Authorization' ifAbsent: [self headerAt: 'authorization'])
		ifNotNilDo: [:auth | self decodeAuthorization: auth]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'lr 5/10/2007 22:17'!
cookieAt: aKey
	^ cookies ifNotNil: [ cookies at: aKey ifAbsent: [] ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'lr 5/10/2007 22:07'!
cookies
	^ cookies ifNil: [ cookies := Dictionary new ]! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/29/2006 07:28'!
host
	^ self headerAt: 'host'! !

!WARequest methodsFor: 'testing' stamp: 'mb 3/31/2006 09:41'!
includesKey: key
	^ fields includesKey: key! !

!WARequest methodsFor: 'testing' stamp: 'avi 3/22/2004 12:58'!
isGet
	^ self method asUppercase = 'GET'! !

!WARequest methodsFor: 'testing' stamp: 'avi 5/9/2005 13:13'!
isPrefetch
	^ (self headerAt: 'HTTP_X_MOZ') = 'prefetch'! !

!WARequest methodsFor: 'testing' stamp: 'lr 7/3/2006 09:25'!
isXmlHttpRequest
	^ (self headerAt: 'x-requested-with') = 'XMLHttpRequest'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest
	^ nativeRequest! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest: aRequest
	nativeRequest := aRequest! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
password
	^ self authorization ifNotNilDo: [:auth | auth copyAfter: $:]! !

!WARequest methodsFor: 'printing' stamp: 'lr 4/20/2007 19:12'!
printOn: aStream
	super printOn: aStream.
	aStream space; nextPutAll: self method.
	aStream space; nextPutAll: self url! !

!WARequest methodsFor: 'accessing-headers' stamp: 'ac 6/17/2006 16:28'!
referer
	^ self headerAt: 'referer'! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream
	^ responseStream! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream: aStream
	responseStream := aStream! !

!WARequest methodsFor: 'private' stamp: 'avi 3/19/2004 13:52'!
setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	method := methodString.
	url := urlString.
	headers := headDict.
	fields := fieldDict.
	cookies := cookieDict! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
user
	^ self authorization ifNotNilDo: [:auth | auth copyUpTo: $:]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
userAgent
	^ self headerAt: 'user-agent'! !

Object subclass: #WARequestHandler
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARequestHandler commentStamp: 'rew 10/19/2007 10:44' prior: 0!
WARequestHandler is an abstract class whose subclasses handle http requests. Most of the methods are either empty or return a default value. 

Subclasses must implement the following messages:
	handleRequest:	process the request

Instance Variables:
	parent	<WADispatcher | WAApplication | nil> What owns or manages the handler. WADispatchers manage WADispatchers & WAApplications, WAApplications own WASessions

!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WADocumentHandler commentStamp: 'pmm 10/20/2007 23:22' prior: 0!
WADocumentHandler handles requests for images, text documents and binary files (byte arrays). This class is not normally used directly. A number of WA*Tag classes implement document:mimeType:fileName: which use WADocumentHandler. Given a document document:mimeType:fileName: creates a WADocumentHandler on the document, registers the handler with a dispatcher, and adds the correct url in the tag for the document.

Instance Variables:
	document	<ByteArray | GIFImage | Image | String | WACachedDocument | any class that understands #asMIMEDocumentType:>	contents of the document
	fileName	<String>	file containing the document to be sent as an attachment, nil if no such file
	mimeDocument	<MIMEDocument>	MIMEDocument object representing this document and mimeType, generates stream used to write document for the response. 
	mimeType	<String>	standard HTTP mime type
!

!WADocumentHandler class methodsFor: 'public api' stamp: 'avi 11/3/2003 12:23'!
document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'lr 2/12/2007 19:38'!
= other
	^ other species = self species
		and: [ other document = self document
		and: [ other mimeType = self mimeType ] ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'actions' stamp: 'ab 8/17/2003 12:43'!
handleRequest: aRequest
	^ self response! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'initialization' stamp: 'pmm 11/21/2007 20:51'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document := anObject.
	mimeString isNil ifFalse: [
		mimeType := mimeString toMimeType ].
	fileName := fileString! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:37'!
mimeDocument
	^ mimeDocument ifNil: [ mimeDocument := document asMIMEDocumentType: mimeType ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'pmm 11/21/2007 20:27'!
response
	| response |
	response := WAResponse new.
	response contents: self mimeDocument contentStream.
	response contentType: (mimeType ifNil: [ self mimeDocument contentType toMimeType ]).
	response cacheForever.
	fileName ifNotNil: [ response attachmentWithFileName: fileName ].
	^ response! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAEntryPoint commentStamp: 'rew 10/19/2007 10:45' prior: 0!
WAEntryPoint represents a named entry point to a request handler.

Given a seaside application URL, http://localhost:8008/seaside/tests/alltests, the path parts of the url are mapped to WARequestHandlers. "seaside" & "tests" map to WADispatchers, "alltests" maps to a WAApplication. These individual path parts are used as the names of the WARequestHandlers. WAEntryPoint is an abstract class that handles the name of WARequestHandlers. WAEntryPoint constructs the proper url path for this handler.

Instance Variables:
	name	<String>	the name or path part of this handler

!

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints defaultName lastUpdate version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher commentStamp: 'rew 10/19/2007 10:46' prior: 0!
WADispatcher takes http requests and dispatches them to the correct handler (WAApplication, WAFileHandler, WANotFoundHandler, etc). 

WADispatcher class>>default is the top level dispatcher. When a Seaside application is registered as "foo" the application is added to the top level dispatcher. The application is added to the entryPoints of the dispatcher at the key "foo". If a Seaside application is registered as "bar/foo" then the application isadded to a  dispatcher's entryPoints at the key "foo". That dispatcher is in the top level dispatcher's  entryPoints at the key "bar". 
  
When a http request is received it is sent to WADispatcher class>>default to find the correct handler for the request. If a handler exists for the request is sent to that handler. Otherwise the request is sent to WANotFoundHandler.

The VW port maintains multiple copies of the tree of dispatchers rooted at WADispatcher class>>default. One copy is for each different URL that can reach Seaside (http://..../seaside/go/counter - normal, http://..../counter - SeasideShortPath, http://..../seaside/stream/counter - streaming). 

Instance Variables:
	defaultName	<String>
	entryPoints	<(Dictionary of: (WAApplication | WADispatcher | WAFileHandler))>	 the keys are strings, which are the names and URL path segments for the handler at that key
	lastUpdate	<TimeStamp>	Time the dispatcher was last changed
	version	<SmallInteger>	Each time the dispatcher is changed the version is increased by 1
!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 3/19/2007 21:06'!
default
	^ default ifNil: [ default := self named: SeasidePlatformSupport defaultDispatcherName ]! !

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:39'!
description
	^ 'Directory'! !

!WADispatcher class methodsFor: 'initialization' stamp: 'lr 10/28/2007 14:42'!
resetAll
	"To have this todo list somewhere,
	May be used in the WADispatcher tests"
	default := nil.
	WAFileHandler initialize.
	WAFileHandler default.
	WAComponent allSubclasses do: [:ea | ea initialize]! !

!WADispatcher methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
beAwareOfChangeOf: anAspectSymbol with: aParameter from: anEntryPoint
	(anEntryPoint == self
		and: [anAspectSymbol == #name]) ifTrue: [^ self].
	"Here when anything has changed but the name in the
	receiver"
	version := self version + 1.
	lastUpdate := TimeStamp now.

	"following line is for VW Seaside to handle multiple top level dispatchers"
	self changed! !

!WADispatcher methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:53'!
configurationComponent
	^ WADispatcherEditor new dispatcher: self! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 20:07'!
defaultName
	^ defaultName! !

!WADispatcher methodsFor: 'accessing' stamp: 'mb 2/17/2007 23:44'!
defaultName: aString
	defaultName := aString.
	self announceChangeOf: #defaultName with: aString! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 21:44'!
entryPointAt: aString
	^ (aString findTokens: '/') inject: self into: [ :dispatcher :token | dispatcher entryPoints at: token ]! !

!WADispatcher methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WADispatcher methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
handleRequest: aRequest
	aRequest isPrefetch
		ifTrue: [ ^ WAResponse forbidden: aRequest url ].
	^ (self handlerForRequest: aRequest)
		handleRequest: aRequest! !

!WADispatcher methodsFor: 'processing' stamp: 'lr 2/12/2007 20:02'!
handlerForRequest: aRequest
	^ self handlerForRequest: aRequest relativeTo: self basePath! !

!WADispatcher methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
handlerForRequest: aRequest relativeTo: aString
	| fullUrl relativeUrl handlerName |
	fullUrl := aRequest url.
	(aString isEmpty or: [ fullUrl beginsWith: aString ]) ifTrue: [
		relativeUrl := fullUrl allButFirst: aString size.
		handlerName := (relativeUrl notEmpty and: [ relativeUrl first = $/ ])
			ifTrue: [ (relativeUrl findTokens: '/') at: 1 ifAbsent: [ self defaultName ] ]
			ifFalse: [ self defaultName ].
		^ self entryPoints at: handlerName ifAbsent: [
			self entryPoints
				at: self defaultName
				ifAbsent: [ WANotFoundHandler new ] ] ].
       ^ WANotFoundHandler new! !

!WADispatcher methodsFor: 'initialization' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	entryPoints := Dictionary new.
	version := 0! !

!WADispatcher methodsFor: 'testing' stamp: 'mb 5/26/2006 08:51'!
isDispatcher
	^ true! !

!WADispatcher methodsFor: 'testing' stamp: 'lr 2/12/2007 20:59'!
isRoot
	^ self parent isNil! !

!WADispatcher methodsFor: 'accessing' stamp: 'mb 2/17/2007 23:39'!
lastUpdate
	^ lastUpdate! !

!WADispatcher methodsFor: 'copying' stamp: 'mb 2/17/2007 01:31'!
postCopy
	super postCopy.
	entryPoints := entryPoints valuesCollect: [ :each | each copy setParent: self ]! !

!WADispatcher methodsFor: 'registration' stamp: 'lr 10/28/2007 14:42'!
register: anEntryPoint
	anEntryPoint name
		ifNil: [ self error: 'Unable to add unnamed entry point.' ].
	entryPoints
		at: anEntryPoint name
		put: (anEntryPoint setParent: self).
	self announceChangeOf: #entryPoint with: #add -> anEntryPoint.
	^ anEntryPoint! !

!WADispatcher methodsFor: 'registration' stamp: 'lr 10/28/2007 14:42'!
unregister: anEntryPoint
	entryPoints removeKey: anEntryPoint name ifAbsent: [ ^ nil ].
	self announceChangeOf: #entryPoint with: #add->anEntryPoint.
	^ anEntryPoint unregistered! !

!WADispatcher methodsFor: 'accessing' stamp: 'mb 2/21/2007 18:48'!
version
	^ version ifNil: [ version := 0 ]! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:54'!
concreteSubclasses
	^ self allSubclasses reject: [ :each | each isAbstract ]! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

!WAEntryPoint class methodsFor: 'testing' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

!WAEntryPoint class methodsFor: 'instance-creation' stamp: 'lr 2/12/2007 19:56'!
named: aString
	^ self new setName: aString! !

!WAEntryPoint methodsFor: 'private' stamp: 'mb 2/17/2007 23:42'!
announceChangeOf: anAspectSymbol with: aParameter
	"Short-circuit the dependency mechanics"
	self rootDispatcher isNil ifTrue: [^nil "Discard this change"].
	self rootDispatcher beAwareOfChangeOf: anAspectSymbol with: aParameter from: self! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'mb 2/18/2007 01:30'!
basePath
	^ self parent isNil
		ifTrue: [self name isEmpty
				ifTrue: ['']
				ifFalse: ['/' , self name]]
		ifFalse: [self parent basePath , '/' , self name]! !

!WAEntryPoint methodsFor: 'public' stamp: 'lr 2/12/2007 20:53'!
baseUrl
	^ WAUrl new
		addToPath: self basePath;
		yourself! !

!WAEntryPoint methodsFor: 'public' stamp: 'ab 8/26/2003 21:48'!
configurationComponent
	^ nil! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:21'!
description
	^ self class description! !

!WAEntryPoint methodsFor: 'testing' stamp: 'mb 5/26/2006 08:50'!
isEntryPoint
	^ true! !

!WAEntryPoint methodsFor: 'testing' stamp: 'mb 2/17/2007 23:42'!
isRoot
	^false! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:50'!
name
	^ name! !

!WAEntryPoint methodsFor: 'printing' stamp: 'lr 2/12/2007 21:48'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' named: '; print: self name! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
rootDispatcher
	self isRoot ifTrue: [^self].
	self parent isNil ifTrue: [^nil].
	^self parent rootDispatcher! !

!WAEntryPoint methodsFor: 'initialization' stamp: 'mb 2/17/2007 23:46'!
setName: aString
	name := aString.
	self announceChangeOf: #name with: aString! !

WAEntryPoint subclass: #WAFileHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler commentStamp: 'rew 10/19/2007 10:48' prior: 0!
Seaside serves static files using WALibrary subclasses. WAFileHandler handles all requests for WALibrary files (or methods) for all applications on the Seaside server. WAFileHandler is registered with the default WADispatcher automatically.!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:47'!
default
	^ default ifNil: [ default := self registerAsHandler: 'files' ]! !

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:25'!
description
	^ 'Files'! !

!WAFileHandler class methodsFor: 'class initialization' stamp: 'lr 10/28/2007 14:42'!
initialize
	"This is just for the 2.7 version, can be removed later"

	default := nil! !

!WAFileHandler class methodsFor: 'initialization' stamp: 'lr 2/18/2007 12:47'!
registerAsHandler: aString
	^ WADispatcher default register: (self named: aString)! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:18'!
configurationComponent
	^ WAFileHandlerEditor new fileHandler: self! !

!WAFileHandler methodsFor: 'processing' stamp: 'lr 2/18/2007 12:16'!
handleRequest: aRequest
	^ self
		responseAt: (aRequest url findTokens: $/)
		ifAbsent: [ self notFound: aRequest url ]! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:15'!
libraries
	^ self libraryRootClasses gather: [ :each | each allSubclasses ]! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/18/2007 12:16'!
librariesDo: aOneArgumentBlock
	self libraryRootClasses do: [ :each | each allSubclassesDo: aOneArgumentBlock ]! !

!WAFileHandler methodsFor: 'accessing' stamp: 'pmm 7/20/2007 06:52'!
libraryAt: aSymbol ifAbsent: aBlock
	self librariesDo: [ :each |
		(each handlesFolder: aSymbol)
			ifTrue: [ ^ each ] ].
	^ aBlock value! !

!WAFileHandler methodsFor: 'private' stamp: 'pmm 7/20/2007 06:54'!
libraryRootClasses
	^ WALibrary subclasses! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/18/2007 12:17'!
notFound: aString
	^ WAResponse notFound: aString! !

!WAFileHandler methodsFor: 'private' stamp: 'pmm 7/21/2007 23:19'!
responseAt: aPath ifAbsent: aBlock
	| libraryName fileName libraryClass |
	libraryName := aPath at: aPath size - 1.
	fileName := aPath last.
	libraryClass := self
		libraryAt: libraryName asSymbol
		ifAbsent: [ ^ aBlock value ].
	^ libraryClass
		documentAt: fileName
		ifAbsent: aBlock! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARegistry commentStamp: 'rew 10/19/2007 10:46' prior: 0!
WARegistry maintains sessions for a Seaside application. Each session has a key, which is the _s part of Seaside URLs and is embedded in links on pages generated by Seaside. WARegistry checks requests for session keys. If one exists, the request is sent to the proper session. If not the request is a new request so handleDefaultRequest: is called so subclasses can handle the request.

Subclasses must implement the following messages:
	handleDefaultRequest:
		Handle a request without a session key, ie a new request.

Instance Variables:
	handlersByKey	<Dictionary of <session key(string),WASession>>	provides easy access to the session for a session key
	keysByHandler	<Dictionary of <WASession, session key(string)>>	provides easy access to the session key of a session
	mutex	<Semaphore>	Used to insure keysByHandler & handlersByKey are updated atomically
!

WARegistry subclass: #WAApplication
	instanceVariableNames: 'configuration libraries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAApplication commentStamp: 'rew 10/19/2007 10:47' prior: 0!
WAApplication is the starting point for a Seaside application. When a WAComponent is registered as a top level component a WAApplication object is added to a WADispatcher. The dispatcher forwards all requests to the WAApplication, which in turn forwards them to the correct WASession object. WAApplication's parent class WARegistry maintains a list of all active sessions to the application. 

"configuration" contains a chain of WAConfituration classes that define attributes of the application. The attribute "rootComponent", for example, defines the top level WAComponent class for the application. The configuration chain includes WAUserConfiguration, WAGlobalConfiguration, WARenderLoopConfiguration and WASessionConfiguration. Other configurations can be added to the chain when the top level application is registered with a dispatcher. (See below)

"libraries" is a collection of WALibrary classes, which are used to serve css, javascript and images used by the application. These may be in methods or in files. Sometimes these libraries are replaced by static files served by Apache. See WAFileLibrary class comment for more information.

Registering an Application.
	An application can be registered with a dispatcher by using the Seaside configuration page or via code. Below MyComponent is a subclass of WAComponent. The following registers the component as an application, gives some values to attributes (or preferences) and adds a library and a configuration. 

MyComponent class>>initialize
	"self initialize"
	| application |
	application := self registerAsApplication: 'sample'.
	application preferenceAt: #sessionClass put: Glorp.WAGlorpSession.
	application addLibrary: SampleLibrary.
	application configuration addAncestor: GlorpConfiguration new.
	application preferenceAt: #glorpDatabasePlatform put: Glorp.PostgreSQLPlatform.
	application preferenceAt: #databaseServer put: '127.0.0.1'.
	application preferenceAt: #databaseConnectString put: 'glorptests'.

MyComponent>>someInstanceMethod
	"example of how to access attributes (preferences)"
	self session application preferenceAt: #glorpDatabasePlatform!

!WAApplication class methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:38'!
description
	^ 'Application'! !

!WAApplication methodsFor: 'libraries' stamp: 'lr 11/18/2007 15:24'!
addLibrary: aLibraryClass
	self preferenceAt: #libraries put: (self libraries copyWith: aLibraryClass)! !

!WAApplication methodsFor: 'accessing' stamp: 'lr 2/12/2007 22:14'!
baseUrl
	| serverPath |
	serverPath := self serverPath.
	^ (serverPath isNil
		ifTrue: [ super baseUrl ]
		ifFalse: [ WAUrl new addToPath: serverPath ])
			scheme: self serverProtocol;
			hostname: self serverHostname;
			port: self serverPort;
			yourself! !

!WAApplication methodsFor: 'preferences' stamp: 'lr 10/28/2007 14:42'!
configuration
	^ configuration ifNil: [configuration := WAUserConfiguration new addAncestor: self defaultAncestor]! !

!WAApplication methodsFor: 'accessing' stamp: 'lr 11/18/2007 15:01'!
configurationComponent
	^ WAConfigurationEditor new configuration: self configuration! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 1/3/2008 13:22'!
decorationClasses
	^ self preferenceAt: #decorationClasses! !

!WAApplication methodsFor: 'preferences' stamp: 'lr 8/1/2007 20:19'!
defaultAncestor
	^ WARenderLoopConfiguration new! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:02'!
deploymentMode
	^ self preferenceAt: #deploymentMode! !

!WAApplication methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:21'!
description
	^ self rootComponent description! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 2/12/2007 20:47'!
handleDefaultRequest: aRequest
	^ (self sessionClass new setParent: self) handleRequest: aRequest! !

!WAApplication methodsFor: 'request handling' stamp: 'kph 7/11/2007 10:23'!
handleExpiredRequest: aRequest
	| response |
	response := super handleExpiredRequest: aRequest.
	(aRequest cookieAt: self handlerCookieName) isNil
		ifFalse: [ response deleteCookieAt: self handlerCookieName ].
	^ response! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 10/28/2007 14:42'!
handleRequest: aRequest
	(aRequest cookieAt: self handlerCookieName) ifNotNilDo: [ :value |
		aRequest fields
			at: self handlerField
			ifAbsentPut: [ value ] ].
	^ super handleRequest: aRequest! !

!WAApplication methodsFor: 'accessing' stamp: 'lr 7/10/2007 19:47'!
handlerCookieName
	^ self name! !

!WAApplication methodsFor: 'testing' stamp: 'mb 4/5/2006 20:26'!
isApplication
	^true! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 11/18/2007 15:03'!
libraries
	^ self preferenceAt: #libraries! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
login
	^ self preferenceAt: #login! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
password
	^ self preferenceAt: #password! !

!WAApplication methodsFor: 'copying' stamp: 'lr 12/12/2006 11:18'!
postCopy
	super postCopy.
	configuration := configuration copy.
	libraries := libraries copy! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol! !

!WAApplication methodsFor: 'preferences' stamp: 'mb 2/17/2007 23:43'!
preferenceAt: aSymbol put: anObject
	self configuration valueAt: aSymbol put: anObject.
	self announceChangeOf: #preference with: aSymbol->anObject.
	^anObject! !

!WAApplication methodsFor: 'configuration' stamp: 'pmm 2/24/2007 19:48'!
redirectHandler
	^ self preferenceAt: #redirectHandler! !

!WAApplication methodsFor: 'libraries' stamp: 'lr 11/18/2007 15:25'!
removeLibrary: aLibraryClass
	self preferenceAt: #libraries put: (self libraries copyWithout: aLibraryClass)! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:02'!
resourceBaseUrl
	^ self preferenceAt: #resourceBaseUrl! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
rootComponent
	^ self preferenceAt: #rootComponent! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
serverHostname
	^ self preferenceAt: #serverHostname! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:01'!
serverPath
	^ self preferenceAt: #serverPath! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
serverPort
	^ self preferenceAt: #serverPort! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
serverProtocol
	^ self preferenceAt: #serverProtocol! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 10/28/2007 14:42'!
sessionClass
	^ self preferenceAt: #sessionClass! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:03'!
sessionExpirySeconds
	^ self preferenceAt: #sessionExpirySeconds! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 4/9/2007 10:51'!
updateRoot: anHtmlRoot
	self libraries do: [ :each | each default updateRoot: anHtmlRoot ]! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 4/15/2007 16:21'!
updateUrl: anUrl! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 7/10/2007 19:49'!
useSessionCookie
	^ self preferenceAt: #useSessionCookie! !

!WARegistry class methodsFor: 'initialization' stamp: 'lr 3/19/2007 15:34'!
clearAllHandlers
	self allSubInstancesDo: [ :each | each clearHandlers ]! !

!WARegistry methodsFor: 'public' stamp: 'pmm 7/5/2007 19:32'!
clearHandlers
	| handlers |
	self mutex critical: [
		handlers := handlersByKey.
		handlersByKey := SeasidePlatformSupport reducedConflictDictionary new.
		keysByHandler := SeasidePlatformSupport reducedConflictDictionary new ].
	handlers ifNotNil: [
		[ handlers do: [ :each | each unregistered ] ]
			fork ]! !

!WARegistry methodsFor: 'public' stamp: 'lr 2/12/2007 20:40'!
ensureKeyForHandler: anObject
	^ (self keyOrNilForHandler: anObject) ifNil: [ self registerRequestHandler: anObject ]! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/22/2006 08:41'!
expiryPathFor: aRequest
	^ aRequest url! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:29'!
handleDefaultRequest: aRequest
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
handleExpiredRequest: aRequest
	| url |
	aRequest isXmlHttpRequest
		ifTrue: [ ^ WAResponse new forbidden ].
	url := WAUrl new.
	url addToPath: (self expiryPathFor: aRequest).
	url takeServerParametersFromRequest: aRequest.
	aRequest isGet ifTrue: [
		aRequest fields keysAndValuesDo: [ :key :value |
			(url isSeasideField: key)
				ifFalse: [ url addParameter: key value: value ] ] ].
	^ self redirectResponseFor: url! !

!WARegistry methodsFor: 'private' stamp: 'mb 1/27/2006 15:52'!
handleKeyRequest: aRequest
	| key handler keyString |
	"Under some circumstances, HTTP fields are collections of values"
	key :=	[keyString := aRequest at: self handlerField.
			(keyString isKindOf: OrderedCollection) ifTrue: [keyString := keyString first].
			WAExternalID fromString: keyString] on: Error do: [:e | nil].
	handler := handlersByKey at: key ifAbsent: [nil].
	^ (handler notNil and: [handler isActive])
		ifTrue: [handler handleRequest: aRequest]
		ifFalse: [self handleExpiredRequest: aRequest]! !

!WARegistry methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
handleRequest: aRequest
	^ (aRequest fields includesKey: self handlerField)
		ifTrue: [ self handleKeyRequest: aRequest ]
		ifFalse: [ self handleDefaultRequest: aRequest ]! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
handlerField
	^ '_s'! !

!WARegistry methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	self clearHandlers! !

!WARegistry methodsFor: 'private' stamp: 'pmm 2/13/2007 07:21'!
isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_ ]! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/12/2007 20:43'!
keyOrNilForHandler: anObject
	^ self mutex critical: [ keysByHandler at: anObject ifAbsent: [ nil ] ]! !

!WARegistry methodsFor: 'private' stamp: 'pmm 7/8/2007 16:45'!
mutex
	^ mutex ifNil: [ mutex := SeasidePlatformSupport semaphoreClass forMutualExclusion ]! !

!WARegistry methodsFor: 'copying' stamp: 'lr 10/28/2007 14:42'!
postCopy
	super postCopy.
	mutex := nil.
	self clearHandlers! !

!WARegistry methodsFor: 'private' stamp: 'pmm 11/20/2007 15:47'!
redirectResponseFor: aUrl
	^ WAResponse redirectTo: aUrl toString! !

!WARegistry methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
registerRequestHandler: anObject
	| key |
	key := WAExternalID new: 16.
	self shouldCollectHandlers
		ifTrue: [ self unregisterExpiredHandlers ].
	self mutex critical: [
		handlersByKey at: key put: anObject.
		keysByHandler at: anObject put: key ].
	^ key! !

!WARegistry methodsFor: 'private' stamp: 'lr 3/19/2007 19:32'!
shouldCollectHandlers
	^ handlersByKey size \\ 10 = 0! !

!WARegistry methodsFor: 'private' stamp: 'eam 11/7/2007 15:05'!
unregisterExpiredHandlers
	"Private - Unregisters the receiver expired handlers."

	| expired newHandlersByKey newKeysByHandler |
	expired := OrderedCollection new.
	newHandlersByKey := SeasidePlatformSupport reducedConflictDictionary new.
	newKeysByHandler := SeasidePlatformSupport reducedConflictDictionary new.
	self mutex critical: [
		handlersByKey keysAndValuesDo: [ :key :value |
			value isActive
				ifFalse: [ expired add: value ]
				ifTrue: [
					newHandlersByKey at: key put: value.
					newKeysByHandler at: value put: key ] ].
		handlersByKey := newHandlersByKey.
		keysByHandler := newKeysByHandler ].
	[ expired do: [ :each | each unregistered ] ]
		fork! !

!WARegistry methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
unregistered
	super unregistered.
	self clearHandlers! !

!WARegistry methodsFor: 'public' stamp: 'pmm 11/20/2007 15:47'!
urlForRequestHandler: anObject
	| key url |
	key := self ensureKeyForHandler: anObject.
	url := self baseUrl.
	url addParameter: self handlerField value: key toString.
	^ url! !

WARequestHandler subclass: #WAExpiringHandler
	instanceVariableNames: 'lastAccess expired timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAExpiringHandler commentStamp: 'rew 10/19/2007 10:47' prior: 0!
WAExpiringHandler is an abstract class that times out when the time between requests is longer than the value of "timeout"

Subclasses must implement the following messages:
	incomingRequest:
		subclass handles the request in this method

Instance Variables:
	expired	<Boolean>	True if handler has times out
	lastAccess	<Time>	Time the handler was last accessed
	timeout	<Integer>	Length of time in seconds handler will timeout without a request
!

!WAExpiringHandler methodsFor: 'defaults' stamp: 'avi 1/23/2004 12:20'!
defaultTimeoutSeconds
	^ 600! !

!WAExpiringHandler methodsFor: 'actions' stamp: 'avi 1/23/2004 12:18'!
expire
	expired := true! !

!WAExpiringHandler methodsFor: 'testing' stamp: 'lr 2/12/2007 19:41'!
expired
	^ expired! !

!WAExpiringHandler methodsFor: 'processing' stamp: 'avi 1/23/2004 14:08'!
handleRequest: aRequest
	lastAccess := Time totalSeconds.
	^ self incomingRequest: aRequest! !

!WAExpiringHandler methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
incomingRequest: aRequest
	self subclassResponsibility! !

!WAExpiringHandler methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:39'!
initialize
	super initialize.
	expired := false! !

!WAExpiringHandler methodsFor: 'testing' stamp: 'lr 2/12/2007 19:42'!
isActive
	^ self expired not and: [ self secondsSinceLastAccess < self timeoutSeconds ]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'lr 2/27/2007 10:10'!
lastAccess
	^ lastAccess ifNil: [ lastAccess := Time totalSeconds ]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:19'!
secondsSinceLastAccess
	^ Time totalSeconds - self lastAccess! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'lr 2/27/2007 10:10'!
timeoutSeconds
	^ timeout ifNil: [ timeout := self defaultTimeoutSeconds ]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds: aNumber
	timeout := aNumber! !

WAExpiringHandler subclass: #WASession
	instanceVariableNames: 'continuations lastContinuation escapeContinuation monitor currentRequest scripts jumpTo cookiesEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WASession commentStamp: 'lr 5/10/2007 22:41' prior: 0!
I am a Seaside session. A new instance of me gets created when an user accesses an application for the first time and is persistent as long as the user is interacting with it.

This class is intended to be subclasses by applications that need global state, like a user. Custom state can be added by creating instance variables and storing it there. The session can be retrieved by #session if inside a component or task or by evaluating: WACurrentSession value

If the session has not been used for #defaultTimeoutSeconds, it is garbage collected by the system. To manually expire a session call #expire.

A good way to clear all sessions is the following code:

WARegistry clearAllHandlers.
Smalltalk garbageCollect!

!WASession methodsFor: 'accessing' stamp: 'lr 4/15/2007 15:55'!
actionField
	^ '_k'! !

!WASession methodsFor: 'accessing' stamp: 'lr 8/20/2007 22:50'!
actionUrlForContinuation: aContinuation
	^ self actionUrlForKey: (continuations store: (lastContinuation := aContinuation))! !

!WASession methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
actionUrlForKey: aString
	| url |
	url := self application urlForRequestHandler: self.
	self useSessionCookie
		ifTrue: [ url parameters removeKey: self application handlerField ].
	url takeServerParametersFromRequest: currentRequest.
	url addParameter: self actionField value: aString.
	jumpTo ifNotNil: [ url fragment: jumpTo ].
	^ url! !

!WASession methodsFor: 'scripts' stamp: 'lr 4/15/2007 15:55'!
addLoadScript: aString
	^ (scripts ifNil: [scripts := OrderedCollection new]) add: aString! !

!WASession methodsFor: 'accessing' stamp: 'lr 4/15/2007 15:55'!
application
	^ parent! !

!WASession methodsFor: 'accessing' stamp: 'lr 4/15/2007 15:55'!
baseUrl
	^ self parent baseUrl! !

!WASession methodsFor: 'http' stamp: 'lr 4/15/2007 15:55'!
charSet
	^WAResponse defaultValueForCharSet. "utf-8"! !

!WASession methodsFor: 'private' stamp: 'lr 7/10/2007 19:34'!
checkCookiesField
	^ '_c'! !

!WASession methodsFor: 'scripts' stamp: 'lr 4/15/2007 15:55'!
clearJumpTo
	jumpTo := nil! !

!WASession methodsFor: 'scripts' stamp: 'lr 4/15/2007 15:55'!
clearLoadScripts
	scripts := nil! !

!WASession methodsFor: 'responding' stamp: 'pmm 5/23/2007 23:50'!
closePopup
	^ self respond: [ :url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=self.opener.location';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'pmm 11/20/2007 15:48'!
closePopupAndContinue
	^ self respond: [ :url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=', url toString printString;
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'pmm 5/23/2007 23:50'!
closePopupWithoutReloadingOpener
	^ self respond: [ :url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'http' stamp: 'pmm 11/21/2007 15:18'!
contentType
	^ (WAMimeType fromString: self mimeType)
		charset: self charSet;
		yourself! !

!WASession methodsFor: 'accessing' stamp: 'pmm 5/27/2007 21:54'!
currentRequest
	"Returns the current http request, instance of WARequest"
	^ currentRequest! !

!WASession methodsFor: 'private' stamp: 'pmm 11/25/2007 10:55'!
currentRequest: aRequest
	"for testing only"
	currentRequest := aRequest! !

!WASession methodsFor: 'expiring' stamp: 'lr 4/15/2007 15:55'!
defaultTimeoutSeconds
	^ (self application isNil or: [ self application sessionExpirySeconds isNil ])
		ifFalse: [ self application sessionExpirySeconds ]
		ifTrue: [ super defaultTimeoutSeconds ]! !

!WASession methodsFor: 'accessing-preferences' stamp: 'lr 4/18/2007 09:25'!
errorHandler
	^ self application preferenceAt: #errorHandler! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/15/2007 15:55'!
fieldsAt: key
	^ self currentRequest at: key! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/15/2007 15:55'!
fieldsAt: key ifAbsent: aBlock
	^ self currentRequest at: key ifAbsent: aBlock! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/15/2007 15:55'!
fieldsAt: key ifPresent: aBlock
	^ self currentRequest at: key ifPresent: aBlock! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/17/2007 23:18'!
incomingRequest: aRequest
	((aRequest fields includesKey: 'terminate')
		and: [self application deploymentMode not])
			ifTrue: [
				monitor terminate.
				^ WAResponse new nextPutAll: 'Process terminated' ].
	^ monitor
		critical: [ self responseForRequest: aRequest ]
		ifError: [ :error | self errorHandler internalError: error ]! !

!WASession methodsFor: 'initializing' stamp: 'lr 7/10/2007 19:28'!
initialize
	super initialize.
	continuations := WALRUCache new.
	monitor := WAProcessMonitor new.
	cookiesEnabled := true! !

!WASession methodsFor: 'scripts' stamp: 'lr 4/15/2007 15:55'!
jumpToAnchor: aString
	jumpTo := aString! !

!WASession methodsFor: 'accessing-preferences' stamp: 'lr 4/18/2007 09:25'!
mainClass
	^ self application preferenceAt: #mainClass! !

!WASession methodsFor: 'http' stamp: 'lr 4/15/2007 15:55'!
mimeType
	^WAResponse defaultValueForMimeType. "text/html"! !

!WASession methodsFor: 'responding' stamp: 'lr 4/15/2007 15:55'!
newSessionUrl
	^ self baseUrl takeServerParametersFromRequest: currentRequest! !

!WASession methodsFor: 'scripts' stamp: 'lr 4/15/2007 15:55'!
onLoadScripts
	^ scripts ifNil: [#()]! !

!WASession methodsFor: 'responding' stamp: 'lr 5/18/2007 22:23'!
onRespond: aBlock
	| previous |
	previous := escapeContinuation.
	escapeContinuation := [ :response |
		aBlock value: response.
		previous value: response ]! !

!WASession methodsFor: 'accessing' stamp: 'mb 5/7/2007 17:11'!
outputDocumentClass
	"To be subclassed as needed"
	^ WAHtmlStreamDocument! !

!WASession methodsFor: 'expiring' stamp: 'lr 10/11/2007 11:03'!
pageExpired
	((lastContinuation isKindOf: WASessionContinuation) and: [ lastContinuation states notNil ])
		ifTrue:  [ lastContinuation states restore ].
	self respond: [ :url |
		self application redirectHandler
			redirectPageExpiredTo: url ].
	WAPageExpired raiseSignal! !

!WASession methodsFor: 'responding' stamp: 'lr 4/15/2007 15:55'!
pageIntentionallyLeftBlank
	self returnResponse: WAResponse new! !

!WASession methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
performRequest: aRequest
	| key continuation |
	key := aRequest fields
		at: self actionField
		ifAbsent: [ ^ self start: aRequest ].
	((aRequest fields includesKey: self checkCookiesField)
		and: [ aRequest cookies isEmpty ])
			ifTrue: [ cookiesEnabled := false ].
	(key isKindOf: OrderedCollection)
		ifTrue: [ key := key first ].
	continuation := continuations
		at: key
		ifAbsent: [ ^ self unknownRequest: aRequest ].
	^ continuation value: aRequest! !

!WASession methodsFor: 'redirecting' stamp: 'lr 5/10/2007 22:20'!
redirect
	^ self respond: [ :url | self redirectResponseFor: url ]! !

!WASession methodsFor: 'redirecting' stamp: 'lr 10/11/2007 09:44'!
redirectResponseFor: aUrl
	^ self application redirectHandler redirectTo: aUrl! !

!WASession methodsFor: 'redirecting' stamp: 'lr 5/10/2007 22:21'!
redirectTo: anUrl
	self returnResponse: (self redirectResponseFor: anUrl)! !

!WASession methodsFor: 'redirecting' stamp: 'lr 7/10/2007 19:38'!
redirectWithCookie: aCookie
	| response |
	self respond: [ :url |
		url addParameter: self checkCookiesField.
		response := self redirectResponseFor: url.
		response addCookie: aCookie.
		response ]! !

!WASession methodsFor: 'redirecting' stamp: 'pmm 11/20/2007 15:48'!
redirectWithMessage: aString delay: aNumber
	self respond: [ :url |
		WAResponse
			refreshWithMessage: aString
			location: url toString
			delay: aNumber ]! !

!WASession methodsFor: 'deprecated' stamp: 'lr 6/5/2007 21:37'!
registerObjectForBacktracking: anObject
	self deprecatedApi: '#registerObjectForBacktracking: is not supported, implement #states to backtrack your object'! !

!WASession methodsFor: 'responding' stamp: 'lr 10/22/2007 20:53'!
respond: aBlock
	^ ResponseContinuation currentDo: [ :cc | self respond: aBlock onAnswer: cc ]! !

!WASession methodsFor: 'responding' stamp: 'lr 5/10/2007 22:59'!
respond: aBlock onAnswer: aContinuation
	| url response |
	url := self actionUrlForContinuation: aContinuation.
	response := aBlock value: url.
	self returnResponse: response! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/15/2007 15:55'!
responseForRequest: aRequest
	currentRequest := aRequest.
	^ self withEscapeContinuation: [
		WACurrentSession
			use: self
			during: [
				self withErrorHandler: [
					self performRequest: aRequest ] ] ]! !

!WASession methodsFor: 'responding' stamp: 'pmm 5/27/2007 21:52'!
returnResponse: aResponse
	"aborts all further processing and directly returns aResponse
	aResponse instance of WAResponse"
	escapeContinuation value: aResponse! !

!WASession methodsFor: 'responding' stamp: 'lr 4/15/2007 15:55'!
script: aString
	self redirectWithMessage: '<script>', aString, '</script>' delay: 0! !

!WASession methodsFor: 'accessing' stamp: 'pmm 11/20/2007 15:48'!
sessionCookie
	^ WACookie key: self application handlerCookieName value: (self application ensureKeyForHandler: self) toString! !

!WASession methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
start: aRequest
	self useSessionCookie
		ifTrue: [ self redirectWithCookie: self sessionCookie ].
	^ self mainClass new start: aRequest! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/15/2007 15:55'!
unknownRequest: aRequest
	self start: aRequest! !

!WASession methodsFor: 'private' stamp: 'lr 4/15/2007 15:55'!
unregistered
	super unregistered.
	self expire! !

!WASession methodsFor: 'updating' stamp: 'pmm 11/21/2007 21:18'!
updateRoot: anHtmlRoot
	self application updateRoot: anHtmlRoot.
	anHtmlRoot meta contentType: self contentType.
	anHtmlRoot meta contentScriptType: 'text/javascript' toMimeType.
	anHtmlRoot htmlAttributes
		at: 'xmlns' put: 'http://www.w3.org/1999/xhtml';
		at: 'xml:lang' put: 'en';
		at: 'lang' put: 'en'.
	anHtmlRoot beXhtml10Strict.
	anHtmlRoot title: 'Seaside'! !

!WASession methodsFor: 'updating' stamp: 'lr 4/20/2007 20:14'!
updateStates: aSnapshot! !

!WASession methodsFor: 'updating' stamp: 'lr 4/15/2007 16:27'!
updateUrl: anUrl
	self application updateUrl: anUrl! !

!WASession methodsFor: 'accessing-preferences' stamp: 'lr 7/10/2007 19:33'!
useSessionCookie
	^ cookiesEnabled and: [ self application useSessionCookie ]! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/20/2007 14:53'!
withErrorHandler: aBlock
	^ [aBlock
		on: Error
		do: [:e | self errorHandler handleError: e. WAPageExpired raiseSignal]]
		on: Warning
		do: [:w | self errorHandler handleWarning: w. WAPageExpired raiseSignal]! !

!WASession methodsFor: 'request handling' stamp: 'avi 10/26/2004 15:40'!
withEscapeContinuation: aBlock
	^ EscapeContinuation currentDo:
			[:cc |
			escapeContinuation := cc.
			aBlock value.
			self pageIntentionallyLeftBlank]! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WANotFoundHandler commentStamp: 'pmm 10/20/2007 23:18' prior: 0!
WANotFoundHandler handles requests whose urls don't map to a Seaside application.

!

!WANotFoundHandler methodsFor: 'actions' stamp: 'avi 5/18/2004 16:16'!
handleRequest: aRequest
	^ WAResponse notFound: aRequest url! !

!WARequestHandler class methodsFor: 'instance-creation' stamp: 'pmm 4/19/2006 18:00'!
new
	^ self basicNew initialize! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:33'!
description
	"Answer a descriptive text of the receiver."

	^ String new! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
handleRequest: aRequest
	"Handle aRequest and answer a response."

	self subclassResponsibility! !

!WARequestHandler methodsFor: 'initialization' stamp: 'pmm 11/2/2005 23:17'!
initialize! !

!WARequestHandler methodsFor: 'testing' stamp: 'avi 7/23/2004 15:11'!
isActive
	^ true! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isApplication
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isDispatcher
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:48'!
isEntryPoint
	^ false! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
parent
	"Answer the parent request handler of the receiver."

	^ parent! !

!WARequestHandler methodsFor: 'copying' stamp: 'lr 2/16/2007 15:06'!
postCopy
	super postCopy.
	parent := nil! !

!WARequestHandler methodsFor: 'initialization' stamp: 'lr 2/12/2007 20:50'!
setParent: aRequestHandler
	parent := aRequestHandler! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 2/12/2007 21:12'!
unregistered! !

Object subclass: #WAResponse
	instanceVariableNames: 'contentType headers cookies status stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAResponse commentStamp: 'pmm 5/27/2007 21:52' prior: 0!
I am a server independent http response object. I am used in conjunction with WASession >> returnResponse:!

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
basicAuthWithRealm: aString
	^ self new basicAuthenticationRealm: aString! !

!WAResponse class methodsFor: 'defaults' stamp: 'mb 3/12/2007 13:49'!
defaultHttpVersion
	^'HTTP/1.0'! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 3/1/2007 06:34'!
defaultValueForCharSet
	^'utf-8'! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 11/21/2007 15:24'!
defaultValueForContentType
	^(WAMimeType fromString: self defaultValueForMimeType)
		charset: self defaultValueForCharSet;
		yourself! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 3/1/2007 06:34'!
defaultValueForMimeType
	^'text/html'! !

!WAResponse class methodsFor: 'instance creation' stamp: 'pmm 11/21/2007 20:32'!
document: anObject mimeType: mimeType
	| document |
	document := anObject asMIMEDocumentType: mimeType.
	^ self new
		contentType: (mimeType ifNil: [ document contentType toMimeType ]);
		cacheForever;
		nextPutAll: document content;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 9/22/2004 21:02'!
document: anObject mimeType: mimeString fileName: fileString
	^ (self document: anObject mimeType: mimeString)
		attachmentWithFileName: fileString;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/9/2005 13:14'!
forbidden: locationString
	^ self new
		forbidden;
		nextPutAll: '<h1> Error: you are forbidden to access "', locationString, '". </h1>';
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'pmm 11/1/2007 21:30'!
internalError: anError
	| response content |
	response := self new internalError.
	content := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root |
			root title: 'Internal Error' ];
		render: [ :html |
			html heading level1; with: 'Internal Error'.
			html heading level2; with: anError description.
			(SeasidePlatformSupport walkbackStringsFor: anError)
				do: [ :each | html text: each ]
				separatedBy: [ html break ] ].
	response nextPutAll: content.
	^ response! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
new
	^ self basicNew initialize! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:15'!
notFound: locationString
	^ self new
		notFound;
		nextPutAll: '<h1> Error: "', locationString, '" not found. </h1>';
		yourself! !

!WAResponse class methodsFor: 'responding' stamp: 'avi 5/18/2004 16:15'!
redirectTo: locationString
	^ self new redirectTo: locationString! !

!WAResponse class methodsFor: 'instance creation' stamp: 'lr 10/28/2007 14:42'!
refreshWithMessage: aString location: locationString delay: aNumber
	| document |
	document := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root |
			root redirectTo: locationString delay: aNumber ];
		render: [ :html |
			html heading level1
				with: aString.
			html text: 'You are being redirected to '.
			html anchor
				url: locationString;
				with: locationString ].

	^ self new nextPutAll: document! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 9/10/2005 17:31'!
root: anHtmlRoot render: renderBlock
	| canvas |
	canvas := WAStaticHtmlCanvas root: anHtmlRoot.
	renderBlock value: canvas.
	^ self new nextPutAll: canvas document stream contents! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
addCookie: aCookie
	cookies ifNil: [ cookies := Set new ].
	cookies add: aCookie! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 4/19/2006 09:30'!
attachmentWithFileName: aString
	self headerAt: 'Content-Disposition' put: 'attachment; filename="', aString, '"'! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
authenticationFailed
	self status: 401! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 5/18/2004 14:25'!
basicAuthenticationRealm: aString
	self headerAt: 'WWW-Authenticate' put: ('Basic realm="',aString,'"').
	self authenticationFailed! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 11/21/2007 15:22'!
beXML
	contentType sub = 'html' ifTrue: [
		contentType sub: 'xml' ]! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 1/3/2008 21:03'!
cacheForever
	self removeHeaderAt: 'Cache-Control'.
	self removeHeaderAt: 'Pragma'.
	self headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAResponse methodsFor: 'accessing' stamp: 'pmm 11/21/2007 20:21'!
contentType: mimeTypeOrString
	contentType := mimeTypeOrString toMimeType! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents
	^ stream reset! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents: aStream
	stream := aStream! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
cookieAt: key put: value
	^ self addCookie: (WACookie key: key value: value)! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
cookies
	^ cookies ifNil: [ #() ]! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 10/28/2007 14:42'!
deleteCookieAt: key
	"Delete the cookie in the browser"
	self addCookie: ((WACookie key: key value: '')
						expireIn: (Duration days: -10000);
						yourself)! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 1/3/2008 21:02'!
doNotCache
	self headerAt: 'Expires' put: 'Thu, 11 Jun 1980 12:00:00 GMT'.
	self headerAt: 'Cache-Control' put: 'no-cache, must-revalidate'.
	self headerAt: 'Pragma' put: 'no-cache'! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/9/2005 13:14'!
forbidden
	self status: 403! !

!WAResponse methodsFor: 'status' stamp: 'pmm 12/31/2007 11:49'!
gone
	self status: 410! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:14'!
headerAt: aString
	^self headers
		detect: [ :each | each key = aString ]
		ifNone: [ nil ]! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:15'!
headerAt: aKeyString put: aValueObject
	self headers add: aKeyString -> aValueObject! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:24'!
headers
	headers isNil ifTrue: [
		headers := OrderedCollection new ].
	^headers! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 5/1/2007 09:42'!
httpVersion
	^self class defaultHttpVersion! !

!WAResponse methodsFor: 'initialize-release' stamp: 'pmm 11/20/2007 10:51'!
initialize
	| session |
	stream := SeasidePlatformSupport readWriteStream.
	status := 200.
	session := WACurrentSession value.
	contentType := session isNil
		ifFalse: [ session contentType ]
		ifTrue: [ self class defaultValueForContentType ]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 15:57'!
internalError
	self status: 500! !

!WAResponse methodsFor: 'streaming' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAResponse methodsFor: 'streaming' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
notFound
	self status: 404! !

!WAResponse methodsFor: 'printing' stamp: 'pmm 11/20/2007 15:47'!
printOn: aStream
	super printOn: aStream.
	aStream space; nextPutAll: self status toString! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:26'!
redirect
	self status: 302! !

!WAResponse methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
redirectTo: aString
	self headerAt: 'Location' put: aString.
	self redirect! !

!WAResponse methodsFor: 'initialize-release' stamp: 'tbn 7/20/2006 17:31'!
release
	stream := cookies := headers := nil.
	super release! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:21'!
removeHeaderAt: aString
	headers isNil ifTrue: [
		^self ].	

	headers := self headers reject: [ :each |
		each key = aString ]! !

!WAResponse methodsFor: 'streaming' stamp: 'lr 5/23/2007 11:13'!
space
	stream space! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAResponse methodsFor: 'accessing' stamp: 'lr 5/23/2007 12:04'!
status: aNumber
	status := aNumber! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 2/6/2004 15:28'!
stream
	^ stream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
stream: aStream
	stream := aStream! !

!WAResponse methodsFor: 'writing' stamp: 'pmm 11/21/2007 20:29'!
writeHeadersOn: aStream
	self headers associationsDo: [ :assoc |
		aStream nextPutAll: assoc key; nextPutAll: ': '; nextPutAll: assoc value toString.
		aStream crlf ].
	cookies ifNotNil: [
		cookies do: [ :each |
			aStream nextPutAll: 'Set-Cookie: '.
			each writeOn: aStream.
			aStream crlf ] ].
	aStream nextPutAll: 'Content-Type: ', self contentType toString.
	aStream crlf! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:52'!
writeOn: aStream
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	aStream crlf.
	aStream nextPutAll: stream contents! !

!WAResponse methodsFor: 'writing' stamp: 'pmm 11/20/2007 15:47'!
writeStatusOn: aStream
	aStream nextPutAll: self httpVersion; space; nextPutAll: self status toString; crlf! !

WAResponse subclass: #WAStreamResponse
	instanceVariableNames: 'writtenHeaders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAStreamResponse class methodsFor: 'instance-creation' stamp: 'lr 5/23/2007 10:35'!
on: aStream
	^ self new stream: aStream! !

!WAStreamResponse methodsFor: 'accessing' stamp: 'pmm 4/19/2006 17:32'!
hasWrittenHeaders
	^ writtenHeaders! !

!WAStreamResponse methodsFor: 'initialization' stamp: 'mb 9/22/2006 12:26'!
initialize
	super initialize.
	writtenHeaders := false! !

!WAStreamResponse methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:31'!
stream
	self writeOn: stream.
	^ stream! !

!WAStreamResponse methodsFor: 'private' stamp: 'pmm 9/30/2006 18:18'!
writeOn: aStream
	self hasWrittenHeaders ifFalse: [
		self writeStatusOn: aStream.
		self writeHeadersOn: aStream.
		aStream crlf.
		writtenHeaders := true ]! !

Object subclass: #WARoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

WARoot subclass: #WAHtmlRoot
	instanceVariableNames: 'context docType htmlAttrs headAttrs bodyAttrs headElements title styles scripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlRoot class methodsFor: 'instance-creation' stamp: 'lr 3/27/2007 12:08'!
context: aRenderingContext
	^ self new setContext: aRenderingContext! !

!WAHtmlRoot methodsFor: 'private' stamp: 'lr 4/20/2007 16:24'!
absoluteUrlForResource: aString
	^ context absoluteUrlForResource: aString! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 10/28/2007 14:42'!
add: aHtmlElement
	"Add a HTML head element to the receiver."

	^ headElements add: aHtmlElement! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 10/28/2007 14:42'!
addScript: aString
	"Include the script aString into the receiver."

	scripts ifNil: [ scripts := OrderedCollection new ].
	(scripts includes: aString) ifFalse: [ scripts add: aString ]! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 4/9/2007 10:33'!
addStyle: aString
	"Include the style-sheet aString into the receiver."

	styles ifNil: [ styles := OrderedCollection new ].
	(styles includes: aString) ifFalse: [ styles add: aString ]! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:30'!
base
	^ self add: (WABaseElement root: self)! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:44'!
beXhtml10Strict
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:45'!
beXhtml10Transitional
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:45'!
beXhtml11
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
bodyAttributes
	^ bodyAttrs ifNil: [ bodyAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:18'!
close: aDocument
	self writeFootOn: aDocument! !

!WAHtmlRoot methodsFor: 'convenience' stamp: 'lr 3/27/2007 13:14'!
contentBase: urlString
	self base url: urlString! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:29'!
context
	^ context! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 3/27/2007 12:11'!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 10/28/2007 14:42'!
docType: aString
	"Set the document-type of the receiver. The table at http://www.w3.org/TR/2002/NOTE-xhtml-media-types-20020430/ summarizes the recommendation to content authors for labeling their XHTML documents:

Media type				XHTML 1.0 (HTML compatible)	XHTML 1.0 (other)	XHTML Basic / 1.1	XHTML+MathML
text/html				MAY							SHOULD NOT			SHOULD NOT			SHOULD NOT
application/xhtml+xml	SHOULD							SHOULD				SHOULD				SHOULD
application/xml			MAY							MAY				MAY				MAY
text/xml					MAY							MAY				MAY				MAY"

	docType := aString! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
headAttributes
	^ headAttrs ifNil: [ headAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
htmlAttributes
	^ htmlAttrs ifNil: [ htmlAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
if
	^ WAConditionalComment root: self! !

!WAHtmlRoot methodsFor: 'initialization' stamp: 'lr 3/27/2007 12:09'!
initialize
	headElements := OrderedCollection new.
	title := docType := String new! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'pmm 4/6/2007 14:18'!
javascript
	^ self script beJavascript; yourself! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
link
	^ self add: (WALinkElement root: self)! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:30'!
meta
	^ self add: (WAMetaElement root: self)! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:17'!
open: aDocument
	self writeHeadOn: aDocument! !

!WAHtmlRoot methodsFor: 'convenience' stamp: 'lr 4/9/2007 10:43'!
redirectTo: aLocationString delay: aNumber
	self meta redirectAfter: aNumber to: aLocationString! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'pmm 11/25/2007 21:57'!
revealedIf
	^ WARevealedConditionalComment root: self! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
script
	^ self add: (WAScriptElement root: self)! !

!WAHtmlRoot methodsFor: 'initialization' stamp: 'lr 3/27/2007 12:08'!
setContext: aRenderingContext
	context := aRenderingContext! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:31'!
stylesheet
    ^ self link beStylesheet; beCss; yourself! !

!WAHtmlRoot methodsFor: 'accessing-properties' stamp: 'lr 3/27/2007 12:11'!
title
	^ title! !

!WAHtmlRoot methodsFor: 'accessing-properties' stamp: 'lr 3/27/2007 12:11'!
title: aString
	title := aString! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 4/9/2007 10:40'!
writeElementsOn: aDocument
	aDocument openTag: 'title'; nextPutAll: title; closeTag: 'title'.
	headElements do: [ :each | aDocument print: each ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:20'!
writeFootOn: aDocument
	aDocument closeTag: 'body'.
	aDocument closeTag: 'html'! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 5/16/2007 21:53'!
writeHeadOn: aDocument
	aDocument nextPutAll: docType.
	aDocument openTag: 'html' attributes: htmlAttrs.
	aDocument openTag: 'head' attributes: headAttrs.
	self writeElementsOn: aDocument.
	self writeStylesOn: aDocument.
	self writeScriptsOn: aDocument.
	aDocument closeTag: 'head'.
	aDocument openTag: 'body' attributes: bodyAttrs! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'pmm 4/6/2007 14:18'!
writeScriptsOn: aDocument
	scripts ifNil: [ ^ self ].
	scripts do: [ :each |
		aDocument print: ((WAScriptElement root: self)
			beJavascript;
			document: each;
			yourself) ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'pmm 4/6/2007 14:18'!
writeStylesOn: aDocument
	styles ifNil: [ ^ self ].
	styles do: [ :each |
		aDocument print: ((WALinkElement root: self)
			beStylesheet; beCss;
			document: each;
			yourself) ]! !

!WARoot class methodsFor: 'instance creation' stamp: 'avi 6/19/2004 18:05'!
new
	^ self basicNew initialize! !

!WARoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:30'!
close: aDocument! !

!WARoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:30'!
open: aDocument! !

Object subclass: #WASessionContinuation
	instanceVariableNames: 'root states'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

WASessionContinuation subclass: #WARedirectContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARedirectContinuation methodsFor: 'processing' stamp: 'lr 8/17/2007 09:54'!
handleRequest: aRequest
	self newRenderContinuation run! !

!WARedirectContinuation methodsFor: 'processing' stamp: 'pmm 11/20/2007 15:47'!
run
	self respond: [ :response | response redirectTo: self url toString ]! !

WASessionContinuation subclass: #WARenderContinuation
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARenderContinuation methodsFor: 'private' stamp: 'pmm 11/20/2007 15:47'!
componentsNotFound: aCollection
	WAComponentsNotFoundError raiseSignal: 'Components not found while processing callbacks: ' , aCollection toString! !

!WARenderContinuation methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
context
	"Answer the current context of this request."

	^ context! !

!WARenderContinuation methodsFor: 'processing' stamp: 'lr 8/17/2007 09:55'!
handleRequest: aRequest
	aRequest isXmlHttpRequest ifTrue: [
		self session onRespond: [ :r | states snapshot ] ].
	self withNotificationHandler: [ self processCallbacks: aRequest ].
	((self shouldRedirect: aRequest)
		ifTrue: [ self newRedirectContinuation ]
		ifFalse: [ self newRenderContinuation ])
			run! !

!WARenderContinuation methodsFor: 'creational' stamp: 'lr 4/20/2007 19:36'!
newContext
	^ WARenderingContext new
		session: self session;
		actionUrl: self url;
		yourself! !

!WARenderContinuation methodsFor: 'creational' stamp: 'lr 10/28/2007 14:42'!
newDocumentOn: aResponse
	^ WAHtmlStreamDocument new stream: aResponse stream! !

!WARenderContinuation methodsFor: 'creational' stamp: 'lr 4/17/2007 23:01'!
newHtmlRoot
	| htmlRoot |
	htmlRoot := WAHtmlRoot context: self context.
	htmlRoot bodyAttributes at: 'onload' append: 'onLoad()' separator: ';'.
	self updateRoot: htmlRoot.
	^ htmlRoot! !

!WARenderContinuation methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
processCallbacks: aRequest
	| lastPosition callbackStream |
	lastPosition := nil.
	callbackStream := context callbackStreamForRequest: aRequest.
	[ callbackStream position = lastPosition ] whileFalse: [
		lastPosition := callbackStream position.
		self root decorationChainDo: [ :each |
			each processCallbackStream: callbackStream ] ].
	callbackStream atEnd
		ifFalse: [ self unprocessedCallbacks: callbackStream upToEnd ]! !

!WARenderContinuation methodsFor: 'private' stamp: 'lr 4/20/2007 22:27'!
processRendering: aResponse
	| document htmlRoot |
	document := self newDocumentOn: aResponse.
	context document: document.
	htmlRoot := self newHtmlRoot.
	document open: htmlRoot.
	self root decorationChainDo: [ :each | each renderWithContext: context ].
	self writeOnLoadOn: document.
	document close: htmlRoot.
	context release! !

!WARenderContinuation methodsFor: 'actions' stamp: 'lr 4/20/2007 19:37'!
render
	self session clearJumpTo.
	context := self newContext.
	self respond: [ :response | self processRendering: response ]! !

!WARenderContinuation methodsFor: 'processing' stamp: 'lr 4/20/2007 19:41'!
run
	self withNotificationHandler: [ self render ]! !

!WARenderContinuation methodsFor: 'testing' stamp: 'lr 4/16/2007 21:06'!
shouldRedirect: aRequest
	^ aRequest isGet not or: [ (aRequest fields includesKey: '_n') not ]! !

!WARenderContinuation methodsFor: 'private' stamp: 'pmm 5/29/2007 16:34'!
unprocessedCallbacks: aCollection
	| owners |
	owners := (aCollection collect: [ :each | each owner ]) asSet asArray.
	self componentsNotFound: owners! !

!WARenderContinuation methodsFor: 'private' stamp: 'lr 4/18/2007 00:04'!
withNotificationHandler: aBlock
	^ aBlock on: WARenderNotification , WAPageExpired do: [ :n | ]! !

!WARenderContinuation methodsFor: 'private' stamp: 'pmm 11/20/2007 15:47'!
writeOnLoadOn: aDocument
	| attributes |
	attributes := WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	aDocument openTag: 'script' attributes: attributes closed: false.
	aDocument nextPutAll: '/*<!![CDATA[*/function onLoad(){'.
	self session onLoadScripts
		do: [ :each | aDocument nextPutAll: each toString ]
		separatedBy: [ aDocument nextPutAll: ';' ].
	aDocument nextPutAll: '}/*]]>*/'.
	aDocument closeTag: 'script'.
	self session clearLoadScripts! !

!WASessionContinuation class methodsFor: 'instance-creation' stamp: 'lr 4/20/2007 20:17'!
root: aComponent
	^ self new initializeWithRoot: aComponent! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
application
	"Answer the application to which this handler is associated."

	^ self session application! !

!WASessionContinuation methodsFor: 'processing' stamp: 'lr 4/20/2007 19:34'!
handleRequest: aRequest
	self subclassResponsibility! !

!WASessionContinuation methodsFor: 'initialization' stamp: 'lr 4/20/2007 20:17'!
initializeWithRoot: aComponent
	root := aComponent! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 10/28/2007 14:42'!
newRedirectContinuation
	"Answer a new redirect handler."

	^ (self application preferenceAt: #redirectContinuationClass) root: self root! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 10/28/2007 14:42'!
newRenderContinuation
	"Answer a new render continuation."

	^ (self application preferenceAt: #renderContinuationClass) root: self root! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 10/28/2007 14:42'!
newResponse
	"Answer a new response object and assign the current request stream."

	| stream response |
	stream := self request responseStream.
	response := stream isNil
		ifTrue: [ WAResponse new ]
		ifFalse: [ WAStreamResponse on: stream ].
	^ response doNotCache! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 5/10/2007 22:26'!
newStates
	^ WASnapshot new! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
request
	"Answer the current request object."

	^ self session currentRequest! !

!WASessionContinuation methodsFor: 'processing' stamp: 'lr 5/10/2007 22:39'!
respond: aBlock
	| response |
	states := self newStates.
	response := self newResponse.
	aBlock value: response.
	self updateStates: states.
	self session returnResponse: response! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
root
	"Answer the root component instance. Usually this component is instantiated with the first reuqest."

	^ root! !

!WASessionContinuation methodsFor: 'processing' stamp: 'lr 4/20/2007 19:46'!
run
	self subclassResponsibility! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
session
	"Answer the session to which this handler is associated."

	^ WACurrentSession value! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 8/20/2007 22:59'!
states
	^ states! !

!WASessionContinuation methodsFor: 'updating' stamp: 'lr 4/17/2007 22:50'!
updateRoot: aHtmlRoot
	self session updateRoot: aHtmlRoot.
	self root visiblePresentersDo: [ :each | each updateRoot: aHtmlRoot ]! !

!WASessionContinuation methodsFor: 'updating' stamp: 'lr 10/28/2007 14:42'!
updateStates: aSnapshot
	self session updateStates: aSnapshot.
	self root visiblePresentersDo: [ :each |
		(each isDecoration and: [ each isDelegation ])
			ifTrue: [ each component updateStates: aSnapshot ].
		each updateStates: aSnapshot ]! !

!WASessionContinuation methodsFor: 'updating' stamp: 'lr 4/17/2007 22:50'!
updateUrl: anUrl
	self session updateUrl: anUrl.
	self root visiblePresentersDo: [ :each | each updateUrl: anUrl ]! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 4/17/2007 22:20'!
url
	| url |
	url := self session actionUrlForContinuation: self.
	self updateUrl: url.
	^ url! !

!WASessionContinuation methodsFor: 'evaluating' stamp: 'lr 5/10/2007 10:49'!
value: aRequest
	"Resume processing of aRequest. To ensure valid application state restore all registered states."

	states ifNotNil: [ states restore ].
	self handleRequest: aRequest! !

Object subclass: #WASmallDictionary
	instanceVariableNames: 'size keys values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WASmallDictionary commentStamp: 'lr 7/12/2007 13:15' prior: 0!
I am an implementation of a dictionary. Compared to other dictionaries I am very efficient for small sizes, speed- and space-wise. I also remember the order in which elements are added, some of my users might depend on that. My implementation features some ideas from the RefactoringBrowser.!

WASmallDictionary subclass: #WAHtmlAttributes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlAttributes commentStamp: 'lr 7/12/2007 13:30' prior: 0!
I represent the attributes of a XHTML tag. Compared to my superclass I ignore requests to add a nil-values. I also don't throw an exception when accessing a key that doesn't exist, but instead return nil.!

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addClass: aString
	"Add an additional CSS class aString to the receiver."

	self at: 'class' append: aString separator: ' '! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addStyle: aString
	"Add an additional CSS style definition aString to the receiver."

	self at: 'style' append: aString separator: ';'! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'lr 7/9/2007 07:46'!
at: aKey append: aValue
	"Append aValue to the attribute aKey. If already present, concatenate it with a space. Ignore the request if aValue is nil."

	^ self at: aKey append: aValue separator: ' '! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'pmm 11/20/2007 15:45'!
at: aKey append: aValue separator: aString
	"Append aValue to the attribute aKey. If already present, concatenate it with aString. Ignore the request if aValue is nil."

	aValue ifNil: [ ^ self at: aKey ].
	^ self at: aKey put: (String streamContents: [ :stream |
		self at: aKey ifPresent: [ :value |
			stream nextPutAll: value toString.
			stream nextPutAll: aString ].
		stream nextPutAll: aValue toString ])! !

!WAHtmlAttributes methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeOn: aDocument
	"Encode the receivers attribute onto aDocument. Note that this implementation reqires those two checks for true and false exactly the way they are here, to reliable encode boolean attributes in an XHTML compliant way."

	self keysAndValuesDo: [ :key :value |
		value == false ifFalse: [
			aDocument nextPut: $ ; nextPutAll: key; nextPutAll: '="'.
			value == true
				ifTrue: [ aDocument nextPutAll: key ]
				ifFalse: [ aDocument print: value ].
			aDocument nextPut: $" ] ]! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'lr 7/12/2007 13:21'!
errorKeyNotFound
	^ nil! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'lr 7/12/2007 13:23'!
privateAt: aKey put: aValue
	aValue ifNil: [ ^ nil ].
	^ super privateAt: aKey put: aValue! !

!WASmallDictionary class methodsFor: 'instance-creation' stamp: 'lr 6/6/2007 19:09'!
new
	^ self basicNew initialize! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
associations
	"Answer a Collection containing the receiver's associations."

	| result |
	result := WriteStream on: (Array new: self size).
	self associationsDo: [ :assoc | result nextPut: assoc ].
	^ result contents! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 8/20/2007 13:45'!
associationsDo: aBlock
	self keysAndValuesDo: [ :key :value | aBlock value: key -> value ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey
	"Answer the value associated with aKey. Raise an exception, if no such key is defined."

	^ self at: aKey ifAbsent: [ self errorKeyNotFound ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey ifAbsent: aBlock
	"Answer the value associated with aKey. Evaluate aBlock, if no such key is defined."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index ]
		ifTrue: [ aBlock value ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey ifAbsentPut: aBlock
	"Answer the value associated with aKey. Evaluate aBlock, if no such key is defined and store the return value."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index ]
		ifTrue: [ self privateAt: aKey put: aBlock value ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey ifPresent: aBlock
	"Lookup aKey in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0 ifFalse: [ aBlock value: (values at: index) ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey put: aValue
	"Set the value of aKey to be aValue."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index put: aValue ]
		ifTrue: [ self privateAt: aKey put: aValue ]! !

!WASmallDictionary methodsFor: 'private' stamp: 'lr 7/12/2007 13:18'!
errorKeyNotFound
	self error: 'Key not found'! !

!WASmallDictionary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
findIndexFor: aKey
	1 to: size do: [ :index |
		(keys at: index) = aKey
			ifTrue: [ ^ index ] ].
	^ 0! !

!WASmallDictionary methodsFor: 'private' stamp: 'lr 6/6/2007 19:12'!
grow
	| newKeys newValues |
	newKeys := Array new: 2 * size.
	newValues := Array new: 2 * size.
	1 to: size do: [ :index |
		newKeys at: index put: (keys at: index).
		newValues at: index put: (values at: index) ].
	keys := newKeys.
	values := newValues! !

!WASmallDictionary methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
includesKey: aKey
	"Answer whether the receiver has a key equal to aKey."

	^ (self findIndexFor: aKey) ~= 0! !

!WASmallDictionary methodsFor: 'initialization' stamp: 'lr 6/6/2007 19:10'!
initialize
	size := 0.
	keys := Array new: 3.
	values := Array new: 3! !

!WASmallDictionary methodsFor: 'testing' stamp: 'lr 7/9/2007 08:13'!
isEmpty
	^ size = 0! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 7/9/2007 10:37'!
keys
	^ keys copyFrom: 1 to: size! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 6/7/2007 08:04'!
keysAndValuesDo: aBlock
	1 to: size do: [ :index | aBlock value: (keys at: index) value: (values at: index) ]! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 8/17/2007 11:52'!
keysDo: aBlock
	1 to: size do: [ :each | aBlock value: (keys at: each) ]! !

!WASmallDictionary methodsFor: 'copying' stamp: 'lr 7/9/2007 07:50'!
postCopy
	super postCopy.
	keys := keys copy.
	values := values copy! !

!WASmallDictionary methodsFor: 'private' stamp: 'lr 6/6/2007 19:28'!
privateAt: aKey put: aValue
	size = keys size ifTrue: [ self grow ].
	keys at: (size := size + 1) put: aKey.
	^ values at: size put: aValue! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 7/12/2007 13:18'!
removeKey: aKey
	"Remove aKey from the receiver, raise an exception if the element is missing."

	^ self removeKey: aKey ifAbsent: [ self errorKeyNotFound ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
removeKey: aKey ifAbsent: aBlock
	"Remove aKey from the receiver, evaluate aBlock if the element is missing."

	| index value |
	index := self findIndexFor: aKey.
	index = 0 ifTrue: [ ^ aBlock value ].
	value := values at: index.
	index to: size - 1 do: [ :i |
		keys at: i put: (keys at: i + 1).
		values at: i put: (values at: i + 1) ].
	keys at: size put: nil.
	values at: size put: nil.
	size := size - 1.
	^ value! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 7/9/2007 10:38'!
size
	^ size! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 7/9/2007 10:38'!
values
	^ values copyFrom: 1 to: size! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 8/17/2007 11:52'!
valuesDo: aBlock
	1 to: size do: [ :index | aBlock value: (values at: index) ]! !

Object subclass: #WAUrl
	instanceVariableNames: 'scheme username password hostname port path parameters fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAUrl commentStamp: 'lr 7/9/2007 21:43' prior: 0!
I represent all portions of an URL as described by the RFC 1738. I include scheme, username, password, hostname, port, path, parameters, and fragment.

Portions of this code are based on code of Kazuki Yasumatsu and Paolo Bonzini.

Instance Variables
	scheme:			<String> or nil
	username:		<String> or nil
	password:		<String> or nil
	hostname:		<String> or nil
	port:			<Integer> or nil
	path:			<OrderedCollection> or nil
	parameters:		<Dictionary>
	fragment:		<String> or nil!

!WAUrl class methodsFor: 'instance creation' stamp: 'avi 3/18/2004 16:07'!
new
	^ self basicNew initialize! !

!WAUrl methodsFor: 'adding' stamp: 'lr 10/28/2007 14:42'!
addParameter: aString
	self addParameter: aString value: nil! !

!WAUrl methodsFor: 'adding' stamp: 'lr 8/17/2007 20:54'!
addParameter: keyString value: valueString
	self parameters at: keyString put: valueString! !

!WAUrl methodsFor: 'adding' stamp: 'lr 8/17/2007 20:54'!
addToPath: aString
	self path addAll: (aString findTokens: '/')! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 8/20/2007 21:13'!
encodeFragmentOn: aDocument
	fragment ifNil: [ ^ self ].
	aDocument nextPut: $#.
	aDocument urlEncoder nextPutAll: fragment! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 9/4/2007 15:32'!
encodeOn: aDocument
	self encodeOn: aDocument usingHtmlEntities: true! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeOn: aDocument usingHtmlEntities: aBoolean
	self encodeServerOn: aDocument.
	self encodePathOn: aDocument.
	self
		encodeParametersOn: aDocument
		usingHtmlEntities: aBoolean.
	self encodeFragmentOn: aDocument! !

!WAUrl methodsFor: 'encoding' stamp: 'pmm 11/21/2007 14:24'!
encodeParametersOn: aDocument usingHtmlEntities: aBoolean
	| first |
	first := true.
	parameters ifNil: [ ^ self ].
	parameters keysAndValuesDo: [ :key :value |
		aDocument nextPutAll: (first
			ifTrue: [ first := false. '?' ]
			ifFalse: [
				aBoolean
					ifTrue: [ '&amp;' ]
					ifFalse: [ '&' ] ]).
		aDocument urlEncoder nextPutAll: key.
		value ifNotNil: [
			aDocument nextPut: $=.
			aDocument urlEncoder nextPutAll: value toString ] ]! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodePathOn: aDocument
	path ifNil: [ ^ self ].
	aDocument nextPut: $/.
	path
		do: [ :each | aDocument urlEncoder nextPutAll: each ]
		separatedBy: [ aDocument nextPut: $/ ]! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeServerOn: aDocument
	hostname ifNil: [ ^ self ].
	aDocument nextPutAll: scheme; nextPutAll: '://'.
	username notNil ifTrue: [
		aDocument urlEncoder nextPutAll: username.
		password notNil ifTrue: [
			aDocument nextPut: $:.
			aDocument urlEncoder nextPutAll: password ].
		aDocument nextPut: $@ ].
	aDocument urlEncoder nextPutAll: hostname.
	port notNil ifTrue: [
		((scheme = 'http' and: [ port = 80 ])
			or: [ scheme = 'https' and: [ port = 443 ] ])
			ifFalse: [ aDocument nextPut: $:; print: port ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
fragment
	"Answer the fragment part of the URL."

	^ fragment! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:18'!
fragment: aString
	fragment := aString! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
hostname
	"Answer the host part of the URL."

	^ hostname! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 21:07'!
hostname: aString
	hostname := aString! !

!WAUrl methodsFor: 'initialization' stamp: 'lr 8/17/2007 21:53'!
initialize
	scheme := 'http'! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/17/2007 22:49'!
isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_
		or: [ aString allSatisfy: [ :each | each isDigit ] ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:20'!
parameters
	^ parameters ifNil: [ parameters := WASmallDictionary new ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:19'!
parameters: aDictionary
	parameters := aDictionary! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
password
	"Answer the password part of the URL."

	^ password! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:21'!
password: aString
	password := aString! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
path
	"Answer the path part of the URL."

	^ path ifNil: [ path := OrderedCollection new ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
path: aCollection
	"Set the path part of the URL to aCollection."

	path := aCollection! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:22'!
port
	"Answer the port number part of the URL."

	^ port! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:22'!
port: aNumber
	port := aNumber! !

!WAUrl methodsFor: 'copying' stamp: 'lr 10/28/2007 14:42'!
postCopy
	super postCopy.
	scheme := scheme copy.
	username := username copy.
	password := password copy.
	hostname := hostname copy.
	port := port copy.
	path := path copy.
	parameters := parameters copy.
	fragment := fragment copy! !

!WAUrl methodsFor: 'printing' stamp: 'lr 9/4/2007 15:37'!
printOn: aStream
	| document |
	document := WAHtmlStreamDocument new.
	document stream: aStream.
	self encodeOn: document usingHtmlEntities: false! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/17/2007 20:54'!
removeParameters
	parameters := nil! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
scheme
	"Answer the URL's scheme."

	^ scheme! !

!WAUrl methodsFor: 'accessing' stamp: 'pmm 11/21/2007 14:23'!
scheme: aString
	"we really expect a String here, Old versions (2.7) expected a Symbol you can still pass a Symbol and get away with it but don't expect this behavior to be supported in future versions."
	scheme := aString toString! !

!WAUrl methodsFor: 'private' stamp: 'pmm 12/9/2007 12:28'!
takeServerParametersFromRequest: aRequest
	| httpHost |
	hostname ifNil: [
		httpHost := aRequest
			headerAt: 'host'
			ifAbsent: [ ^ self ].
		hostname := httpHost copyUpTo: $:.
		(httpHost includes: $:)
			ifTrue: [ port := (httpHost copyAfter: $:) asInteger ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
username
	"Answer the username part of the URL."

	^ username! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:38'!
username: aString
	username := aString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:52'!
with: pathString
	^ self copy
		addToPath: pathString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'pmm 6/21/2007 20:45'!
withParameter: aString
	^ self copy
		addParameter: aString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString value: valueString
	^ self copy
		addParameter: aString value: valueString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'pmm 6/21/2007 20:57'!
withoutParameters
	^self copy
		removeParameters;
		yourself! !

Object subclass: #WAValueHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAValueHolder commentStamp: 'pmm 9/5/2007 19:01' prior: 0!
I wrap a single object. I am like value holder except that I am portable and don't include the Model cruft in Squeak.!

WAValueHolder subclass: #WAStateHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAStateHolder commentStamp: 'pmm 9/5/2007 19:03' prior: 0!
I am only where for migration purposes. Don't use WAStateHolder anymore. Backtracking is now done using #states. If you need an object that wraps a single value use WAValueHolder.!

!WAStateHolder class methodsFor: 'instance-creation' stamp: 'lr 9/5/2007 11:41'!
new
	self deprecatedApi.
	^ super new! !

!WAValueHolder class methodsFor: 'instance-creation' stamp: 'lr 9/5/2007 11:40'!
with: anObject
	^ self new contents: anObject! !

!WAValueHolder methodsFor: 'accessing' stamp: 'lr 4/16/2007 00:11'!
contents
	^ contents! !

!WAValueHolder methodsFor: 'accessing' stamp: 'lr 4/16/2007 00:11'!
contents: anObject
	contents := anObject! !

!WAValueHolder methodsFor: 'printing' stamp: 'lr 4/20/2007 20:46'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' contents: '; print: self contents! !

!UndefinedObject methodsFor: '*Seaside-Core' stamp: 'lr 3/27/2007 10:40'!
encodeOn: aDocument! !

!UndefinedObject methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
renderOn: html! !

!Dictionary methodsFor: '*Seaside-Core' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

!Dictionary methodsFor: '*Seaside-Core' stamp: 'lr 2/16/2007 15:11'!
valuesCollect: aBlock
	| result |
	result := self species new: self size.
	self keysAndValuesDo: [ :key :value |
		result at: key put: (aBlock value: value) ].
	^ result! !

!Exception methodsFor: '*Seaside-Core' stamp: 'lr 6/5/2007 21:42'!
possibleCauses
	^ #()! !

!MessageNotUnderstood methodsFor: '*Seaside-Core' stamp: 'pmm 7/7/2007 18:25'!
possibleCauses
	| causes |
	self receiver isNil ifFalse: [
		^ #('you sent a message this type of object doesn''t understand' )].
	causes := #(
		'the receiver of the message is nil'
		'a class extension hasn''t been loaded correctly'
		'you sent the wrong message' ) asOrderedCollection.
	self message selector = #contents ifTrue: [
		causes addFirst: 'you forgot to send "super initialize" in a initialize method of a component or task' ].
	^causes! !

Error subclass: #WAComponentsNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WAComponentsNotFoundError methodsFor: 'accessing' stamp: 'pmm 7/11/2007 22:19'!
possibleCauses
	^#(
		'you do not implement #children correctly'
		'you do not backtrack #children correctly'
		'you do not implement #states correctly'
	)! !
WACachedDocument initialize!
WAGlobalConfiguration initialize!
WAHtmlEncoder initialize!
WAUrlEncoder initialize!
WAFileLibrary initialize!
WAFileHandler initialize!
